/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
import { ResourceTextEdit } from '../../../browser/services/bulkEditService.js';
export function createCombinedWorkspaceEdit(uri, ranges, edit) {
    var _a, _b;
    return {
        edits: [
            ...ranges.map(range => new ResourceTextEdit(uri, typeof edit.insertText === 'string'
                ? { range, text: edit.insertText, insertAsSnippet: false }
                : { range, text: edit.insertText.snippet, insertAsSnippet: true })),
            ...((_b = (_a = edit.additionalEdit) === null || _a === void 0 ? void 0 : _a.edits) !== null && _b !== void 0 ? _b : [])
        ]
    };
}
export function sortEditsByYieldTo(edits) {
    function yieldsTo(yTo, other) {
        return ('editId' in yTo && yTo.editId === other.id)
            || ('mimeType' in yTo && yTo.mimeType === other.handledMimeType);
    }
    edits.sort((a, b) => {
        var _a, _b;
        if ((_a = a.yieldTo) === null || _a === void 0 ? void 0 : _a.some(yTo => yieldsTo(yTo, b))) {
            return 1;
        }
        if ((_b = b.yieldTo) === null || _b === void 0 ? void 0 : _b.some(yTo => yieldsTo(yTo, a))) {
            return -1;
        }
        return 0;
    });
}
