/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.42.0-dev-20230808(38e1e3d097f84e336c311d071a9ffb5191d4ffd1)
 * Released under the MIT license
 * https://github.com/microsoft/vscode/blob/main/LICENSE.txt
 *-----------------------------------------------------------*/(function(){var ee=["require","exports","vs/editor/common/core/range","vs/editor/common/core/position","vs/base/common/errors","vs/base/common/strings","vs/editor/common/core/offsetRange","vs/base/common/event","vs/editor/common/diff/algorithms/diffAlgorithm","vs/base/common/assert","vs/base/common/lifecycle","vs/base/common/objects","vs/editor/common/core/lineRange","vs/base/common/platform","vs/base/common/uri","vs/nls","vs/base/common/arrays","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/linesDiffComputer","vs/base/common/cache","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cancellation","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/algorithms/joinSequenceDiffs","vs/editor/common/diff/algorithms/myersDiffAlgorithm","vs/editor/common/diff/algorithms/utils","vs/editor/common/diff/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/smartLinesDiffComputer","vs/editor/common/diff/standardLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls!vs/base/common/worker/simpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],te=function(B){for(var n=[],E=0,M=B.length;E<M;E++)n[E]=ee[B[E]];return n};const Ee=this,Ae=typeof global=="object"?global:{};var fe;(function(B){B.global=Ee;class n{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=n._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof B.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}B.Environment=n})(fe||(fe={}));var fe;(function(B){class n{constructor(o,c,C){this.type=o,this.detail=c,this.timestamp=C}}B.LoaderEvent=n;class E{constructor(o){this._events=[new n(1,"",o)]}record(o,c){this._events.push(new n(o,c,B.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}B.LoaderEventRecorder=E;class M{record(o,c){}getEvents(){return[]}}M.INSTANCE=new M,B.NullLoaderEventRecorder=M})(fe||(fe={}));var fe;(function(B){class n{static fileUriToFilePath(M,i){if(i=decodeURI(i).replace(/%23/g,"#"),M){if(/^file:\/\/\//.test(i))return i.substr(8);if(/^file:\/\//.test(i))return i.substr(5)}else if(/^file:\/\//.test(i))return i.substr(7);return i}static startsWith(M,i){return M.length>=i.length&&M.substr(0,i.length)===i}static endsWith(M,i){return M.length>=i.length&&M.substr(M.length-i.length)===i}static containsQueryString(M){return/^[^\#]*\?/gi.test(M)}static isAbsolutePath(M){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(M)}static forEachProperty(M,i){if(M){let o;for(o in M)M.hasOwnProperty(o)&&i(o,M[o])}}static isEmpty(M){let i=!0;return n.forEachProperty(M,()=>{i=!1}),i}static recursiveClone(M){if(!M||typeof M!="object"||M instanceof RegExp||!Array.isArray(M)&&Object.getPrototypeOf(M)!==Object.prototype)return M;let i=Array.isArray(M)?[]:{};return n.forEachProperty(M,(o,c)=>{c&&typeof c=="object"?i[o]=n.recursiveClone(c):i[o]=c}),i}static generateAnonymousModule(){return"===anonymous"+n.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(M){return n.startsWith(M,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=B.global.performance&&typeof B.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?B.global.performance.now():Date.now()}}n.NEXT_ANONYMOUS_ID=1,n.PERFORMANCE_NOW_PROBED=!1,n.HAS_PERFORMANCE_NOW=!1,B.Utilities=n})(fe||(fe={}));var fe;(function(B){function n(i){if(i instanceof Error)return i;const o=new Error(i.message||String(i)||"Unknown Error");return i.stack&&(o.stack=i.stack),o}B.ensureError=n;class E{static validateConfigurationOptions(o){function c(C){if(C.phase==="loading"){console.error('Loading "'+C.moduleId+'" failed'),console.error(C),console.error("Here are the modules that depend on it:"),console.error(C.neededBy);return}if(C.phase==="factory"){console.error('The factory function of "'+C.moduleId+'" has thrown an exception'),console.error(C),console.error("Here are the modules that depend on it:"),console.error(C.neededBy);return}}if(o=o||{},typeof o.baseUrl!="string"&&(o.baseUrl=""),typeof o.isBuild!="boolean"&&(o.isBuild=!1),typeof o.paths!="object"&&(o.paths={}),typeof o.config!="object"&&(o.config={}),typeof o.catchError>"u"&&(o.catchError=!1),typeof o.recordStats>"u"&&(o.recordStats=!1),typeof o.urlArgs!="string"&&(o.urlArgs=""),typeof o.onError!="function"&&(o.onError=c),Array.isArray(o.ignoreDuplicateModules)||(o.ignoreDuplicateModules=[]),o.baseUrl.length>0&&(B.Utilities.endsWith(o.baseUrl,"/")||(o.baseUrl+="/")),typeof o.cspNonce!="string"&&(o.cspNonce=""),typeof o.preferScriptTags>"u"&&(o.preferScriptTags=!1),o.nodeCachedData&&typeof o.nodeCachedData=="object"&&(typeof o.nodeCachedData.seed!="string"&&(o.nodeCachedData.seed="seed"),(typeof o.nodeCachedData.writeDelay!="number"||o.nodeCachedData.writeDelay<0)&&(o.nodeCachedData.writeDelay=1e3*7),!o.nodeCachedData.path||typeof o.nodeCachedData.path!="string")){const C=n(new Error("INVALID cached data configuration, 'path' MUST be set"));C.phase="configuration",o.onError(C),o.nodeCachedData=void 0}return o}static mergeConfigurationOptions(o=null,c=null){let C=B.Utilities.recursiveClone(c||{});return B.Utilities.forEachProperty(o,(u,s)=>{u==="ignoreDuplicateModules"&&typeof C.ignoreDuplicateModules<"u"?C.ignoreDuplicateModules=C.ignoreDuplicateModules.concat(s):u==="paths"&&typeof C.paths<"u"?B.Utilities.forEachProperty(s,(v,e)=>C.paths[v]=e):u==="config"&&typeof C.config<"u"?B.Utilities.forEachProperty(s,(v,e)=>C.config[v]=e):C[u]=B.Utilities.recursiveClone(s)}),E.validateConfigurationOptions(C)}}B.ConfigurationOptionsUtil=E;class M{constructor(o,c){if(this._env=o,this.options=E.mergeConfigurationOptions(c),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let C=this.options.nodeRequire.main.filename,u=Math.max(C.lastIndexOf("/"),C.lastIndexOf("\\"));this.options.baseUrl=C.substring(0,u+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let o=0;o<this.options.ignoreDuplicateModules.length;o++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[o]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],B.Utilities.forEachProperty(this.options.paths,(o,c)=>{Array.isArray(c)?this.sortedPathsRules.push({from:o,to:c}):this.sortedPathsRules.push({from:o,to:[c]})}),this.sortedPathsRules.sort((o,c)=>c.from.length-o.from.length)}cloneAndMerge(o){return new M(this._env,E.mergeConfigurationOptions(o,this.options))}getOptionsLiteral(){return this.options}_applyPaths(o){let c;for(let C=0,u=this.sortedPathsRules.length;C<u;C++)if(c=this.sortedPathsRules[C],B.Utilities.startsWith(o,c.from)){let s=[];for(let v=0,e=c.to.length;v<e;v++)s.push(c.to[v]+o.substr(c.from.length));return s}return[o]}_addUrlArgsToUrl(o){return B.Utilities.containsQueryString(o)?o+"&"+this.options.urlArgs:o+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(o){return this.options.urlArgs?this._addUrlArgsToUrl(o):o}_addUrlArgsIfNecessaryToUrls(o){if(this.options.urlArgs)for(let c=0,C=o.length;c<C;c++)o[c]=this._addUrlArgsToUrl(o[c]);return o}moduleIdToPaths(o){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(o))return this.isBuild()?["empty:"]:["node|"+o];let c=o,C;if(!B.Utilities.endsWith(c,".js")&&!B.Utilities.isAbsolutePath(c)){C=this._applyPaths(c);for(let u=0,s=C.length;u<s;u++)this.isBuild()&&C[u]==="empty:"||(B.Utilities.isAbsolutePath(C[u])||(C[u]=this.options.baseUrl+C[u]),!B.Utilities.endsWith(C[u],".js")&&!B.Utilities.containsQueryString(C[u])&&(C[u]=C[u]+".js"))}else!B.Utilities.endsWith(c,".js")&&!B.Utilities.containsQueryString(c)&&(c=c+".js"),C=[c];return this._addUrlArgsIfNecessaryToUrls(C)}requireToUrl(o){let c=o;return B.Utilities.isAbsolutePath(c)||(c=this._applyPaths(c)[0],B.Utilities.isAbsolutePath(c)||(c=this.options.baseUrl+c)),this._addUrlArgsIfNecessaryToUrl(c)}isBuild(){return this.options.isBuild}shouldInvokeFactory(o){return!!(!this.options.isBuild||B.Utilities.isAnonymousModule(o)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[o])}isDuplicateMessageIgnoredFor(o){return this.ignoreDuplicateModulesMap.hasOwnProperty(o)}getConfigForModule(o){if(this.options.config)return this.options.config[o]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(o){this.options.onError(o)}}B.Configuration=M})(fe||(fe={}));var fe;(function(B){class n{constructor(s){this._env=s,this._scriptLoader=null,this._callbackMap={}}load(s,v,e,d){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new i;else if(this._env.isElectronRenderer){const{preferScriptTags:f}=s.getConfig().getOptionsLiteral();f?this._scriptLoader=new E:this._scriptLoader=new o(this._env)}else this._env.isNode?this._scriptLoader=new o(this._env):this._scriptLoader=new E;let h={callback:e,errorback:d};if(this._callbackMap.hasOwnProperty(v)){this._callbackMap[v].push(h);return}this._callbackMap[v]=[h],this._scriptLoader.load(s,v,()=>this.triggerCallback(v),f=>this.triggerErrorback(v,f))}triggerCallback(s){let v=this._callbackMap[s];delete this._callbackMap[s];for(let e=0;e<v.length;e++)v[e].callback()}triggerErrorback(s,v){let e=this._callbackMap[s];delete this._callbackMap[s];for(let d=0;d<e.length;d++)e[d].errorback(v)}}class E{attachListeners(s,v,e){let d=()=>{s.removeEventListener("load",h),s.removeEventListener("error",f)},h=w=>{d(),v()},f=w=>{d(),e(w)};s.addEventListener("load",h),s.addEventListener("error",f)}load(s,v,e,d){if(/^node\|/.test(v)){let h=s.getConfig().getOptionsLiteral(),f=c(s.getRecorder(),h.nodeRequire||B.global.nodeRequire),w=v.split("|"),p=null;try{p=f(w[1])}catch(y){d(y);return}s.enqueueDefineAnonymousModule([],()=>p),e()}else{let h=document.createElement("script");h.setAttribute("async","async"),h.setAttribute("type","text/javascript"),this.attachListeners(h,e,d);const{trustedTypesPolicy:f}=s.getConfig().getOptionsLiteral();f&&(v=f.createScriptURL(v)),h.setAttribute("src",v);const{cspNonce:w}=s.getConfig().getOptionsLiteral();w&&h.setAttribute("nonce",w),document.getElementsByTagName("head")[0].appendChild(h)}}}function M(u){const{trustedTypesPolicy:s}=u.getConfig().getOptionsLiteral();try{return(s?self.eval(s.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class i{constructor(){this._cachedCanUseEval=null}_canUseEval(s){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=M(s)),this._cachedCanUseEval}load(s,v,e,d){if(/^node\|/.test(v)){const h=s.getConfig().getOptionsLiteral(),f=c(s.getRecorder(),h.nodeRequire||B.global.nodeRequire),w=v.split("|");let p=null;try{p=f(w[1])}catch(y){d(y);return}s.enqueueDefineAnonymousModule([],function(){return p}),e()}else{const{trustedTypesPolicy:h}=s.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(v)&&v.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(s)){fetch(v).then(w=>{if(w.status!==200)throw new Error(w.statusText);return w.text()}).then(w=>{w=`${w}
//# sourceURL=${v}`,(h?self.eval(h.createScript("",w)):new Function(w)).call(self),e()}).then(void 0,d);return}try{h&&(v=h.createScriptURL(v)),importScripts(v),e()}catch(w){d(w)}}}}class o{constructor(s){this._env=s,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(s){this._didInitialize||(this._didInitialize=!0,this._fs=s("fs"),this._vm=s("vm"),this._path=s("path"),this._crypto=s("crypto"))}_initNodeRequire(s,v){const{nodeCachedData:e}=v.getConfig().getOptionsLiteral();if(!e||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const d=this,h=s("module");function f(w){const p=w.constructor;let y=function(N){try{return w.require(N)}finally{}};return y.resolve=function(N,S){return p._resolveFilename(N,w,!1,S)},y.resolve.paths=function(N){return p._resolveLookupPaths(N,w)},y.main=process.mainModule,y.extensions=p._extensions,y.cache=p._cache,y}h.prototype._compile=function(w,p){const y=h.wrap(w.replace(/^#!.*/,"")),m=v.getRecorder(),N=d._getCachedDataPath(e,p),S={filename:p};let _;try{const A=d._fs.readFileSync(N);_=A.slice(0,16),S.cachedData=A.slice(16),m.record(60,N)}catch{m.record(61,N)}const r=new d._vm.Script(y,S),a=r.runInThisContext(S),l=d._path.dirname(p),b=f(this),g=[this.exports,b,this,p,l,process,Ae,Buffer],L=a.apply(this.exports,g);return d._handleCachedData(r,y,N,!S.cachedData,v),d._verifyCachedData(r,y,N,_,v),L}}load(s,v,e,d){const h=s.getConfig().getOptionsLiteral(),f=c(s.getRecorder(),h.nodeRequire||B.global.nodeRequire),w=h.nodeInstrumenter||function(y){return y};this._init(f),this._initNodeRequire(f,s);let p=s.getRecorder();if(/^node\|/.test(v)){let y=v.split("|"),m=null;try{m=f(y[1])}catch(N){d(N);return}s.enqueueDefineAnonymousModule([],()=>m),e()}else{v=B.Utilities.fileUriToFilePath(this._env.isWindows,v);const y=this._path.normalize(v),m=this._getElectronRendererScriptPathOrUri(y),N=!!h.nodeCachedData,S=N?this._getCachedDataPath(h.nodeCachedData,v):void 0;this._readSourceAndCachedData(y,S,p,(_,r,a,l)=>{if(_){d(_);return}let b;r.charCodeAt(0)===o._BOM?b=o._PREFIX+r.substring(1)+o._SUFFIX:b=o._PREFIX+r+o._SUFFIX,b=w(b,y);const g={filename:m,cachedData:a},L=this._createAndEvalScript(s,b,g,e,d);this._handleCachedData(L,b,S,N&&!a,s),this._verifyCachedData(L,b,S,l,s)})}}_createAndEvalScript(s,v,e,d,h){const f=s.getRecorder();f.record(31,e.filename);const w=new this._vm.Script(v,e),p=w.runInThisContext(e),y=s.getGlobalAMDDefineFunc();let m=!1;const N=function(){return m=!0,y.apply(null,arguments)};return N.amd=y.amd,p.call(B.global,s.getGlobalAMDRequireFunc(),N,e.filename,this._path.dirname(e.filename)),f.record(32,e.filename),m?d():h(new Error(`Didn't receive define call in ${e.filename}!`)),w}_getElectronRendererScriptPathOrUri(s){if(!this._env.isElectronRenderer)return s;let v=s.match(/^([a-z])\:(.*)/i);return v?`file:///${(v[1].toUpperCase()+":"+v[2]).replace(/\\/g,"/")}`:`file://${s}`}_getCachedDataPath(s,v){const e=this._crypto.createHash("md5").update(v,"utf8").update(s.seed,"utf8").update(process.arch,"").digest("hex"),d=this._path.basename(v).replace(/\.js$/,"");return this._path.join(s.path,`${d}-${e}.code`)}_handleCachedData(s,v,e,d,h){s.cachedDataRejected?this._fs.unlink(e,f=>{h.getRecorder().record(62,e),this._createAndWriteCachedData(s,v,e,h),f&&h.getConfig().onError(f)}):d&&this._createAndWriteCachedData(s,v,e,h)}_createAndWriteCachedData(s,v,e,d){let h=Math.ceil(d.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),f=-1,w=0,p;const y=()=>{setTimeout(()=>{p||(p=this._crypto.createHash("md5").update(v,"utf8").digest());const m=s.createCachedData();if(!(m.length===0||m.length===f||w>=5)){if(m.length<f){y();return}f=m.length,this._fs.writeFile(e,Buffer.concat([p,m]),N=>{N&&d.getConfig().onError(N),d.getRecorder().record(63,e),y()})}},h*Math.pow(4,w++))};y()}_readSourceAndCachedData(s,v,e,d){if(!v)this._fs.readFile(s,{encoding:"utf8"},d);else{let h,f,w,p=2;const y=m=>{m?d(m):--p===0&&d(void 0,h,f,w)};this._fs.readFile(s,{encoding:"utf8"},(m,N)=>{h=N,y(m)}),this._fs.readFile(v,(m,N)=>{!m&&N&&N.length>0?(w=N.slice(0,16),f=N.slice(16),e.record(60,v)):e.record(61,v),y()})}}_verifyCachedData(s,v,e,d,h){d&&(s.cachedDataRejected||setTimeout(()=>{const f=this._crypto.createHash("md5").update(v,"utf8").digest();d.equals(f)||(h.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${e}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(e,w=>{w&&h.getConfig().onError(w)}))},Math.ceil(5e3*(1+Math.random()))))}}o._BOM=65279,o._PREFIX="(function (require, define, __filename, __dirname) { ",o._SUFFIX=`
});`;function c(u,s){if(s.__$__isRecorded)return s;const v=function(d){u.record(33,d);try{return s(d)}finally{u.record(34,d)}};return v.__$__isRecorded=!0,v}B.ensureRecordedNodeRequire=c;function C(u){return new n(u)}B.createScriptLoader=C})(fe||(fe={}));var fe;(function(B){class n{constructor(u){let s=u.lastIndexOf("/");s!==-1?this.fromModulePath=u.substr(0,s+1):this.fromModulePath=""}static _normalizeModuleId(u){let s=u,v;for(v=/\/\.\//;v.test(s);)s=s.replace(v,"/");for(s=s.replace(/^\.\//g,""),v=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;v.test(s);)s=s.replace(v,"/");return s=s.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),s}resolveModule(u){let s=u;return B.Utilities.isAbsolutePath(s)||(B.Utilities.startsWith(s,"./")||B.Utilities.startsWith(s,"../"))&&(s=n._normalizeModuleId(this.fromModulePath+s)),s}}n.ROOT=new n(""),B.ModuleIdResolver=n;class E{constructor(u,s,v,e,d,h){this.id=u,this.strId=s,this.dependencies=v,this._callback=e,this._errorback=d,this.moduleIdResolver=h,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(u,s){try{return{returnedValue:u.apply(B.global,s),producedError:null}}catch(v){return{returnedValue:null,producedError:v}}}static _invokeFactory(u,s,v,e){return u.shouldInvokeFactory(s)?u.shouldCatchError()?this._safeInvokeFunction(v,e):{returnedValue:v.apply(B.global,e),producedError:null}:{returnedValue:null,producedError:null}}complete(u,s,v,e){this._isComplete=!0;let d=null;if(this._callback)if(typeof this._callback=="function"){u.record(21,this.strId);let h=E._invokeFactory(s,this.strId,this._callback,v);d=h.producedError,u.record(22,this.strId),!d&&typeof h.returnedValue<"u"&&(!this.exportsPassedIn||B.Utilities.isEmpty(this.exports))&&(this.exports=h.returnedValue)}else this.exports=this._callback;if(d){let h=B.ensureError(d);h.phase="factory",h.moduleId=this.strId,h.neededBy=e(this.id),this.error=h,s.onError(h)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(u){return this._isComplete=!0,this.error=u,this._errorback?(this._errorback(u),!0):!1}isComplete(){return this._isComplete}}B.Module=E;class M{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(u){let s=this._strModuleIdToIntModuleId.get(u);return typeof s>"u"&&(s=this._nextId++,this._strModuleIdToIntModuleId.set(u,s),this._intModuleIdToStrModuleId[s]=u),s}getStrModuleId(u){return this._intModuleIdToStrModuleId[u]}}class i{constructor(u){this.id=u}}i.EXPORTS=new i(0),i.MODULE=new i(1),i.REQUIRE=new i(2),B.RegularDependency=i;class o{constructor(u,s,v){this.id=u,this.pluginId=s,this.pluginParam=v}}B.PluginDependency=o;class c{constructor(u,s,v,e,d=0){this._env=u,this._scriptLoader=s,this._loaderAvailableTimestamp=d,this._defineFunc=v,this._requireFunc=e,this._moduleIdProvider=new M,this._config=new B.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}reset(){return new c(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(u,s){let v=h=>h.replace(/\\/g,"/"),e=v(u),d=s.split(/\n/);for(let h=0;h<d.length;h++){let f=d[h].match(/(.*):(\d+):(\d+)\)?$/);if(f){let w=f[1],p=f[2],y=f[3],m=Math.max(w.lastIndexOf(" ")+1,w.lastIndexOf("(")+1);if(w=w.substr(m),w=v(w),w===e){let N={line:parseInt(p,10),col:parseInt(y,10)};return N.line===1&&(N.col-=53),N}}}throw new Error("Could not correlate define call site for needle "+u)}getBuildInfo(){if(!this._config.isBuild())return null;let u=[],s=0;for(let v=0,e=this._modules2.length;v<e;v++){let d=this._modules2[v];if(!d)continue;let h=this._buildInfoPath[d.id]||null,f=this._buildInfoDefineStack[d.id]||null,w=this._buildInfoDependencies[d.id];u[s++]={id:d.strId,path:h,defineLocation:h&&f?c._findRelevantLocationInStack(h,f):null,dependencies:w,shim:null,exports:d.exports}}return u}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new B.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=B.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(u,s){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let v=null;this._config.isBuild()&&(v=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:v,dependencies:u,callback:s}}defineModule(u,s,v,e,d,h=new n(u)){let f=this._moduleIdProvider.getModuleId(u);if(this._modules2[f]){this._config.isDuplicateMessageIgnoredFor(u)||console.warn("Duplicate definition of module '"+u+"'");return}let w=new E(f,u,this._normalizeDependencies(s,h),v,e,h);this._modules2[f]=w,this._config.isBuild()&&(this._buildInfoDefineStack[f]=d,this._buildInfoDependencies[f]=(w.dependencies||[]).map(p=>this._moduleIdProvider.getStrModuleId(p.id))),this._resolve(w)}_normalizeDependency(u,s){if(u==="exports")return i.EXPORTS;if(u==="module")return i.MODULE;if(u==="require")return i.REQUIRE;let v=u.indexOf("!");if(v>=0){let e=s.resolveModule(u.substr(0,v)),d=s.resolveModule(u.substr(v+1)),h=this._moduleIdProvider.getModuleId(e+"!"+d),f=this._moduleIdProvider.getModuleId(e);return new o(h,f,d)}return new i(this._moduleIdProvider.getModuleId(s.resolveModule(u)))}_normalizeDependencies(u,s){let v=[],e=0;for(let d=0,h=u.length;d<h;d++)v[e++]=this._normalizeDependency(u[d],s);return v}_relativeRequire(u,s,v,e){if(typeof s=="string")return this.synchronousRequire(s,u);this.defineModule(B.Utilities.generateAnonymousModule(),s,v,e,null,u)}synchronousRequire(u,s=new n(u)){let v=this._normalizeDependency(u,s),e=this._modules2[v.id];if(!e)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+u+"'. This is the first mention of this module!");if(!e.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+u+"'. This module has not been resolved completely yet.");if(e.error)throw e.error;return e.exports}configure(u,s){let v=this._config.shouldRecordStats();s?this._config=new B.Configuration(this._env,u):this._config=this._config.cloneAndMerge(u),this._config.shouldRecordStats()&&!v&&(this._recorder=null)}getConfig(){return this._config}_onLoad(u){if(this._currentAnonymousDefineCall!==null){let s=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(u),s.dependencies,s.callback,null,s.stack)}}_createLoadError(u,s){let v=this._moduleIdProvider.getStrModuleId(u),e=(this._inverseDependencies2[u]||[]).map(h=>this._moduleIdProvider.getStrModuleId(h));const d=B.ensureError(s);return d.phase="loading",d.moduleId=v,d.neededBy=e,d}_onLoadError(u,s){const v=this._createLoadError(u,s);this._modules2[u]||(this._modules2[u]=new E(u,this._moduleIdProvider.getStrModuleId(u),[],()=>{},null,null));let e=[];for(let f=0,w=this._moduleIdProvider.getMaxModuleId();f<w;f++)e[f]=!1;let d=!1,h=[];for(h.push(u),e[u]=!0;h.length>0;){let f=h.shift(),w=this._modules2[f];w&&(d=w.onDependencyError(v)||d);let p=this._inverseDependencies2[f];if(p)for(let y=0,m=p.length;y<m;y++){let N=p[y];e[N]||(h.push(N),e[N]=!0)}}d||this._config.onError(v)}_hasDependencyPath(u,s){let v=this._modules2[u];if(!v)return!1;let e=[];for(let h=0,f=this._moduleIdProvider.getMaxModuleId();h<f;h++)e[h]=!1;let d=[];for(d.push(v),e[u]=!0;d.length>0;){let f=d.shift().dependencies;if(f)for(let w=0,p=f.length;w<p;w++){let y=f[w];if(y.id===s)return!0;let m=this._modules2[y.id];m&&!e[y.id]&&(e[y.id]=!0,d.push(m))}}return!1}_findCyclePath(u,s,v){if(u===s||v===50)return[u];let e=this._modules2[u];if(!e)return null;let d=e.dependencies;if(d)for(let h=0,f=d.length;h<f;h++){let w=this._findCyclePath(d[h].id,s,v+1);if(w!==null)return w.push(u),w}return null}_createRequire(u){let s=(v,e,d)=>this._relativeRequire(u,v,e,d);return s.toUrl=v=>this._config.requireToUrl(u.resolveModule(v)),s.getStats=()=>this.getLoaderEvents(),s.hasDependencyCycle=()=>this._hasDependencyCycle,s.config=(v,e=!1)=>{this.configure(v,e)},s.__$__nodeRequire=B.global.nodeRequire,s}_loadModule(u){if(this._modules2[u]||this._knownModules2[u])return;this._knownModules2[u]=!0;let s=this._moduleIdProvider.getStrModuleId(u),v=this._config.moduleIdToPaths(s),e=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(s.indexOf("/")===-1||e.test(s))&&v.push("node|"+s);let d=-1,h=f=>{if(d++,d>=v.length)this._onLoadError(u,f);else{let w=v[d],p=this.getRecorder();if(this._config.isBuild()&&w==="empty:"){this._buildInfoPath[u]=w,this.defineModule(this._moduleIdProvider.getStrModuleId(u),[],null,null,null),this._onLoad(u);return}p.record(10,w),this._scriptLoader.load(this,w,()=>{this._config.isBuild()&&(this._buildInfoPath[u]=w),p.record(11,w),this._onLoad(u)},y=>{p.record(12,w),h(y)})}};h(null)}_loadPluginDependency(u,s){if(this._modules2[s.id]||this._knownModules2[s.id])return;this._knownModules2[s.id]=!0;let v=e=>{this.defineModule(this._moduleIdProvider.getStrModuleId(s.id),[],e,null,null)};v.error=e=>{this._config.onError(this._createLoadError(s.id,e))},u.load(s.pluginParam,this._createRequire(n.ROOT),v,this._config.getOptionsLiteral())}_resolve(u){let s=u.dependencies;if(s)for(let v=0,e=s.length;v<e;v++){let d=s[v];if(d===i.EXPORTS){u.exportsPassedIn=!0,u.unresolvedDependenciesCount--;continue}if(d===i.MODULE){u.unresolvedDependenciesCount--;continue}if(d===i.REQUIRE){u.unresolvedDependenciesCount--;continue}let h=this._modules2[d.id];if(h&&h.isComplete()){if(h.error){u.onDependencyError(h.error);return}u.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(d.id,u.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(d.id)+"' and '"+this._moduleIdProvider.getStrModuleId(u.id)+"'. The cyclic path follows:");let f=this._findCyclePath(d.id,u.id,0)||[];f.reverse(),f.push(d.id),console.warn(f.map(w=>this._moduleIdProvider.getStrModuleId(w)).join(` => 
`)),u.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[d.id]=this._inverseDependencies2[d.id]||[],this._inverseDependencies2[d.id].push(u.id),d instanceof o){let f=this._modules2[d.pluginId];if(f&&f.isComplete()){this._loadPluginDependency(f.exports,d);continue}let w=this._inversePluginDependencies2.get(d.pluginId);w||(w=[],this._inversePluginDependencies2.set(d.pluginId,w)),w.push(d),this._loadModule(d.pluginId);continue}this._loadModule(d.id)}u.unresolvedDependenciesCount===0&&this._onModuleComplete(u)}_onModuleComplete(u){let s=this.getRecorder();if(u.isComplete())return;let v=u.dependencies,e=[];if(v)for(let w=0,p=v.length;w<p;w++){let y=v[w];if(y===i.EXPORTS){e[w]=u.exports;continue}if(y===i.MODULE){e[w]={id:u.strId,config:()=>this._config.getConfigForModule(u.strId)};continue}if(y===i.REQUIRE){e[w]=this._createRequire(u.moduleIdResolver);continue}let m=this._modules2[y.id];if(m){e[w]=m.exports;continue}e[w]=null}const d=w=>(this._inverseDependencies2[w]||[]).map(p=>this._moduleIdProvider.getStrModuleId(p));u.complete(s,this._config,e,d);let h=this._inverseDependencies2[u.id];if(this._inverseDependencies2[u.id]=null,h)for(let w=0,p=h.length;w<p;w++){let y=h[w],m=this._modules2[y];m.unresolvedDependenciesCount--,m.unresolvedDependenciesCount===0&&this._onModuleComplete(m)}let f=this._inversePluginDependencies2.get(u.id);if(f){this._inversePluginDependencies2.delete(u.id);for(let w=0,p=f.length;w<p;w++)this._loadPluginDependency(u.exports,f[w])}}}B.ModuleManager=c})(fe||(fe={}));var K,fe;(function(B){const n=new B.Environment;let E=null;const M=function(C,u,s){typeof C!="string"&&(s=u,u=C,C=null),(typeof u!="object"||!Array.isArray(u))&&(s=u,u=null),u||(u=["require","exports","module"]),C?E.defineModule(C,u,s,null,null):E.enqueueDefineAnonymousModule(u,s)};M.amd={jQuery:!0};const i=function(C,u=!1){E.configure(C,u)},o=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){i(arguments[0]);return}if(typeof arguments[0]=="string")return E.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){E.defineModule(B.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};o.config=i,o.getConfig=function(){return E.getConfig().getOptionsLiteral()},o.reset=function(){E=E.reset()},o.getBuildInfo=function(){return E.getBuildInfo()},o.getStats=function(){return E.getLoaderEvents()},o.define=M;function c(){if(typeof B.global.require<"u"||typeof require<"u"){const C=B.global.require||require;if(typeof C=="function"&&typeof C.resolve=="function"){const u=B.ensureRecordedNodeRequire(E.getRecorder(),C);B.global.nodeRequire=u,o.nodeRequire=u,o.__$__nodeRequire=u}}n.isNode&&!n.isElectronRenderer&&!n.isElectronNodeIntegrationWebWorker?module.exports=o:(n.isElectronRenderer||(B.global.define=M),B.global.require=o)}B.init=c,(typeof B.global.define!="function"||!B.global.define.amd)&&(E=new B.ModuleManager(n,B.createScriptLoader(n),M,o,B.Utilities.getHighPerformanceTimestamp()),typeof B.global.require<"u"&&typeof B.global.require!="function"&&o.config(B.global.require),K=function(){return M.apply(null,arguments)},K.amd=M.amd,typeof doNotInitLoader>"u"&&c())})(fe||(fe={}));var pe=this&&this.__awaiter||function(B,n,E,M){function i(o){return o instanceof E?o:new E(function(c){c(o)})}return new(E||(E=Promise))(function(o,c){function C(v){try{s(M.next(v))}catch(e){c(e)}}function u(v){try{s(M.throw(v))}catch(e){c(e)}}function s(v){v.done?o(v.value):i(v.value).then(C,u)}s((M=M.apply(B,n||[])).next())})};K(ee[15],te([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.load=n.create=n.setPseudoTranslation=n.getConfiguredDefaultLocale=n.localize=void 0;let E=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const M="i-default";function i(f,w){let p;return w.length===0?p=f:p=f.replace(/\{(\d+)\}/g,(y,m)=>{const N=m[0],S=w[N];let _=y;return typeof S=="string"?_=S:(typeof S=="number"||typeof S=="boolean"||S===void 0||S===null)&&(_=String(S)),_}),E&&(p="\uFF3B"+p.replace(/[aouei]/g,"$&$&")+"\uFF3D"),p}function o(f,w){let p=f[w];return p||(p=f["*"],p)?p:null}function c(f){return f.charAt(f.length-1)==="/"?f:f+"/"}function C(f,w,p){return pe(this,void 0,void 0,function*(){const y=c(f)+c(w)+"vscode/"+c(p),m=yield fetch(y);if(m.ok)return yield m.json();throw new Error(`${m.status} - ${m.statusText}`)})}function u(f){return function(w,p){const y=Array.prototype.slice.call(arguments,2);return i(f[w],y)}}function s(f,w,...p){return i(w,p)}n.localize=s;function v(f){}n.getConfiguredDefaultLocale=v;function e(f){E=f}n.setPseudoTranslation=e;function d(f,w){var p;return{localize:u(w[f]),getConfiguredDefaultLocale:(p=w.getConfiguredDefaultLocale)!==null&&p!==void 0?p:y=>{}}}n.create=d;function h(f,w,p,y){var m;const N=(m=y["vs/nls"])!==null&&m!==void 0?m:{};if(!f||f.length===0)return p({localize:s,getConfiguredDefaultLocale:()=>{var l;return(l=N.availableLanguages)===null||l===void 0?void 0:l["*"]}});const S=N.availableLanguages?o(N.availableLanguages,f):null,_=S===null||S===M;let r=".nls";_||(r=r+"."+S);const a=l=>{Array.isArray(l)?l.localize=u(l):l.localize=u(l[f]),l.getConfiguredDefaultLocale=()=>{var b;return(b=N.availableLanguages)===null||b===void 0?void 0:b["*"]},p(l)};typeof N.loadBundle=="function"?N.loadBundle(f,S,(l,b)=>{l?w([f+".nls"],a):a(b)}):N.translationServiceUrl&&!_?pe(this,void 0,void 0,function*(){var l;try{const b=yield C(N.translationServiceUrl,S,f);return a(b)}catch(b){if(!S.includes("-"))return console.error(b),w([f+".nls"],a);try{const g=S.split("-")[0],L=yield C(N.translationServiceUrl,g,f);return(l=N.availableLanguages)!==null&&l!==void 0||(N.availableLanguages={}),N.availableLanguages["*"]=g,a(L)}catch(g){return console.error(g),w([f+".nls"],a)}}}):w([f+r],a,l=>{if(r===".nls"){console.error("Failed trying to load default language strings",l);return}console.error(`Failed to load message bundle for language ${S}. Falling back to the default language:`,l),w([f+".nls"],a)})}n.load=h}),function(){const B=globalThis.MonacoEnvironment,n=B&&B.baseUrl?B.baseUrl:"../../../";function E(v,e){var d;if(B?.createTrustedTypesPolicy)try{return B.createTrustedTypesPolicy(v,e)}catch(h){console.warn(h);return}try{return(d=self.trustedTypes)===null||d===void 0?void 0:d.createPolicy(v,e)}catch(h){console.warn(h);return}}const M=E("amdLoader",{createScriptURL:v=>v,createScript:(v,...e)=>{const d=e.slice(0,-1).join(","),h=e.pop().toString();return`(function anonymous(${d}) { ${h}
})`}});function i(){try{return(M?globalThis.eval(M.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function o(){return new Promise((v,e)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return v();const d=n+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(d)&&d.substring(0,globalThis.origin.length)!==globalThis.origin)&&i()){fetch(d).then(f=>{if(f.status!==200)throw new Error(f.statusText);return f.text()}).then(f=>{f=`${f}
//# sourceURL=${d}`,(M?globalThis.eval(M.createScript("",f)):new Function(f)).call(globalThis),v()}).then(void 0,e);return}M?importScripts(M.createScriptURL(d)):importScripts(d),v()})}function c(){require.config({baseUrl:n,catchError:!0,trustedTypesPolicy:M,amdModulesPattern:/^vs\//})}function C(v){o().then(()=>{c(),require([v],function(e){setTimeout(function(){const d=e.create((h,f)=>{globalThis.postMessage(h,f)},null);for(globalThis.onmessage=h=>d.onmessage(h.data,h.ports);s.length>0;){const h=s.shift();d.onmessage(h.data,h.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&c();let u=!0;const s=[];globalThis.onmessage=v=>{if(!u){s.push(v);return}u=!1,C(v.data)}}(),K(ee[16],te([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CallbackIterable=n.ArrayQueue=n.findMinBy=n.findLastMaxBy=n.findMaxBy=n.reverseOrder=n.numberComparator=n.compareBy=n.CompareResult=n.splice=n.insertInto=n.mapFind=n.asArray=n.pushMany=n.pushToEnd=n.pushToStart=n.arrayInsert=n.range=n.firstOrDefault=n.findLastIndex=n.findLast=n.distinct=n.isNonEmptyArray=n.isFalsyOrEmpty=n.coalesceInPlace=n.coalesce=n.groupBy=n.quickSelect=n.findFirstInSorted=n.binarySearch2=n.binarySearch=n.removeFastWithoutKeepingOrder=n.equals=n.tail2=n.tail=void 0;function E(D,T=0){return D[D.length-(1+T)]}n.tail=E;function M(D){if(D.length===0)throw new Error("Invalid tail call");return[D.slice(0,D.length-1),D[D.length-1]]}n.tail2=M;function i(D,T,U=(t,j)=>t===j){if(D===T)return!0;if(!D||!T||D.length!==T.length)return!1;for(let t=0,j=D.length;t<j;t++)if(!U(D[t],T[t]))return!1;return!0}n.equals=i;function o(D,T){const U=D.length-1;T<U&&(D[T]=D[U]),D.pop()}n.removeFastWithoutKeepingOrder=o;function c(D,T,U){return C(D.length,t=>U(D[t],T))}n.binarySearch=c;function C(D,T){let U=0,t=D-1;for(;U<=t;){const j=(U+t)/2|0,se=T(j);if(se<0)U=j+1;else if(se>0)t=j-1;else return j}return-(U+1)}n.binarySearch2=C;function u(D,T){let U=0,t=D.length;if(t===0)return 0;for(;U<t;){const j=Math.floor((U+t)/2);T(D[j])?t=j:U=j+1}return U}n.findFirstInSorted=u;function s(D,T,U){if(D=D|0,D>=T.length)throw new TypeError("invalid index");const t=T[Math.floor(T.length*Math.random())],j=[],se=[],ae=[];for(const oe of T){const ge=U(oe,t);ge<0?j.push(oe):ge>0?se.push(oe):ae.push(oe)}return D<j.length?s(D,j,U):D<j.length+ae.length?ae[0]:s(D-(j.length+ae.length),se,U)}n.quickSelect=s;function v(D,T){const U=[];let t;for(const j of D.slice(0).sort(T))!t||T(t[0],j)!==0?(t=[j],U.push(t)):t.push(j);return U}n.groupBy=v;function e(D){return D.filter(T=>!!T)}n.coalesce=e;function d(D){let T=0;for(let U=0;U<D.length;U++)D[U]&&(D[T]=D[U],T+=1);D.length=T}n.coalesceInPlace=d;function h(D){return!Array.isArray(D)||D.length===0}n.isFalsyOrEmpty=h;function f(D){return Array.isArray(D)&&D.length>0}n.isNonEmptyArray=f;function w(D,T=U=>U){const U=new Set;return D.filter(t=>{const j=T(t);return U.has(j)?!1:(U.add(j),!0)})}n.distinct=w;function p(D,T){const U=y(D,T);if(U!==-1)return D[U]}n.findLast=p;function y(D,T){for(let U=D.length-1;U>=0;U--){const t=D[U];if(T(t))return U}return-1}n.findLastIndex=y;function m(D,T){return D.length>0?D[0]:T}n.firstOrDefault=m;function N(D,T){let U=typeof T=="number"?D:0;typeof T=="number"?U=D:(U=0,T=D);const t=[];if(U<=T)for(let j=U;j<T;j++)t.push(j);else for(let j=U;j>T;j--)t.push(j);return t}n.range=N;function S(D,T,U){const t=D.slice(0,T),j=D.slice(T);return t.concat(U,j)}n.arrayInsert=S;function _(D,T){const U=D.indexOf(T);U>-1&&(D.splice(U,1),D.unshift(T))}n.pushToStart=_;function r(D,T){const U=D.indexOf(T);U>-1&&(D.splice(U,1),D.push(T))}n.pushToEnd=r;function a(D,T){for(const U of T)D.push(U)}n.pushMany=a;function l(D){return Array.isArray(D)?D:[D]}n.asArray=l;function b(D,T){for(const U of D){const t=T(U);if(t!==void 0)return t}}n.mapFind=b;function g(D,T,U){const t=A(D,T),j=D.length,se=U.length;D.length=j+se;for(let ae=j-1;ae>=t;ae--)D[ae+se]=D[ae];for(let ae=0;ae<se;ae++)D[ae+t]=U[ae]}n.insertInto=g;function L(D,T,U,t){const j=A(D,T),se=D.splice(j,U);return g(D,j,t),se}n.splice=L;function A(D,T){return T<0?Math.max(T+D.length,0):Math.min(T,D.length)}var R;(function(D){function T(j){return j<0}D.isLessThan=T;function U(j){return j>0}D.isGreaterThan=U;function t(j){return j===0}D.isNeitherLessOrGreaterThan=t,D.greaterThan=1,D.lessThan=-1,D.neitherLessOrGreaterThan=0})(R||(n.CompareResult=R={}));function P(D,T){return(U,t)=>T(D(U),D(t))}n.compareBy=P;const O=(D,T)=>D-T;n.numberComparator=O;function V(D){return(T,U)=>-D(T,U)}n.reverseOrder=V;function x(D,T){if(D.length===0)return;let U=D[0];for(let t=1;t<D.length;t++){const j=D[t];T(j,U)>0&&(U=j)}return U}n.findMaxBy=x;function I(D,T){if(D.length===0)return;let U=D[0];for(let t=1;t<D.length;t++){const j=D[t];T(j,U)>=0&&(U=j)}return U}n.findLastMaxBy=I;function k(D,T){return x(D,(U,t)=>-T(U,t))}n.findMinBy=k;class q{constructor(T){this.items=T,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(T){let U=this.firstIdx;for(;U<this.items.length&&T(this.items[U]);)U++;const t=U===this.firstIdx?null:this.items.slice(this.firstIdx,U);return this.firstIdx=U,t}takeFromEndWhile(T){let U=this.lastIdx;for(;U>=0&&T(this.items[U]);)U--;const t=U===this.lastIdx?null:this.items.slice(U+1,this.lastIdx+1);return this.lastIdx=U,t}peek(){if(this.length!==0)return this.items[this.firstIdx]}dequeue(){const T=this.items[this.firstIdx];return this.firstIdx++,T}takeCount(T){const U=this.items.slice(this.firstIdx,this.firstIdx+T);return this.firstIdx+=T,U}}n.ArrayQueue=q;class z{constructor(T){this.iterate=T}toArray(){const T=[];return this.iterate(U=>(T.push(U),!0)),T}filter(T){return new z(U=>this.iterate(t=>T(t)?U(t):!0))}map(T){return new z(U=>this.iterate(t=>U(T(t))))}findLast(T){let U;return this.iterate(t=>(T(t)&&(U=t),!0)),U}findLastMaxBy(T){let U,t=!0;return this.iterate(j=>((t||R.isGreaterThan(T(j,U)))&&(t=!1,U=j),!0)),U}}n.CallbackIterable=z,z.empty=new z(D=>{})}),K(ee[27],te([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CachedFunction=n.LRUCachedFunction=void 0;class E{constructor(o){this.fn=o,this.lastCache=void 0,this.lastArgKey=void 0}get(o){const c=JSON.stringify(o);return this.lastArgKey!==c&&(this.lastArgKey=c,this.lastCache=this.fn(o)),this.lastCache}}n.LRUCachedFunction=E;class M{get cachedValues(){return this._map}constructor(o){this.fn=o,this._map=new Map}get(o){if(this._map.has(o))return this._map.get(o);const c=this.fn(o);return this._map.set(o,c),c}}n.CachedFunction=M}),K(ee[28],te([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.SetMap=void 0;class E{constructor(){this.map=new Map}add(i,o){let c=this.map.get(i);c||(c=new Set,this.map.set(i,c)),c.add(o)}delete(i,o){const c=this.map.get(i);c&&(c.delete(o),c.size===0&&this.map.delete(i))}forEach(i,o){const c=this.map.get(i);c&&c.forEach(o)}get(i){const o=this.map.get(i);return o||new Set}}n.SetMap=E}),K(ee[29],te([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Color=n.HSVA=n.HSLA=n.RGBA=void 0;function E(C,u){const s=Math.pow(10,u);return Math.round(C*s)/s}class M{constructor(u,s,v,e=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,u))|0,this.g=Math.min(255,Math.max(0,s))|0,this.b=Math.min(255,Math.max(0,v))|0,this.a=E(Math.max(Math.min(1,e),0),3)}static equals(u,s){return u.r===s.r&&u.g===s.g&&u.b===s.b&&u.a===s.a}}n.RGBA=M;class i{constructor(u,s,v,e){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=E(Math.max(Math.min(1,s),0),3),this.l=E(Math.max(Math.min(1,v),0),3),this.a=E(Math.max(Math.min(1,e),0),3)}static equals(u,s){return u.h===s.h&&u.s===s.s&&u.l===s.l&&u.a===s.a}static fromRGBA(u){const s=u.r/255,v=u.g/255,e=u.b/255,d=u.a,h=Math.max(s,v,e),f=Math.min(s,v,e);let w=0,p=0;const y=(f+h)/2,m=h-f;if(m>0){switch(p=Math.min(y<=.5?m/(2*y):m/(2-2*y),1),h){case s:w=(v-e)/m+(v<e?6:0);break;case v:w=(e-s)/m+2;break;case e:w=(s-v)/m+4;break}w*=60,w=Math.round(w)}return new i(w,p,y,d)}static _hue2rgb(u,s,v){return v<0&&(v+=1),v>1&&(v-=1),v<1/6?u+(s-u)*6*v:v<1/2?s:v<2/3?u+(s-u)*(2/3-v)*6:u}static toRGBA(u){const s=u.h/360,{s:v,l:e,a:d}=u;let h,f,w;if(v===0)h=f=w=e;else{const p=e<.5?e*(1+v):e+v-e*v,y=2*e-p;h=i._hue2rgb(y,p,s+1/3),f=i._hue2rgb(y,p,s),w=i._hue2rgb(y,p,s-1/3)}return new M(Math.round(h*255),Math.round(f*255),Math.round(w*255),d)}}n.HSLA=i;class o{constructor(u,s,v,e){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=E(Math.max(Math.min(1,s),0),3),this.v=E(Math.max(Math.min(1,v),0),3),this.a=E(Math.max(Math.min(1,e),0),3)}static equals(u,s){return u.h===s.h&&u.s===s.s&&u.v===s.v&&u.a===s.a}static fromRGBA(u){const s=u.r/255,v=u.g/255,e=u.b/255,d=Math.max(s,v,e),h=Math.min(s,v,e),f=d-h,w=d===0?0:f/d;let p;return f===0?p=0:d===s?p=((v-e)/f%6+6)%6:d===v?p=(e-s)/f+2:p=(s-v)/f+4,new o(Math.round(p*60),w,d,u.a)}static toRGBA(u){const{h:s,s:v,v:e,a:d}=u,h=e*v,f=h*(1-Math.abs(s/60%2-1)),w=e-h;let[p,y,m]=[0,0,0];return s<60?(p=h,y=f):s<120?(p=f,y=h):s<180?(y=h,m=f):s<240?(y=f,m=h):s<300?(p=f,m=h):s<=360&&(p=h,m=f),p=Math.round((p+w)*255),y=Math.round((y+w)*255),m=Math.round((m+w)*255),new M(p,y,m,d)}}n.HSVA=o;class c{static fromHex(u){return c.Format.CSS.parseHex(u)||c.red}static equals(u,s){return!u&&!s?!0:!u||!s?!1:u.equals(s)}get hsla(){return this._hsla?this._hsla:i.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:o.fromRGBA(this.rgba)}constructor(u){if(u)if(u instanceof M)this.rgba=u;else if(u instanceof i)this._hsla=u,this.rgba=i.toRGBA(u);else if(u instanceof o)this._hsva=u,this.rgba=o.toRGBA(u);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(u){return!!u&&M.equals(this.rgba,u.rgba)&&i.equals(this.hsla,u.hsla)&&o.equals(this.hsva,u.hsva)}getRelativeLuminance(){const u=c._relativeLuminanceForComponent(this.rgba.r),s=c._relativeLuminanceForComponent(this.rgba.g),v=c._relativeLuminanceForComponent(this.rgba.b),e=.2126*u+.7152*s+.0722*v;return E(e,4)}static _relativeLuminanceForComponent(u){const s=u/255;return s<=.03928?s/12.92:Math.pow((s+.055)/1.055,2.4)}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(u){const s=this.getRelativeLuminance(),v=u.getRelativeLuminance();return s>v}isDarkerThan(u){const s=this.getRelativeLuminance(),v=u.getRelativeLuminance();return s<v}lighten(u){return new c(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*u,this.hsla.a))}darken(u){return new c(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*u,this.hsla.a))}transparent(u){const{r:s,g:v,b:e,a:d}=this.rgba;return new c(new M(s,v,e,d*u))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new c(new M(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}makeOpaque(u){if(this.isOpaque()||u.rgba.a!==1)return this;const{r:s,g:v,b:e,a:d}=this.rgba;return new c(new M(u.rgba.r-d*(u.rgba.r-s),u.rgba.g-d*(u.rgba.g-v),u.rgba.b-d*(u.rgba.b-e),1))}toString(){return this._toString||(this._toString=c.Format.CSS.format(this)),this._toString}static getLighterColor(u,s,v){if(u.isLighterThan(s))return u;v=v||.5;const e=u.getRelativeLuminance(),d=s.getRelativeLuminance();return v=v*(d-e)/d,u.lighten(v)}static getDarkerColor(u,s,v){if(u.isDarkerThan(s))return u;v=v||.5;const e=u.getRelativeLuminance(),d=s.getRelativeLuminance();return v=v*(e-d)/e,u.darken(v)}}n.Color=c,c.white=new c(new M(255,255,255,1)),c.black=new c(new M(0,0,0,1)),c.red=new c(new M(255,0,0,1)),c.blue=new c(new M(0,0,255,1)),c.green=new c(new M(0,255,0,1)),c.cyan=new c(new M(0,255,255,1)),c.lightgrey=new c(new M(211,211,211,1)),c.transparent=new c(new M(0,0,0,0)),function(C){let u;(function(s){let v;(function(e){function d(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:C.Format.CSS.formatRGBA(r)}e.formatRGB=d;function h(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}e.formatRGBA=h;function f(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:C.Format.CSS.formatHSLA(r)}e.formatHSL=f;function w(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}e.formatHSLA=w;function p(r){const a=r.toString(16);return a.length!==2?"0"+a:a}function y(r){return`#${p(r.rgba.r)}${p(r.rgba.g)}${p(r.rgba.b)}`}e.formatHex=y;function m(r,a=!1){return a&&r.rgba.a===1?C.Format.CSS.formatHex(r):`#${p(r.rgba.r)}${p(r.rgba.g)}${p(r.rgba.b)}${p(Math.round(r.rgba.a*255))}`}e.formatHexA=m;function N(r){return r.isOpaque()?C.Format.CSS.formatHex(r):C.Format.CSS.formatRGBA(r)}e.format=N;function S(r){const a=r.length;if(a===0||r.charCodeAt(0)!==35)return null;if(a===7){const l=16*_(r.charCodeAt(1))+_(r.charCodeAt(2)),b=16*_(r.charCodeAt(3))+_(r.charCodeAt(4)),g=16*_(r.charCodeAt(5))+_(r.charCodeAt(6));return new C(new M(l,b,g,1))}if(a===9){const l=16*_(r.charCodeAt(1))+_(r.charCodeAt(2)),b=16*_(r.charCodeAt(3))+_(r.charCodeAt(4)),g=16*_(r.charCodeAt(5))+_(r.charCodeAt(6)),L=16*_(r.charCodeAt(7))+_(r.charCodeAt(8));return new C(new M(l,b,g,L/255))}if(a===4){const l=_(r.charCodeAt(1)),b=_(r.charCodeAt(2)),g=_(r.charCodeAt(3));return new C(new M(16*l+l,16*b+b,16*g+g))}if(a===5){const l=_(r.charCodeAt(1)),b=_(r.charCodeAt(2)),g=_(r.charCodeAt(3)),L=_(r.charCodeAt(4));return new C(new M(16*l+l,16*b+b,16*g+g,(16*L+L)/255))}return null}e.parseHex=S;function _(r){switch(r){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(v=s.CSS||(s.CSS={}))})(u=C.Format||(C.Format={}))}(c||(n.Color=c={}))}),K(ee[30],te([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffChange=void 0;class E{constructor(i,o,c,C){this.originalStart=i,this.originalLength=o,this.modifiedStart=c,this.modifiedLength=C}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}n.DiffChange=E}),K(ee[4],te([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BugIndicatingError=n.ErrorNoTelemetry=n.NotSupportedError=n.illegalState=n.illegalArgument=n.canceled=n.CancellationError=n.isCancellationError=n.transformErrorForSerialization=n.onUnexpectedExternalError=n.onUnexpectedError=n.errorHandler=n.ErrorHandler=void 0;class E{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(p){setTimeout(()=>{throw p.stack?h.isErrorNoTelemetry(p)?new h(p.message+`

`+p.stack):new Error(p.message+`

`+p.stack):p},0)}}emit(p){this.listeners.forEach(y=>{y(p)})}onUnexpectedError(p){this.unexpectedErrorHandler(p),this.emit(p)}onUnexpectedExternalError(p){this.unexpectedErrorHandler(p)}}n.ErrorHandler=E,n.errorHandler=new E;function M(w){C(w)||n.errorHandler.onUnexpectedError(w)}n.onUnexpectedError=M;function i(w){C(w)||n.errorHandler.onUnexpectedExternalError(w)}n.onUnexpectedExternalError=i;function o(w){if(w instanceof Error){const{name:p,message:y}=w,m=w.stacktrace||w.stack;return{$isError:!0,name:p,message:y,stack:m,noTelemetry:h.isErrorNoTelemetry(w)}}return w}n.transformErrorForSerialization=o;const c="Canceled";function C(w){return w instanceof u?!0:w instanceof Error&&w.name===c&&w.message===c}n.isCancellationError=C;class u extends Error{constructor(){super(c),this.name=this.message}}n.CancellationError=u;function s(){const w=new Error(c);return w.name=w.message,w}n.canceled=s;function v(w){return w?new Error(`Illegal argument: ${w}`):new Error("Illegal argument")}n.illegalArgument=v;function e(w){return w?new Error(`Illegal state: ${w}`):new Error("Illegal state")}n.illegalState=e;class d extends Error{constructor(p){super("NotSupported"),p&&(this.message=p)}}n.NotSupportedError=d;class h extends Error{constructor(p){super(p),this.name="CodeExpectedError"}static fromError(p){if(p instanceof h)return p;const y=new h;return y.message=p.message,y.stack=p.stack,y}static isErrorNoTelemetry(p){return p.name==="CodeExpectedError"}}n.ErrorNoTelemetry=h;class f extends Error{constructor(p){super(p||"An unexpected bug occurred."),Object.setPrototypeOf(this,f.prototype)}}n.BugIndicatingError=f}),K(ee[9],te([0,1,4]),function(B,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.checkAdjacentItems=n.assertFn=n.assertNever=n.ok=void 0;function M(C,u){if(!C)throw new Error(u?`Assertion failed (${u})`:"Assertion Failed")}n.ok=M;function i(C,u="Unreachable"){throw new Error(u)}n.assertNever=i;function o(C){if(!C()){debugger;C(),(0,E.onUnexpectedError)(new E.BugIndicatingError("Assertion Failed"))}}n.assertFn=o;function c(C,u){let s=0;for(;s<C.length-1;){const v=C[s],e=C[s+1];if(!u(v,e))return!1;s++}return!0}n.checkAdjacentItems=c}),K(ee[17],te([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.once=void 0;function E(M){const i=this;let o=!1,c;return function(){return o||(o=!0,c=M.apply(i,arguments)),c}}n.once=E}),K(ee[18],te([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Iterable=void 0;var E;(function(M){function i(S){return S&&typeof S=="object"&&typeof S[Symbol.iterator]=="function"}M.is=i;const o=Object.freeze([]);function c(){return o}M.empty=c;function*C(S){yield S}M.single=C;function u(S){return i(S)?S:C(S)}M.wrap=u;function s(S){return S||o}M.from=s;function v(S){return!S||S[Symbol.iterator]().next().done===!0}M.isEmpty=v;function e(S){return S[Symbol.iterator]().next().value}M.first=e;function d(S,_){for(const r of S)if(_(r))return!0;return!1}M.some=d;function h(S,_){for(const r of S)if(_(r))return r}M.find=h;function*f(S,_){for(const r of S)_(r)&&(yield r)}M.filter=f;function*w(S,_){let r=0;for(const a of S)yield _(a,r++)}M.map=w;function*p(...S){for(const _ of S)for(const r of _)yield r}M.concat=p;function y(S,_,r){let a=r;for(const l of S)a=_(a,l);return a}M.reduce=y;function*m(S,_,r=S.length){for(_<0&&(_+=S.length),r<0?r+=S.length:r>S.length&&(r=S.length);_<r;_++)yield S[_]}M.slice=m;function N(S,_=Number.POSITIVE_INFINITY){const r=[];if(_===0)return[r,S];const a=S[Symbol.iterator]();for(let l=0;l<_;l++){const b=a.next();if(b.done)return[r,M.empty()];r.push(b.value)}return[r,{[Symbol.iterator](){return a}}]}M.consume=N})(E||(n.Iterable=E={}))}),K(ee[31],te([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyChord=n.KeyCodeUtils=n.IMMUTABLE_KEY_CODE_TO_CODE=n.IMMUTABLE_CODE_TO_KEY_CODE=n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=n.EVENT_KEY_CODE_MAP=void 0;class E{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(d,h){this._keyCodeToStr[d]=h,this._strToKeyCode[h.toLowerCase()]=d}keyCodeToStr(d){return this._keyCodeToStr[d]}strToKeyCode(d){return this._strToKeyCode[d.toLowerCase()]||0}}const M=new E,i=new E,o=new E;n.EVENT_KEY_CODE_MAP=new Array(230),n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const c=[],C=Object.create(null),u=Object.create(null);n.IMMUTABLE_CODE_TO_KEY_CODE=[],n.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)n.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=132;e++)n.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",d=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],h=[],f=[];for(const w of d){const[p,y,m,N,S,_,r,a,l]=w;if(f[y]||(f[y]=!0,c[y]=m,C[m]=y,u[m.toLowerCase()]=y,p&&(n.IMMUTABLE_CODE_TO_KEY_CODE[y]=N,N!==0&&N!==3&&N!==5&&N!==4&&N!==6&&N!==57&&(n.IMMUTABLE_KEY_CODE_TO_CODE[N]=y))),!h[N]){if(h[N]=!0,!S)throw new Error(`String representation missing for key code ${N} around scan code ${m}`);M.define(N,S),i.define(N,a||S),o.define(N,l||a||S)}_&&(n.EVENT_KEY_CODE_MAP[_]=N),r&&(n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[r]=N)}n.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var s;(function(e){function d(m){return M.keyCodeToStr(m)}e.toString=d;function h(m){return M.strToKeyCode(m)}e.fromString=h;function f(m){return i.keyCodeToStr(m)}e.toUserSettingsUS=f;function w(m){return o.keyCodeToStr(m)}e.toUserSettingsGeneral=w;function p(m){return i.strToKeyCode(m)||o.strToKeyCode(m)}e.fromUserSettings=p;function y(m){if(m>=98&&m<=113)return null;switch(m){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return M.keyCodeToStr(m)}e.toElectronAccelerator=y})(s||(n.KeyCodeUtils=s={}));function v(e,d){const h=(d&65535)<<16>>>0;return(e|h)>>>0}n.KeyChord=v}),K(ee[32],te([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Lazy=void 0;class E{constructor(i){this.executor=i,this._didRun=!1}get value(){if(!this._didRun)try{this._value=this.executor()}catch(i){this._error=i}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}n.Lazy=E}),K(ee[10],te([0,1,17,18]),function(B,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DisposableMap=n.ImmortalReference=n.RefCountedDisposable=n.MutableDisposable=n.Disposable=n.DisposableStore=n.toDisposable=n.combinedDisposable=n.dispose=n.isDisposable=n.markAsSingleton=n.setDisposableTracker=void 0;const i=!1;let o=null;function c(r){o=r}if(n.setDisposableTracker=c,i){const r="__is_disposable_tracked__";c(new class{trackDisposable(a){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[r]||console.log(l)},3e3)}setParent(a,l){if(a&&a!==y.None)try{a[r]=!0}catch{}}markAsDisposed(a){if(a&&a!==y.None)try{a[r]=!0}catch{}}markAsSingleton(a){}})}function C(r){return o?.trackDisposable(r),r}function u(r){o?.markAsDisposed(r)}function s(r,a){o?.setParent(r,a)}function v(r,a){if(o)for(const l of r)o.setParent(l,a)}function e(r){return o?.markAsSingleton(r),r}n.markAsSingleton=e;function d(r){return typeof r.dispose=="function"&&r.dispose.length===0}n.isDisposable=d;function h(r){if(M.Iterable.is(r)){const a=[];for(const l of r)if(l)try{l.dispose()}catch(b){a.push(b)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}n.dispose=h;function f(...r){const a=w(()=>h(r));return v(r,a),a}n.combinedDisposable=f;function w(r){const a=C({dispose:(0,E.once)(()=>{u(a),r()})});return a}n.toDisposable=w;class p{constructor(){this._toDispose=new Set,this._isDisposed=!1,C(this)}dispose(){this._isDisposed||(u(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{h(this._toDispose)}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return s(a,this),this._isDisposed?p.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}n.DisposableStore=p,p.DISABLE_DISPOSED_WARNING=!1;class y{constructor(){this._store=new p,C(this),s(this._store,this)}dispose(){u(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}n.Disposable=y,y.None=Object.freeze({dispose(){}});class m{constructor(){this._isDisposed=!1,C(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){var l;this._isDisposed||a===this._value||((l=this._value)===null||l===void 0||l.dispose(),a&&s(a,this),this._value=a)}clear(){this.value=void 0}dispose(){var a;this._isDisposed=!0,u(this),(a=this._value)===null||a===void 0||a.dispose(),this._value=void 0}}n.MutableDisposable=m;class N{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}n.RefCountedDisposable=N;class S{constructor(a){this.object=a}dispose(){}}n.ImmortalReference=S;class _{constructor(){this._store=new Map,this._isDisposed=!1,C(this)}dispose(){u(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{h(this._store.values())}finally{this._store.clear()}}get(a){return this._store.get(a)}set(a,l,b=!1){var g;this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),b||(g=this._store.get(a))===null||g===void 0||g.dispose(),this._store.set(a,l)}deleteAndDispose(a){var l;(l=this._store.get(a))===null||l===void 0||l.dispose(),this._store.delete(a)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}n.DisposableMap=_}),K(ee[19],te([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkedList=void 0;class E{constructor(o){this.element=o,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class M{constructor(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===E.Undefined}clear(){let o=this._first;for(;o!==E.Undefined;){const c=o.next;o.prev=E.Undefined,o.next=E.Undefined,o=c}this._first=E.Undefined,this._last=E.Undefined,this._size=0}unshift(o){return this._insert(o,!1)}push(o){return this._insert(o,!0)}_insert(o,c){const C=new E(o);if(this._first===E.Undefined)this._first=C,this._last=C;else if(c){const s=this._last;this._last=C,C.prev=s,s.next=C}else{const s=this._first;this._first=C,C.next=s,s.prev=C}this._size+=1;let u=!1;return()=>{u||(u=!0,this._remove(C))}}shift(){if(this._first!==E.Undefined){const o=this._first.element;return this._remove(this._first),o}}pop(){if(this._last!==E.Undefined){const o=this._last.element;return this._remove(this._last),o}}_remove(o){if(o.prev!==E.Undefined&&o.next!==E.Undefined){const c=o.prev;c.next=o.next,o.next.prev=c}else o.prev===E.Undefined&&o.next===E.Undefined?(this._first=E.Undefined,this._last=E.Undefined):o.next===E.Undefined?(this._last=this._last.prev,this._last.next=E.Undefined):o.prev===E.Undefined&&(this._first=this._first.next,this._first.prev=E.Undefined);this._size-=1}*[Symbol.iterator](){let o=this._first;for(;o!==E.Undefined;)yield o.element,o=o.next}}n.LinkedList=M}),K(ee[20],te([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StopWatch=void 0;const E=globalThis.performance&&typeof globalThis.performance.now=="function";class M{static create(o){return new M(o)}constructor(o){this._now=E&&o===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}n.StopWatch=M}),K(ee[7],te([0,1,4,17,10,19,20]),function(B,n,E,M,i,o,c){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Relay=n.EventBufferer=n.EventMultiplexer=n.MicrotaskEmitter=n.DebounceEmitter=n.PauseableEmitter=n.createEventDeliveryQueue=n.Emitter=n.EventProfiling=n.Event=void 0;const C=!1,u=!1;var s;(function(g){g.None=()=>i.Disposable.None;function L(Q){if(u){const{onDidAddListener:G}=Q,Y=h.create();let H=0;Q.onDidAddListener=()=>{++H===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Y.print()),G?.()}}}function A(Q,G){return z(Q,()=>{},0,void 0,!0,void 0,G)}g.defer=A;function R(Q){return(G,Y=null,H)=>{let X=!1,Z;return Z=Q(ne=>{if(!X)return Z?Z.dispose():X=!0,G.call(Y,ne)},null,H),X&&Z.dispose(),Z}}g.once=R;function P(Q,G,Y){return q((H,X=null,Z)=>Q(ne=>H.call(X,G(ne)),null,Z),Y)}g.map=P;function O(Q,G,Y){return q((H,X=null,Z)=>Q(ne=>{G(ne),H.call(X,ne)},null,Z),Y)}g.forEach=O;function V(Q,G,Y){return q((H,X=null,Z)=>Q(ne=>G(ne)&&H.call(X,ne),null,Z),Y)}g.filter=V;function x(Q){return Q}g.signal=x;function I(...Q){return(G,Y=null,H)=>(0,i.combinedDisposable)(...Q.map(X=>X(Z=>G.call(Y,Z),null,H)))}g.any=I;function k(Q,G,Y,H){let X=Y;return P(Q,Z=>(X=G(X,Z),X),H)}g.reduce=k;function q(Q,G){let Y;const H={onWillAddFirstListener(){Y=Q(X.fire,X)},onDidRemoveLastListener(){Y?.dispose()}};G||L(H);const X=new y(H);return G?.add(X),X.event}function z(Q,G,Y=100,H=!1,X=!1,Z,ne){let ce,ve,Le,F=0,W;const $={leakWarningThreshold:Z,onWillAddFirstListener(){ce=Q(ie=>{F++,ve=G(ve,ie),H&&!Le&&(J.fire(ve),ve=void 0),W=()=>{const ue=ve;ve=void 0,Le=void 0,(!H||F>1)&&J.fire(ue),F=0},typeof Y=="number"?(clearTimeout(Le),Le=setTimeout(W,Y)):Le===void 0&&(Le=0,queueMicrotask(W))})},onWillRemoveListener(){X&&F>0&&W?.()},onDidRemoveLastListener(){W=void 0,ce.dispose()}};ne||L($);const J=new y($);return ne?.add(J),J.event}g.debounce=z;function D(Q,G=0,Y){return g.debounce(Q,(H,X)=>H?(H.push(X),H):[X],G,void 0,!0,void 0,Y)}g.accumulate=D;function T(Q,G=(H,X)=>H===X,Y){let H=!0,X;return V(Q,Z=>{const ne=H||!G(Z,X);return H=!1,X=Z,ne},Y)}g.latch=T;function U(Q,G,Y){return[g.filter(Q,G,Y),g.filter(Q,H=>!G(H),Y)]}g.split=U;function t(Q,G=!1,Y=[]){let H=Y.slice(),X=Q(ce=>{H?H.push(ce):ne.fire(ce)});const Z=()=>{H?.forEach(ce=>ne.fire(ce)),H=null},ne=new y({onWillAddFirstListener(){X||(X=Q(ce=>ne.fire(ce)))},onDidAddFirstListener(){H&&(G?setTimeout(Z):Z())},onDidRemoveLastListener(){X&&X.dispose(),X=null}});return ne.event}g.buffer=t;class j{constructor(G){this.event=G,this.disposables=new i.DisposableStore}map(G){return new j(P(this.event,G,this.disposables))}forEach(G){return new j(O(this.event,G,this.disposables))}filter(G){return new j(V(this.event,G,this.disposables))}reduce(G,Y){return new j(k(this.event,G,Y,this.disposables))}latch(){return new j(T(this.event,void 0,this.disposables))}debounce(G,Y=100,H=!1,X=!1,Z){return new j(z(this.event,G,Y,H,X,Z,this.disposables))}on(G,Y,H){return this.event(G,Y,H)}once(G,Y,H){return R(this.event)(G,Y,H)}dispose(){this.disposables.dispose()}}function se(Q){return new j(Q)}g.chain=se;function ae(Q,G,Y=H=>H){const H=(...ce)=>ne.fire(Y(...ce)),X=()=>Q.on(G,H),Z=()=>Q.removeListener(G,H),ne=new y({onWillAddFirstListener:X,onDidRemoveLastListener:Z});return ne.event}g.fromNodeEventEmitter=ae;function oe(Q,G,Y=H=>H){const H=(...ce)=>ne.fire(Y(...ce)),X=()=>Q.addEventListener(G,H),Z=()=>Q.removeEventListener(G,H),ne=new y({onWillAddFirstListener:X,onDidRemoveLastListener:Z});return ne.event}g.fromDOMEventEmitter=oe;function ge(Q){return new Promise(G=>R(Q)(G))}g.toPromise=ge;function de(Q,G){return G(void 0),Q(Y=>G(Y))}g.runAndSubscribe=de;function me(Q,G){let Y=null;function H(Z){Y?.dispose(),Y=new i.DisposableStore,G(Z,Y)}H(void 0);const X=Q(Z=>H(Z));return(0,i.toDisposable)(()=>{X.dispose(),Y?.dispose()})}g.runAndSubscribeWithStore=me;class _e{constructor(G,Y){this._observable=G,this._counter=0,this._hasChanged=!1;const H={onWillAddFirstListener:()=>{G.addObserver(this)},onDidRemoveLastListener:()=>{G.removeObserver(this)}};Y||L(H),this.emitter=new y(H),Y&&Y.add(this.emitter)}beginUpdate(G){this._counter++}handlePossibleChange(G){}handleChange(G,Y){this._hasChanged=!0}endUpdate(G){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function re(Q,G){return new _e(Q,G).emitter.event}g.fromObservable=re;function le(Q){return G=>{let Y=0,H=!1;const X={beginUpdate(){Y++},endUpdate(){Y--,Y===0&&(Q.reportChanges(),H&&(H=!1,G()))},handlePossibleChange(){},handleChange(){H=!0}};return Q.addObserver(X),Q.reportChanges(),{dispose(){Q.removeObserver(X)}}}}g.fromObservableLight=le})(s||(n.Event=s={}));class v{constructor(L){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${L}_${v._idPool++}`,v.all.add(this)}start(L){this._stopWatch=new c.StopWatch,this.listenerCount=L}stop(){if(this._stopWatch){const L=this._stopWatch.elapsed();this.durations.push(L),this.elapsedOverall+=L,this.invocationCount+=1,this._stopWatch=void 0}}}n.EventProfiling=v,v.all=new Set,v._idPool=0;let e=-1;class d{constructor(L,A=Math.random().toString(18).slice(2,5)){this.threshold=L,this.name=A,this._warnCountdown=0}dispose(){var L;(L=this._stacks)===null||L===void 0||L.clear()}check(L,A){const R=this.threshold;if(R<=0||A<R)return;this._stacks||(this._stacks=new Map);const P=this._stacks.get(L.value)||0;if(this._stacks.set(L.value,P+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=R*.5;let O,V=0;for(const[x,I]of this._stacks)(!O||V<I)&&(O=x,V=I);console.warn(`[${this.name}] potential listener LEAK detected, having ${A} listeners already. MOST frequent listener (${V}):`),console.warn(O)}return()=>{const O=this._stacks.get(L.value)||0;this._stacks.set(L.value,O-1)}}}class h{static create(){var L;return new h((L=new Error().stack)!==null&&L!==void 0?L:"")}constructor(L){this.value=L}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class f{constructor(L){this.value=L}}const w=2,p=(g,L)=>{if(g instanceof f)L(g);else for(let A=0;A<g.length;A++){const R=g[A];R&&L(R)}};class y{constructor(L){var A,R,P,O,V;this._size=0,this._options=L,this._leakageMon=e>0||!((A=this._options)===null||A===void 0)&&A.leakWarningThreshold?new d((P=(R=this._options)===null||R===void 0?void 0:R.leakWarningThreshold)!==null&&P!==void 0?P:e):void 0,this._perfMon=!((O=this._options)===null||O===void 0)&&O._profName?new v(this._options._profName):void 0,this._deliveryQueue=(V=this._options)===null||V===void 0?void 0:V.deliveryQueue}dispose(){var L,A,R,P;if(!this._disposed){if(this._disposed=!0,((L=this._deliveryQueue)===null||L===void 0?void 0:L.current)===this&&this._deliveryQueue.reset(),this._listeners){if(C){const O=this._listeners;queueMicrotask(()=>{p(O,V=>{var x;return(x=V.stack)===null||x===void 0?void 0:x.print()})})}this._listeners=void 0,this._size=0}(R=(A=this._options)===null||A===void 0?void 0:A.onDidRemoveLastListener)===null||R===void 0||R.call(A),(P=this._leakageMon)===null||P===void 0||P.dispose()}}get event(){var L;return(L=this._event)!==null&&L!==void 0||(this._event=(A,R,P)=>{var O,V,x,I,k;if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.Disposable.None;if(this._disposed)return i.Disposable.None;R&&(A=A.bind(R));const q=new f(A);let z,D;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(q.stack=h.create(),z=this._leakageMon.check(q.stack,this._size+1)),C&&(q.stack=D??h.create()),this._listeners?this._listeners instanceof f?((k=this._deliveryQueue)!==null&&k!==void 0||(this._deliveryQueue=new N),this._listeners=[this._listeners,q]):this._listeners.push(q):((V=(O=this._options)===null||O===void 0?void 0:O.onWillAddFirstListener)===null||V===void 0||V.call(O,this),this._listeners=q,(I=(x=this._options)===null||x===void 0?void 0:x.onDidAddFirstListener)===null||I===void 0||I.call(x,this)),this._size++;const T=(0,i.toDisposable)(()=>{z?.(),this._removeListener(q)});return P instanceof i.DisposableStore?P.add(T):Array.isArray(P)&&P.push(T),T}),this._event}_removeListener(L){var A,R,P,O;if((R=(A=this._options)===null||A===void 0?void 0:A.onWillRemoveListener)===null||R===void 0||R.call(A,this),!this._listeners)return;if(this._size===1){this._listeners=void 0,(O=(P=this._options)===null||P===void 0?void 0:P.onDidRemoveLastListener)===null||O===void 0||O.call(P,this),this._size=0;return}const V=this._listeners,x=V.indexOf(L);if(x===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,V[x]=void 0;const I=this._deliveryQueue.current===this;if(this._size*w<=V.length){let k=0;for(let q=0;q<V.length;q++)V[q]?V[k++]=V[q]:I&&(this._deliveryQueue.end--,k<this._deliveryQueue.i&&this._deliveryQueue.i--);V.length=k}}_deliver(L,A){var R;if(!L)return;const P=((R=this._options)===null||R===void 0?void 0:R.onListenerError)||E.onUnexpectedError;if(!P){L.value(A);return}try{L.value(A)}catch(O){P(O)}}_deliverQueue(L){const A=L.current._listeners;for(;L.i<L.end;)this._deliver(A[L.i++],L.value);L.reset()}fire(L){var A,R,P,O;if(!((A=this._deliveryQueue)===null||A===void 0)&&A.current&&(this._deliverQueue(this._deliveryQueue),(R=this._perfMon)===null||R===void 0||R.stop()),(P=this._perfMon)===null||P===void 0||P.start(this._size),this._listeners)if(this._listeners instanceof f)this._deliver(this._listeners,L);else{const V=this._deliveryQueue;V.enqueue(this,L,this._listeners.length),this._deliverQueue(V)}(O=this._perfMon)===null||O===void 0||O.stop()}hasListeners(){return this._size>0}}n.Emitter=y;const m=()=>new N;n.createEventDeliveryQueue=m;class N{constructor(){this.i=-1,this.end=0}enqueue(L,A,R){this.i=0,this.end=R,this.current=L,this.value=A}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class S extends y{constructor(L){super(L),this._isPaused=0,this._eventQueue=new o.LinkedList,this._mergeFn=L?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const L=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(L))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(L){this._size&&(this._isPaused!==0?this._eventQueue.push(L):super.fire(L))}}n.PauseableEmitter=S;class _ extends S{constructor(L){var A;super(L),this._delay=(A=L.delay)!==null&&A!==void 0?A:100}fire(L){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(L)}}n.DebounceEmitter=_;class r extends y{constructor(L){super(L),this._queuedEvents=[],this._mergeFn=L?.merge}fire(L){this.hasListeners()&&(this._queuedEvents.push(L),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(A=>super.fire(A)),this._queuedEvents=[]}))}}n.MicrotaskEmitter=r;class a{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new y({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(L){const A={event:L,listener:null};this.events.push(A),this.hasListeners&&this.hook(A);const R=()=>{this.hasListeners&&this.unhook(A);const P=this.events.indexOf(A);this.events.splice(P,1)};return(0,i.toDisposable)((0,M.once)(R))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(L=>this.hook(L))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(L=>this.unhook(L))}hook(L){L.listener=L.event(A=>this.emitter.fire(A))}unhook(L){L.listener&&L.listener.dispose(),L.listener=null}dispose(){this.emitter.dispose()}}n.EventMultiplexer=a;class l{constructor(){this.buffers=[]}wrapEvent(L){return(A,R,P)=>L(O=>{const V=this.buffers[this.buffers.length-1];V?V.push(()=>A.call(R,O)):A.call(R,O)},void 0,P)}bufferEvents(L){const A=[];this.buffers.push(A);const R=L();return this.buffers.pop(),A.forEach(P=>P()),R}}n.EventBufferer=l;class b{constructor(){this.listening=!1,this.inputEvent=s.None,this.inputEventListener=i.Disposable.None,this.emitter=new y({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(L){this.inputEvent=L,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=L(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}n.Relay=b}),K(ee[33],te([0,1,7]),function(B,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CancellationTokenSource=n.CancellationToken=void 0;const M=Object.freeze(function(C,u){const s=setTimeout(C.bind(u),0);return{dispose(){clearTimeout(s)}}});var i;(function(C){function u(s){return s===C.None||s===C.Cancelled||s instanceof o?!0:!s||typeof s!="object"?!1:typeof s.isCancellationRequested=="boolean"&&typeof s.onCancellationRequested=="function"}C.isCancellationToken=u,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:M})})(i||(n.CancellationToken=i={}));class o{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?M:(this._emitter||(this._emitter=new E.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class c{constructor(u){this._token=void 0,this._parentListener=void 0,this._parentListener=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new o),this._token}cancel(){this._token?this._token instanceof o&&this._token.cancel():this._token=i.Cancelled}dispose(u=!1){var s;u&&this.cancel(),(s=this._parentListener)===null||s===void 0||s.dispose(),this._token?this._token instanceof o&&this._token.dispose():this._token=i.None}}n.CancellationTokenSource=c}),K(ee[5],te([0,1,27,32]),function(B,n,E,M){"use strict";var i;Object.defineProperty(n,"__esModule",{value:!0}),n.InvisibleCharacters=n.AmbiguousCharacters=n.noBreakWhitespace=n.getLeftDeleteOffset=n.singleLetterHash=n.containsUppercaseCharacter=n.startsWithUTF8BOM=n.UTF8_BOM_CHARACTER=n.isEmojiImprecise=n.isFullWidthCharacter=n.containsUnusualLineTerminators=n.UNUSUAL_LINE_TERMINATORS=n.isBasicASCII=n.containsRTL=n.getCharContainingOffset=n.prevCharLength=n.nextCharLength=n.GraphemeIterator=n.CodePointIterator=n.getNextCodePoint=n.computeCodePoint=n.isLowSurrogate=n.isHighSurrogate=n.commonSuffixLength=n.commonPrefixLength=n.startsWithIgnoreCase=n.equalsIgnoreCase=n.isUpperAsciiLetter=n.isLowerAsciiLetter=n.isAsciiDigit=n.compareSubstringIgnoreCase=n.compareIgnoreCase=n.compareSubstring=n.compare=n.lastNonWhitespaceIndex=n.getLeadingWhitespace=n.firstNonWhitespaceIndex=n.splitLines=n.regExpFlags=n.regExpLeadsToEndlessLoop=n.createRegExp=n.stripWildcards=n.convertSimple2RegExpPattern=n.rtrim=n.ltrim=n.trim=n.escapeRegExpCharacters=n.escape=n.format=n.isFalsyOrWhitespace=void 0;function o(F){return!F||typeof F!="string"?!0:F.trim().length===0}n.isFalsyOrWhitespace=o;const c=/{(\d+)}/g;function C(F,...W){return W.length===0?F:F.replace(c,function($,J){const ie=parseInt(J,10);return isNaN(ie)||ie<0||ie>=W.length?$:W[ie]})}n.format=C;function u(F){return F.replace(/[<>&]/g,function(W){switch(W){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return W}})}n.escape=u;function s(F){return F.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}n.escapeRegExpCharacters=s;function v(F,W=" "){const $=e(F,W);return d($,W)}n.trim=v;function e(F,W){if(!F||!W)return F;const $=W.length;if($===0||F.length===0)return F;let J=0;for(;F.indexOf(W,J)===J;)J=J+$;return F.substring(J)}n.ltrim=e;function d(F,W){if(!F||!W)return F;const $=W.length,J=F.length;if($===0||J===0)return F;let ie=J,ue=-1;for(;ue=F.lastIndexOf(W,ie-1),!(ue===-1||ue+$!==ie);){if(ue===0)return"";ie=ue}return F.substring(0,ie)}n.rtrim=d;function h(F){return F.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}n.convertSimple2RegExpPattern=h;function f(F){return F.replace(/\*/g,"")}n.stripWildcards=f;function w(F,W,$={}){if(!F)throw new Error("Cannot create regex from empty string");W||(F=s(F)),$.wholeWord&&(/\B/.test(F.charAt(0))||(F="\\b"+F),/\B/.test(F.charAt(F.length-1))||(F=F+"\\b"));let J="";return $.global&&(J+="g"),$.matchCase||(J+="i"),$.multiline&&(J+="m"),$.unicode&&(J+="u"),new RegExp(F,J)}n.createRegExp=w;function p(F){return F.source==="^"||F.source==="^$"||F.source==="$"||F.source==="^\\s*$"?!1:!!(F.exec("")&&F.lastIndex===0)}n.regExpLeadsToEndlessLoop=p;function y(F){return(F.global?"g":"")+(F.ignoreCase?"i":"")+(F.multiline?"m":"")+(F.unicode?"u":"")}n.regExpFlags=y;function m(F){return F.split(/\r\n|\r|\n/)}n.splitLines=m;function N(F){for(let W=0,$=F.length;W<$;W++){const J=F.charCodeAt(W);if(J!==32&&J!==9)return W}return-1}n.firstNonWhitespaceIndex=N;function S(F,W=0,$=F.length){for(let J=W;J<$;J++){const ie=F.charCodeAt(J);if(ie!==32&&ie!==9)return F.substring(W,J)}return F.substring(W,$)}n.getLeadingWhitespace=S;function _(F,W=F.length-1){for(let $=W;$>=0;$--){const J=F.charCodeAt($);if(J!==32&&J!==9)return $}return-1}n.lastNonWhitespaceIndex=_;function r(F,W){return F<W?-1:F>W?1:0}n.compare=r;function a(F,W,$=0,J=F.length,ie=0,ue=W.length){for(;$<J&&ie<ue;$++,ie++){const Ce=F.charCodeAt($),he=W.charCodeAt(ie);if(Ce<he)return-1;if(Ce>he)return 1}const be=J-$,ye=ue-ie;return be<ye?-1:be>ye?1:0}n.compareSubstring=a;function l(F,W){return b(F,W,0,F.length,0,W.length)}n.compareIgnoreCase=l;function b(F,W,$=0,J=F.length,ie=0,ue=W.length){for(;$<J&&ie<ue;$++,ie++){let Ce=F.charCodeAt($),he=W.charCodeAt(ie);if(Ce===he)continue;if(Ce>=128||he>=128)return a(F.toLowerCase(),W.toLowerCase(),$,J,ie,ue);L(Ce)&&(Ce-=32),L(he)&&(he-=32);const we=Ce-he;if(we!==0)return we}const be=J-$,ye=ue-ie;return be<ye?-1:be>ye?1:0}n.compareSubstringIgnoreCase=b;function g(F){return F>=48&&F<=57}n.isAsciiDigit=g;function L(F){return F>=97&&F<=122}n.isLowerAsciiLetter=L;function A(F){return F>=65&&F<=90}n.isUpperAsciiLetter=A;function R(F,W){return F.length===W.length&&b(F,W)===0}n.equalsIgnoreCase=R;function P(F,W){const $=W.length;return W.length>F.length?!1:b(F,W,0,$)===0}n.startsWithIgnoreCase=P;function O(F,W){const $=Math.min(F.length,W.length);let J;for(J=0;J<$;J++)if(F.charCodeAt(J)!==W.charCodeAt(J))return J;return $}n.commonPrefixLength=O;function V(F,W){const $=Math.min(F.length,W.length);let J;const ie=F.length-1,ue=W.length-1;for(J=0;J<$;J++)if(F.charCodeAt(ie-J)!==W.charCodeAt(ue-J))return J;return $}n.commonSuffixLength=V;function x(F){return 55296<=F&&F<=56319}n.isHighSurrogate=x;function I(F){return 56320<=F&&F<=57343}n.isLowSurrogate=I;function k(F,W){return(F-55296<<10)+(W-56320)+65536}n.computeCodePoint=k;function q(F,W,$){const J=F.charCodeAt($);if(x(J)&&$+1<W){const ie=F.charCodeAt($+1);if(I(ie))return k(J,ie)}return J}n.getNextCodePoint=q;function z(F,W){const $=F.charCodeAt(W-1);if(I($)&&W>1){const J=F.charCodeAt(W-2);if(x(J))return k(J,$)}return $}class D{get offset(){return this._offset}constructor(W,$=0){this._str=W,this._len=W.length,this._offset=$}setOffset(W){this._offset=W}prevCodePoint(){const W=z(this._str,this._offset);return this._offset-=W>=65536?2:1,W}nextCodePoint(){const W=q(this._str,this._len,this._offset);return this._offset+=W>=65536?2:1,W}eol(){return this._offset>=this._len}}n.CodePointIterator=D;class T{get offset(){return this._iterator.offset}constructor(W,$=0){this._iterator=new D(W,$)}nextGraphemeLength(){const W=H.getInstance(),$=this._iterator,J=$.offset;let ie=W.getGraphemeBreakType($.nextCodePoint());for(;!$.eol();){const ue=$.offset,be=W.getGraphemeBreakType($.nextCodePoint());if(Y(ie,be)){$.setOffset(ue);break}ie=be}return $.offset-J}prevGraphemeLength(){const W=H.getInstance(),$=this._iterator,J=$.offset;let ie=W.getGraphemeBreakType($.prevCodePoint());for(;$.offset>0;){const ue=$.offset,be=W.getGraphemeBreakType($.prevCodePoint());if(Y(be,ie)){$.setOffset(ue);break}ie=be}return J-$.offset}eol(){return this._iterator.eol()}}n.GraphemeIterator=T;function U(F,W){return new T(F,W).nextGraphemeLength()}n.nextCharLength=U;function t(F,W){return new T(F,W).prevGraphemeLength()}n.prevCharLength=t;function j(F,W){W>0&&I(F.charCodeAt(W))&&W--;const $=W+U(F,W);return[$-t(F,$),$]}n.getCharContainingOffset=j;let se;function ae(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function oe(F){return se||(se=ae()),se.test(F)}n.containsRTL=oe;const ge=/^[\t\n\r\x20-\x7E]*$/;function de(F){return ge.test(F)}n.isBasicASCII=de,n.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function me(F){return n.UNUSUAL_LINE_TERMINATORS.test(F)}n.containsUnusualLineTerminators=me;function _e(F){return F>=11904&&F<=55215||F>=63744&&F<=64255||F>=65281&&F<=65374}n.isFullWidthCharacter=_e;function re(F){return F>=127462&&F<=127487||F===8986||F===8987||F===9200||F===9203||F>=9728&&F<=10175||F===11088||F===11093||F>=127744&&F<=128591||F>=128640&&F<=128764||F>=128992&&F<=129008||F>=129280&&F<=129535||F>=129648&&F<=129782}n.isEmojiImprecise=re,n.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function le(F){return!!(F&&F.length>0&&F.charCodeAt(0)===65279)}n.startsWithUTF8BOM=le;function Q(F,W=!1){return F?(W&&(F=F.replace(/\\./g,"")),F.toLowerCase()!==F):!1}n.containsUppercaseCharacter=Q;function G(F){return F=F%(2*26),F<26?String.fromCharCode(97+F):String.fromCharCode(65+F-26)}n.singleLetterHash=G;function Y(F,W){return F===0?W!==5&&W!==7:F===2&&W===3?!1:F===4||F===2||F===3||W===4||W===2||W===3?!0:!(F===8&&(W===8||W===9||W===11||W===12)||(F===11||F===9)&&(W===9||W===10)||(F===12||F===10)&&W===10||W===5||W===13||W===7||F===1||F===13&&W===14||F===6&&W===6)}class H{static getInstance(){return H._INSTANCE||(H._INSTANCE=new H),H._INSTANCE}constructor(){this._data=X()}getGraphemeBreakType(W){if(W<32)return W===10?3:W===13?2:4;if(W<127)return 0;const $=this._data,J=$.length/3;let ie=1;for(;ie<=J;)if(W<$[3*ie])ie=2*ie;else if(W>$[3*ie+1])ie=2*ie+1;else return $[3*ie+2];return 0}}H._INSTANCE=null;function X(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Z(F,W){if(F===0)return 0;const $=ne(F,W);if($!==void 0)return $;const J=new D(W,F);return J.prevCodePoint(),J.offset}n.getLeftDeleteOffset=Z;function ne(F,W){const $=new D(W,F);let J=$.prevCodePoint();for(;ce(J)||J===65039||J===8419;){if($.offset===0)return;J=$.prevCodePoint()}if(!re(J))return;let ie=$.offset;return ie>0&&$.prevCodePoint()===8205&&(ie=$.offset),ie}function ce(F){return 127995<=F&&F<=127999}n.noBreakWhitespace="\xA0";class ve{static getInstance(W){return i.cache.get(Array.from(W))}static getLocales(){return i._locales.value}constructor(W){this.confusableDictionary=W}isAmbiguous(W){return this.confusableDictionary.has(W)}getPrimaryConfusable(W){return this.confusableDictionary.get(W)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}n.AmbiguousCharacters=ve,i=ve,ve.ambiguousCharacterData=new M.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ve.cache=new E.LRUCachedFunction(F=>{function W(he){const we=new Map;for(let Se=0;Se<he.length;Se+=2)we.set(he[Se],he[Se+1]);return we}function $(he,we){const Se=new Map(he);for(const[Ne,Re]of we)Se.set(Ne,Re);return Se}function J(he,we){if(!he)return we;const Se=new Map;for(const[Ne,Re]of he)we.has(Ne)&&Se.set(Ne,Re);return Se}const ie=i.ambiguousCharacterData.value;let ue=F.filter(he=>!he.startsWith("_")&&he in ie);ue.length===0&&(ue=["_default"]);let be;for(const he of ue){const we=W(ie[he]);be=J(be,we)}const ye=W(ie._common),Ce=$(ye,be);return new i(Ce)}),ve._locales=new M.Lazy(()=>Object.keys(i.ambiguousCharacterData.value).filter(F=>!F.startsWith("_")));class Le{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Le.getRawData())),this._data}static isInvisibleCharacter(W){return Le.getData().has(W)}static get codePoints(){return Le.getData()}}n.InvisibleCharacters=Le,Le._data=void 0}),K(ee[34],te([0,1,5]),function(B,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StringSHA1=n.toHexString=n.stringHash=n.numberHash=n.doHash=n.hash=void 0;function M(w){return i(w,0)}n.hash=M;function i(w,p){switch(typeof w){case"object":return w===null?o(349,p):Array.isArray(w)?u(w,p):s(w,p);case"string":return C(w,p);case"boolean":return c(w,p);case"number":return o(w,p);case"undefined":return o(937,p);default:return o(617,p)}}n.doHash=i;function o(w,p){return(p<<5)-p+w|0}n.numberHash=o;function c(w,p){return o(w?433:863,p)}function C(w,p){p=o(149417,p);for(let y=0,m=w.length;y<m;y++)p=o(w.charCodeAt(y),p);return p}n.stringHash=C;function u(w,p){return p=o(104579,p),w.reduce((y,m)=>i(m,y),p)}function s(w,p){return p=o(181387,p),Object.keys(w).sort().reduce((y,m)=>(y=C(m,y),i(w[m],y)),p)}function v(w,p,y=32){const m=y-p,N=~((1<<m)-1);return(w<<p|(N&w)>>>m)>>>0}function e(w,p=0,y=w.byteLength,m=0){for(let N=0;N<y;N++)w[p+N]=m}function d(w,p,y="0"){for(;w.length<p;)w=y+w;return w}function h(w,p=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(y=>y.toString(16).padStart(2,"0")).join(""):d((w>>>0).toString(16),p/4)}n.toHexString=h;class f{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(p){const y=p.length;if(y===0)return;const m=this._buff;let N=this._buffLen,S=this._leftoverHighSurrogate,_,r;for(S!==0?(_=S,r=-1,S=0):(_=p.charCodeAt(0),r=0);;){let a=_;if(E.isHighSurrogate(_))if(r+1<y){const l=p.charCodeAt(r+1);E.isLowSurrogate(l)?(r++,a=E.computeCodePoint(_,l)):a=65533}else{S=_;break}else E.isLowSurrogate(_)&&(a=65533);if(N=this._push(m,N,a),r++,r<y)_=p.charCodeAt(r);else break}this._buffLen=N,this._leftoverHighSurrogate=S}_push(p,y,m){return m<128?p[y++]=m:m<2048?(p[y++]=192|(m&1984)>>>6,p[y++]=128|(m&63)>>>0):m<65536?(p[y++]=224|(m&61440)>>>12,p[y++]=128|(m&4032)>>>6,p[y++]=128|(m&63)>>>0):(p[y++]=240|(m&1835008)>>>18,p[y++]=128|(m&258048)>>>12,p[y++]=128|(m&4032)>>>6,p[y++]=128|(m&63)>>>0),y>=64&&(this._step(),y-=64,this._totalLen+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),y}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,e(this._buff,this._buffLen),this._buffLen>56&&(this._step(),e(this._buff));const p=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(p/4294967296),!1),this._buffDV.setUint32(60,p%4294967296,!1),this._step()}_step(){const p=f._bigBlock32,y=this._buffDV;for(let g=0;g<64;g+=4)p.setUint32(g,y.getUint32(g,!1),!1);for(let g=64;g<320;g+=4)p.setUint32(g,v(p.getUint32(g-12,!1)^p.getUint32(g-32,!1)^p.getUint32(g-56,!1)^p.getUint32(g-64,!1),1),!1);let m=this._h0,N=this._h1,S=this._h2,_=this._h3,r=this._h4,a,l,b;for(let g=0;g<80;g++)g<20?(a=N&S|~N&_,l=1518500249):g<40?(a=N^S^_,l=1859775393):g<60?(a=N&S|N&_|S&_,l=2400959708):(a=N^S^_,l=3395469782),b=v(m,5)+a+r+l+p.getUint32(g*4,!1)&4294967295,r=_,_=S,S=v(N,30),N=m,m=b;this._h0=this._h0+m&4294967295,this._h1=this._h1+N&4294967295,this._h2=this._h2+S&4294967295,this._h3=this._h3+_&4294967295,this._h4=this._h4+r&4294967295}}n.StringSHA1=f,f._bigBlock32=new DataView(new ArrayBuffer(320))}),K(ee[21],te([0,1,30,34]),function(B,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LcsDiff=n.stringDiff=n.StringDiffSequence=void 0;class i{constructor(e){this.source=e}getElements(){const e=this.source,d=new Int32Array(e.length);for(let h=0,f=e.length;h<f;h++)d[h]=e.charCodeAt(h);return d}}n.StringDiffSequence=i;function o(v,e,d){return new s(new i(v),new i(e)).ComputeDiff(d).changes}n.stringDiff=o;class c{static Assert(e,d){if(!e)throw new Error(d)}}class C{static Copy(e,d,h,f,w){for(let p=0;p<w;p++)h[f+p]=e[d+p]}static Copy2(e,d,h,f,w){for(let p=0;p<w;p++)h[f+p]=e[d+p]}}class u{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new E.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(e,d){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,d),this.m_originalCount++}AddModifiedElement(e,d){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,d),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class s{constructor(e,d,h=null){this.ContinueProcessingPredicate=h,this._originalSequence=e,this._modifiedSequence=d;const[f,w,p]=s._getElements(e),[y,m,N]=s._getElements(d);this._hasStrings=p&&N,this._originalStringElements=f,this._originalElementsOrHash=w,this._modifiedStringElements=y,this._modifiedElementsOrHash=m,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(e){return e.length>0&&typeof e[0]=="string"}static _getElements(e){const d=e.getElements();if(s._isStringArray(d)){const h=new Int32Array(d.length);for(let f=0,w=d.length;f<w;f++)h[f]=(0,M.stringHash)(d[f],0);return[d,h,!0]}return d instanceof Int32Array?[[],d,!1]:[[],new Int32Array(d),!1]}ElementsAreEqual(e,d){return this._originalElementsOrHash[e]!==this._modifiedElementsOrHash[d]?!1:this._hasStrings?this._originalStringElements[e]===this._modifiedStringElements[d]:!0}ElementsAreStrictEqual(e,d){if(!this.ElementsAreEqual(e,d))return!1;const h=s._getStrictElement(this._originalSequence,e),f=s._getStrictElement(this._modifiedSequence,d);return h===f}static _getStrictElement(e,d){return typeof e.getStrictElement=="function"?e.getStrictElement(d):null}OriginalElementsAreEqual(e,d){return this._originalElementsOrHash[e]!==this._originalElementsOrHash[d]?!1:this._hasStrings?this._originalStringElements[e]===this._originalStringElements[d]:!0}ModifiedElementsAreEqual(e,d){return this._modifiedElementsOrHash[e]!==this._modifiedElementsOrHash[d]?!1:this._hasStrings?this._modifiedStringElements[e]===this._modifiedStringElements[d]:!0}ComputeDiff(e){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,e)}_ComputeDiff(e,d,h,f,w){const p=[!1];let y=this.ComputeDiffRecursive(e,d,h,f,p);return w&&(y=this.PrettifyChanges(y)),{quitEarly:p[0],changes:y}}ComputeDiffRecursive(e,d,h,f,w){for(w[0]=!1;e<=d&&h<=f&&this.ElementsAreEqual(e,h);)e++,h++;for(;d>=e&&f>=h&&this.ElementsAreEqual(d,f);)d--,f--;if(e>d||h>f){let _;return h<=f?(c.Assert(e===d+1,"originalStart should only be one more than originalEnd"),_=[new E.DiffChange(e,0,h,f-h+1)]):e<=d?(c.Assert(h===f+1,"modifiedStart should only be one more than modifiedEnd"),_=[new E.DiffChange(e,d-e+1,h,0)]):(c.Assert(e===d+1,"originalStart should only be one more than originalEnd"),c.Assert(h===f+1,"modifiedStart should only be one more than modifiedEnd"),_=[]),_}const p=[0],y=[0],m=this.ComputeRecursionPoint(e,d,h,f,p,y,w),N=p[0],S=y[0];if(m!==null)return m;if(!w[0]){const _=this.ComputeDiffRecursive(e,N,h,S,w);let r=[];return w[0]?r=[new E.DiffChange(N+1,d-(N+1)+1,S+1,f-(S+1)+1)]:r=this.ComputeDiffRecursive(N+1,d,S+1,f,w),this.ConcatenateChanges(_,r)}return[new E.DiffChange(e,d-e+1,h,f-h+1)]}WALKTRACE(e,d,h,f,w,p,y,m,N,S,_,r,a,l,b,g,L,A){let R=null,P=null,O=new u,V=d,x=h,I=a[0]-g[0]-f,k=-1073741824,q=this.m_forwardHistory.length-1;do{const z=I+e;z===V||z<x&&N[z-1]<N[z+1]?(_=N[z+1],l=_-I-f,_<k&&O.MarkNextChange(),k=_,O.AddModifiedElement(_+1,l),I=z+1-e):(_=N[z-1]+1,l=_-I-f,_<k&&O.MarkNextChange(),k=_-1,O.AddOriginalElement(_,l+1),I=z-1-e),q>=0&&(N=this.m_forwardHistory[q],e=N[0],V=1,x=N.length-1)}while(--q>=-1);if(R=O.getReverseChanges(),A[0]){let z=a[0]+1,D=g[0]+1;if(R!==null&&R.length>0){const T=R[R.length-1];z=Math.max(z,T.getOriginalEnd()),D=Math.max(D,T.getModifiedEnd())}P=[new E.DiffChange(z,r-z+1,D,b-D+1)]}else{O=new u,V=p,x=y,I=a[0]-g[0]-m,k=1073741824,q=L?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const z=I+w;z===V||z<x&&S[z-1]>=S[z+1]?(_=S[z+1]-1,l=_-I-m,_>k&&O.MarkNextChange(),k=_+1,O.AddOriginalElement(_+1,l+1),I=z+1-w):(_=S[z-1],l=_-I-m,_>k&&O.MarkNextChange(),k=_,O.AddModifiedElement(_+1,l+1),I=z-1-w),q>=0&&(S=this.m_reverseHistory[q],w=S[0],V=1,x=S.length-1)}while(--q>=-1);P=O.getChanges()}return this.ConcatenateChanges(R,P)}ComputeRecursionPoint(e,d,h,f,w,p,y){let m=0,N=0,S=0,_=0,r=0,a=0;e--,h--,w[0]=0,p[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const l=d-e+(f-h),b=l+1,g=new Int32Array(b),L=new Int32Array(b),A=f-h,R=d-e,P=e-h,O=d-f,x=(R-A)%2===0;g[A]=e,L[R]=d,y[0]=!1;for(let I=1;I<=l/2+1;I++){let k=0,q=0;S=this.ClipDiagonalBound(A-I,I,A,b),_=this.ClipDiagonalBound(A+I,I,A,b);for(let D=S;D<=_;D+=2){D===S||D<_&&g[D-1]<g[D+1]?m=g[D+1]:m=g[D-1]+1,N=m-(D-A)-P;const T=m;for(;m<d&&N<f&&this.ElementsAreEqual(m+1,N+1);)m++,N++;if(g[D]=m,m+N>k+q&&(k=m,q=N),!x&&Math.abs(D-R)<=I-1&&m>=L[D])return w[0]=m,p[0]=N,T<=L[D]&&1447>0&&I<=1447+1?this.WALKTRACE(A,S,_,P,R,r,a,O,g,L,m,d,w,N,f,p,x,y):null}const z=(k-e+(q-h)-I)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(k,z))return y[0]=!0,w[0]=k,p[0]=q,z>0&&1447>0&&I<=1447+1?this.WALKTRACE(A,S,_,P,R,r,a,O,g,L,m,d,w,N,f,p,x,y):(e++,h++,[new E.DiffChange(e,d-e+1,h,f-h+1)]);r=this.ClipDiagonalBound(R-I,I,R,b),a=this.ClipDiagonalBound(R+I,I,R,b);for(let D=r;D<=a;D+=2){D===r||D<a&&L[D-1]>=L[D+1]?m=L[D+1]-1:m=L[D-1],N=m-(D-R)-O;const T=m;for(;m>e&&N>h&&this.ElementsAreEqual(m,N);)m--,N--;if(L[D]=m,x&&Math.abs(D-A)<=I&&m<=g[D])return w[0]=m,p[0]=N,T>=g[D]&&1447>0&&I<=1447+1?this.WALKTRACE(A,S,_,P,R,r,a,O,g,L,m,d,w,N,f,p,x,y):null}if(I<=1447){let D=new Int32Array(_-S+2);D[0]=A-S+1,C.Copy2(g,S,D,1,_-S+1),this.m_forwardHistory.push(D),D=new Int32Array(a-r+2),D[0]=R-r+1,C.Copy2(L,r,D,1,a-r+1),this.m_reverseHistory.push(D)}}return this.WALKTRACE(A,S,_,P,R,r,a,O,g,L,m,d,w,N,f,p,x,y)}PrettifyChanges(e){for(let d=0;d<e.length;d++){const h=e[d],f=d<e.length-1?e[d+1].originalStart:this._originalElementsOrHash.length,w=d<e.length-1?e[d+1].modifiedStart:this._modifiedElementsOrHash.length,p=h.originalLength>0,y=h.modifiedLength>0;for(;h.originalStart+h.originalLength<f&&h.modifiedStart+h.modifiedLength<w&&(!p||this.OriginalElementsAreEqual(h.originalStart,h.originalStart+h.originalLength))&&(!y||this.ModifiedElementsAreEqual(h.modifiedStart,h.modifiedStart+h.modifiedLength));){const N=this.ElementsAreStrictEqual(h.originalStart,h.modifiedStart);if(this.ElementsAreStrictEqual(h.originalStart+h.originalLength,h.modifiedStart+h.modifiedLength)&&!N)break;h.originalStart++,h.modifiedStart++}const m=[null];if(d<e.length-1&&this.ChangesOverlap(e[d],e[d+1],m)){e[d]=m[0],e.splice(d+1,1),d--;continue}}for(let d=e.length-1;d>=0;d--){const h=e[d];let f=0,w=0;if(d>0){const _=e[d-1];f=_.originalStart+_.originalLength,w=_.modifiedStart+_.modifiedLength}const p=h.originalLength>0,y=h.modifiedLength>0;let m=0,N=this._boundaryScore(h.originalStart,h.originalLength,h.modifiedStart,h.modifiedLength);for(let _=1;;_++){const r=h.originalStart-_,a=h.modifiedStart-_;if(r<f||a<w||p&&!this.OriginalElementsAreEqual(r,r+h.originalLength)||y&&!this.ModifiedElementsAreEqual(a,a+h.modifiedLength))break;const b=(r===f&&a===w?5:0)+this._boundaryScore(r,h.originalLength,a,h.modifiedLength);b>N&&(N=b,m=_)}h.originalStart-=m,h.modifiedStart-=m;const S=[null];if(d>0&&this.ChangesOverlap(e[d-1],e[d],S)){e[d-1]=S[0],e.splice(d,1),d++;continue}}if(this._hasStrings)for(let d=1,h=e.length;d<h;d++){const f=e[d-1],w=e[d],p=w.originalStart-f.originalStart-f.originalLength,y=f.originalStart,m=w.originalStart+w.originalLength,N=m-y,S=f.modifiedStart,_=w.modifiedStart+w.modifiedLength,r=_-S;if(p<5&&N<20&&r<20){const a=this._findBetterContiguousSequence(y,N,S,r,p);if(a){const[l,b]=a;(l!==f.originalStart+f.originalLength||b!==f.modifiedStart+f.modifiedLength)&&(f.originalLength=l-f.originalStart,f.modifiedLength=b-f.modifiedStart,w.originalStart=l+p,w.modifiedStart=b+p,w.originalLength=m-w.originalStart,w.modifiedLength=_-w.modifiedStart)}}}return e}_findBetterContiguousSequence(e,d,h,f,w){if(d<w||f<w)return null;const p=e+d-w+1,y=h+f-w+1;let m=0,N=0,S=0;for(let _=e;_<p;_++)for(let r=h;r<y;r++){const a=this._contiguousSequenceScore(_,r,w);a>0&&a>m&&(m=a,N=_,S=r)}return m>0?[N,S]:null}_contiguousSequenceScore(e,d,h){let f=0;for(let w=0;w<h;w++){if(!this.ElementsAreEqual(e+w,d+w))return 0;f+=this._originalStringElements[e+w].length}return f}_OriginalIsBoundary(e){return e<=0||e>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[e])}_OriginalRegionIsBoundary(e,d){if(this._OriginalIsBoundary(e)||this._OriginalIsBoundary(e-1))return!0;if(d>0){const h=e+d;if(this._OriginalIsBoundary(h-1)||this._OriginalIsBoundary(h))return!0}return!1}_ModifiedIsBoundary(e){return e<=0||e>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[e])}_ModifiedRegionIsBoundary(e,d){if(this._ModifiedIsBoundary(e)||this._ModifiedIsBoundary(e-1))return!0;if(d>0){const h=e+d;if(this._ModifiedIsBoundary(h-1)||this._ModifiedIsBoundary(h))return!0}return!1}_boundaryScore(e,d,h,f){const w=this._OriginalRegionIsBoundary(e,d)?1:0,p=this._ModifiedRegionIsBoundary(h,f)?1:0;return w+p}ConcatenateChanges(e,d){const h=[];if(e.length===0||d.length===0)return d.length>0?d:e;if(this.ChangesOverlap(e[e.length-1],d[0],h)){const f=new Array(e.length+d.length-1);return C.Copy(e,0,f,0,e.length-1),f[e.length-1]=h[0],C.Copy(d,1,f,e.length,d.length-1),f}else{const f=new Array(e.length+d.length);return C.Copy(e,0,f,0,e.length),C.Copy(d,0,f,e.length,d.length),f}}ChangesOverlap(e,d,h){if(c.Assert(e.originalStart<=d.originalStart,"Left change is not less than or equal to right change"),c.Assert(e.modifiedStart<=d.modifiedStart,"Left change is not less than or equal to right change"),e.originalStart+e.originalLength>=d.originalStart||e.modifiedStart+e.modifiedLength>=d.modifiedStart){const f=e.originalStart;let w=e.originalLength;const p=e.modifiedStart;let y=e.modifiedLength;return e.originalStart+e.originalLength>=d.originalStart&&(w=d.originalStart+d.originalLength-e.originalStart),e.modifiedStart+e.modifiedLength>=d.modifiedStart&&(y=d.modifiedStart+d.modifiedLength-e.modifiedStart),h[0]=new E.DiffChange(f,w,p,y),!0}else return h[0]=null,!1}ClipDiagonalBound(e,d,h,f){if(e>=0&&e<f)return e;const w=h,p=f-h-1,y=d%2===0;if(e<0){const m=w%2===0;return y===m?0:1}else{const m=p%2===0;return y===m?f-1:f-2}}}n.LcsDiff=s}),K(ee[22],te([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.withUndefinedAsNull=n.withNullAsUndefined=n.validateConstraint=n.validateConstraints=n.isFunction=n.assertIsDefined=n.assertType=n.isUndefinedOrNull=n.isDefined=n.isUndefined=n.isBoolean=n.isIterable=n.isNumber=n.isTypedArray=n.isObject=n.isString=void 0;function E(m){return typeof m=="string"}n.isString=E;function M(m){return typeof m=="object"&&m!==null&&!Array.isArray(m)&&!(m instanceof RegExp)&&!(m instanceof Date)}n.isObject=M;function i(m){const N=Object.getPrototypeOf(Uint8Array);return typeof m=="object"&&m instanceof N}n.isTypedArray=i;function o(m){return typeof m=="number"&&!isNaN(m)}n.isNumber=o;function c(m){return!!m&&typeof m[Symbol.iterator]=="function"}n.isIterable=c;function C(m){return m===!0||m===!1}n.isBoolean=C;function u(m){return typeof m>"u"}n.isUndefined=u;function s(m){return!v(m)}n.isDefined=s;function v(m){return u(m)||m===null}n.isUndefinedOrNull=v;function e(m,N){if(!m)throw new Error(N?`Unexpected type, expected '${N}'`:"Unexpected type")}n.assertType=e;function d(m){if(v(m))throw new Error("Assertion Failed: argument is undefined or null");return m}n.assertIsDefined=d;function h(m){return typeof m=="function"}n.isFunction=h;function f(m,N){const S=Math.min(m.length,N.length);for(let _=0;_<S;_++)w(m[_],N[_])}n.validateConstraints=f;function w(m,N){if(E(N)){if(typeof m!==N)throw new Error(`argument does not match constraint: typeof ${N}`)}else if(h(N)){try{if(m instanceof N)return}catch{}if(!v(m)&&m.constructor===N||N.length===1&&N.call(void 0,m)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}n.validateConstraint=w;function p(m){return m===null?void 0:m}n.withNullAsUndefined=p;function y(m){return typeof m>"u"?null:m}n.withUndefinedAsNull=y}),K(ee[35],te([0,1,22]),function(B,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Codicon=n.getCodiconFontCharacters=void 0;const M=Object.create(null);function i(c,C){if((0,E.isString)(C)){const u=M[C];if(u===void 0)throw new Error(`${c} references an unknown codicon: ${C}`);C=u}return M[c]=C,{id:c}}function o(){return M}n.getCodiconFontCharacters=o,n.Codicon={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),gitPullRequestLabel:i("git-pull-request-label",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),gitPullRequestMilestone:i("git-pull-request-milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),gitPullRequestReviewer:i("git-pull-request-reviewer",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),gitPullRequestAssignee:i("git-pull-request-assignee",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),K(ee[11],te([0,1,22]),function(B,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createProxyObject=n.getAllMethodNames=n.getAllPropertyNames=n.equals=n.mixin=n.cloneAndChange=n.deepFreeze=n.deepClone=void 0;function M(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const f=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([w,p])=>{f[w]=p&&typeof p=="object"?M(p):p}),f}n.deepClone=M;function i(h){if(!h||typeof h!="object")return h;const f=[h];for(;f.length>0;){const w=f.shift();Object.freeze(w);for(const p in w)if(o.call(w,p)){const y=w[p];typeof y=="object"&&!Object.isFrozen(y)&&!(0,E.isTypedArray)(y)&&f.push(y)}}return h}n.deepFreeze=i;const o=Object.prototype.hasOwnProperty;function c(h,f){return C(h,f,new Set)}n.cloneAndChange=c;function C(h,f,w){if((0,E.isUndefinedOrNull)(h))return h;const p=f(h);if(typeof p<"u")return p;if(Array.isArray(h)){const y=[];for(const m of h)y.push(C(m,f,w));return y}if((0,E.isObject)(h)){if(w.has(h))throw new Error("Cannot clone recursive data-structure");w.add(h);const y={};for(const m in h)o.call(h,m)&&(y[m]=C(h[m],f,w));return w.delete(h),y}return h}function u(h,f,w=!0){return(0,E.isObject)(h)?((0,E.isObject)(f)&&Object.keys(f).forEach(p=>{p in h?w&&((0,E.isObject)(h[p])&&(0,E.isObject)(f[p])?u(h[p],f[p],w):h[p]=f[p]):h[p]=f[p]}),h):f}n.mixin=u;function s(h,f){if(h===f)return!0;if(h==null||f===null||f===void 0||typeof h!=typeof f||typeof h!="object"||Array.isArray(h)!==Array.isArray(f))return!1;let w,p;if(Array.isArray(h)){if(h.length!==f.length)return!1;for(w=0;w<h.length;w++)if(!s(h[w],f[w]))return!1}else{const y=[];for(p in h)y.push(p);y.sort();const m=[];for(p in f)m.push(p);if(m.sort(),!s(y,m))return!1;for(w=0;w<y.length;w++)if(!s(h[y[w]],f[y[w]]))return!1}return!0}n.equals=s;function v(h){let f=[];for(;Object.prototype!==h;)f=f.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return f}n.getAllPropertyNames=v;function e(h){const f=[];for(const w of v(h))typeof h[w]=="function"&&f.push(w);return f}n.getAllMethodNames=e;function d(h,f){const w=y=>function(){const m=Array.prototype.slice.call(arguments,0);return f(y,m)},p={};for(const y of h)p[y]=w(y);return p}n.createProxyObject=d}),K(ee[23],te([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.toUint32=n.toUint8=void 0;function E(i){return i<0?0:i>255?255:i|0}n.toUint8=E;function M(i){return i<0?0:i>4294967295?4294967295:i|0}n.toUint32=M}),K(ee[24],te([0,1,23]),function(B,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CharacterSet=n.CharacterClassifier=void 0;class M{constructor(c){const C=(0,E.toUint8)(c);this._defaultValue=C,this._asciiMap=M._createAsciiMap(C),this._map=new Map}static _createAsciiMap(c){const C=new Uint8Array(256);return C.fill(c),C}set(c,C){const u=(0,E.toUint8)(C);c>=0&&c<256?this._asciiMap[c]=u:this._map.set(c,u)}get(c){return c>=0&&c<256?this._asciiMap[c]:this._map.get(c)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}n.CharacterClassifier=M;class i{constructor(){this._actual=new M(0)}add(c){this._actual.set(c,1)}has(c){return this._actual.get(c)===1}clear(){return this._actual.clear()}}n.CharacterSet=i}),K(ee[6],te([0,1,4]),function(B,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.OffsetRange=void 0;class M{static addRange(o,c){let C=0;for(;C<c.length&&c[C].endExclusive<o.start;)C++;let u=C;for(;u<c.length&&c[u].start<=o.endExclusive;)u++;if(C===u)c.splice(C,0,o);else{const s=Math.min(o.start,c[C].start),v=Math.max(o.endExclusive,c[u-1].endExclusive);c.splice(C,u-C,new M(s,v))}}static tryCreate(o,c){if(!(o>c))return new M(o,c)}constructor(o,c){if(this.start=o,this.endExclusive=c,o>c)throw new E.BugIndicatingError(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(o){return new M(this.start+o,this.endExclusive+o)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(o){return this.start===o.start&&this.endExclusive===o.endExclusive}containsRange(o){return this.start<=o.start&&o.endExclusive<=this.endExclusive}contains(o){return this.start<=o&&o<this.endExclusive}join(o){return new M(Math.min(this.start,o.start),Math.max(this.endExclusive,o.endExclusive))}intersect(o){const c=Math.max(this.start,o.start),C=Math.min(this.endExclusive,o.endExclusive);if(c<=C)return new M(c,C)}}n.OffsetRange=M}),K(ee[3],te([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Position=void 0;class E{constructor(i,o){this.lineNumber=i,this.column=o}with(i=this.lineNumber,o=this.column){return i===this.lineNumber&&o===this.column?this:new E(i,o)}delta(i=0,o=0){return this.with(this.lineNumber+i,this.column+o)}equals(i){return E.equals(this,i)}static equals(i,o){return!i&&!o?!0:!!i&&!!o&&i.lineNumber===o.lineNumber&&i.column===o.column}isBefore(i){return E.isBefore(this,i)}static isBefore(i,o){return i.lineNumber<o.lineNumber?!0:o.lineNumber<i.lineNumber?!1:i.column<o.column}isBeforeOrEqual(i){return E.isBeforeOrEqual(this,i)}static isBeforeOrEqual(i,o){return i.lineNumber<o.lineNumber?!0:o.lineNumber<i.lineNumber?!1:i.column<=o.column}static compare(i,o){const c=i.lineNumber|0,C=o.lineNumber|0;if(c===C){const u=i.column|0,s=o.column|0;return u-s}return c-C}clone(){return new E(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(i){return new E(i.lineNumber,i.column)}static isIPosition(i){return i&&typeof i.lineNumber=="number"&&typeof i.column=="number"}}n.Position=E}),K(ee[2],te([0,1,3]),function(B,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Range=void 0;class M{constructor(o,c,C,u){o>C||o===C&&c>u?(this.startLineNumber=C,this.startColumn=u,this.endLineNumber=o,this.endColumn=c):(this.startLineNumber=o,this.startColumn=c,this.endLineNumber=C,this.endColumn=u)}isEmpty(){return M.isEmpty(this)}static isEmpty(o){return o.startLineNumber===o.endLineNumber&&o.startColumn===o.endColumn}containsPosition(o){return M.containsPosition(this,o)}static containsPosition(o,c){return!(c.lineNumber<o.startLineNumber||c.lineNumber>o.endLineNumber||c.lineNumber===o.startLineNumber&&c.column<o.startColumn||c.lineNumber===o.endLineNumber&&c.column>o.endColumn)}static strictContainsPosition(o,c){return!(c.lineNumber<o.startLineNumber||c.lineNumber>o.endLineNumber||c.lineNumber===o.startLineNumber&&c.column<=o.startColumn||c.lineNumber===o.endLineNumber&&c.column>=o.endColumn)}containsRange(o){return M.containsRange(this,o)}static containsRange(o,c){return!(c.startLineNumber<o.startLineNumber||c.endLineNumber<o.startLineNumber||c.startLineNumber>o.endLineNumber||c.endLineNumber>o.endLineNumber||c.startLineNumber===o.startLineNumber&&c.startColumn<o.startColumn||c.endLineNumber===o.endLineNumber&&c.endColumn>o.endColumn)}strictContainsRange(o){return M.strictContainsRange(this,o)}static strictContainsRange(o,c){return!(c.startLineNumber<o.startLineNumber||c.endLineNumber<o.startLineNumber||c.startLineNumber>o.endLineNumber||c.endLineNumber>o.endLineNumber||c.startLineNumber===o.startLineNumber&&c.startColumn<=o.startColumn||c.endLineNumber===o.endLineNumber&&c.endColumn>=o.endColumn)}plusRange(o){return M.plusRange(this,o)}static plusRange(o,c){let C,u,s,v;return c.startLineNumber<o.startLineNumber?(C=c.startLineNumber,u=c.startColumn):c.startLineNumber===o.startLineNumber?(C=c.startLineNumber,u=Math.min(c.startColumn,o.startColumn)):(C=o.startLineNumber,u=o.startColumn),c.endLineNumber>o.endLineNumber?(s=c.endLineNumber,v=c.endColumn):c.endLineNumber===o.endLineNumber?(s=c.endLineNumber,v=Math.max(c.endColumn,o.endColumn)):(s=o.endLineNumber,v=o.endColumn),new M(C,u,s,v)}intersectRanges(o){return M.intersectRanges(this,o)}static intersectRanges(o,c){let C=o.startLineNumber,u=o.startColumn,s=o.endLineNumber,v=o.endColumn;const e=c.startLineNumber,d=c.startColumn,h=c.endLineNumber,f=c.endColumn;return C<e?(C=e,u=d):C===e&&(u=Math.max(u,d)),s>h?(s=h,v=f):s===h&&(v=Math.min(v,f)),C>s||C===s&&u>v?null:new M(C,u,s,v)}equalsRange(o){return M.equalsRange(this,o)}static equalsRange(o,c){return!o&&!c?!0:!!o&&!!c&&o.startLineNumber===c.startLineNumber&&o.startColumn===c.startColumn&&o.endLineNumber===c.endLineNumber&&o.endColumn===c.endColumn}getEndPosition(){return M.getEndPosition(this)}static getEndPosition(o){return new E.Position(o.endLineNumber,o.endColumn)}getStartPosition(){return M.getStartPosition(this)}static getStartPosition(o){return new E.Position(o.startLineNumber,o.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(o,c){return new M(this.startLineNumber,this.startColumn,o,c)}setStartPosition(o,c){return new M(o,c,this.endLineNumber,this.endColumn)}collapseToStart(){return M.collapseToStart(this)}static collapseToStart(o){return new M(o.startLineNumber,o.startColumn,o.startLineNumber,o.startColumn)}collapseToEnd(){return M.collapseToEnd(this)}static collapseToEnd(o){return new M(o.endLineNumber,o.endColumn,o.endLineNumber,o.endColumn)}delta(o){return new M(this.startLineNumber+o,this.startColumn,this.endLineNumber+o,this.endColumn)}static fromPositions(o,c=o){return new M(o.lineNumber,o.column,c.lineNumber,c.column)}static lift(o){return o?new M(o.startLineNumber,o.startColumn,o.endLineNumber,o.endColumn):null}static isIRange(o){return o&&typeof o.startLineNumber=="number"&&typeof o.startColumn=="number"&&typeof o.endLineNumber=="number"&&typeof o.endColumn=="number"}static areIntersectingOrTouching(o,c){return!(o.endLineNumber<c.startLineNumber||o.endLineNumber===c.startLineNumber&&o.endColumn<c.startColumn||c.endLineNumber<o.startLineNumber||c.endLineNumber===o.startLineNumber&&c.endColumn<o.startColumn)}static areIntersecting(o,c){return!(o.endLineNumber<c.startLineNumber||o.endLineNumber===c.startLineNumber&&o.endColumn<=c.startColumn||c.endLineNumber<o.startLineNumber||c.endLineNumber===o.startLineNumber&&c.endColumn<=o.startColumn)}static compareRangesUsingStarts(o,c){if(o&&c){const s=o.startLineNumber|0,v=c.startLineNumber|0;if(s===v){const e=o.startColumn|0,d=c.startColumn|0;if(e===d){const h=o.endLineNumber|0,f=c.endLineNumber|0;if(h===f){const w=o.endColumn|0,p=c.endColumn|0;return w-p}return h-f}return e-d}return s-v}return(o?1:0)-(c?1:0)}static compareRangesUsingEnds(o,c){return o.endLineNumber===c.endLineNumber?o.endColumn===c.endColumn?o.startLineNumber===c.startLineNumber?o.startColumn-c.startColumn:o.startLineNumber-c.startLineNumber:o.endColumn-c.endColumn:o.endLineNumber-c.endLineNumber}static spansMultipleLines(o){return o.endLineNumber>o.startLineNumber}toJSON(){return this}}n.Range=M}),K(ee[12],te([0,1,4,2]),function(B,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineRange=void 0;class i{static fromRange(c){return new i(c.startLineNumber,c.endLineNumber)}static subtract(c,C){return C?c.startLineNumber<C.startLineNumber&&C.endLineNumberExclusive<c.endLineNumberExclusive?[new i(c.startLineNumber,C.startLineNumber),new i(C.endLineNumberExclusive,c.endLineNumberExclusive)]:C.startLineNumber<=c.startLineNumber&&c.endLineNumberExclusive<=C.endLineNumberExclusive?[]:C.endLineNumberExclusive<c.endLineNumberExclusive?[new i(Math.max(C.endLineNumberExclusive,c.startLineNumber),c.endLineNumberExclusive)]:[new i(c.startLineNumber,Math.min(C.startLineNumber,c.endLineNumberExclusive))]:[c]}static joinMany(c){if(c.length===0)return[];let C=c[0];for(let u=1;u<c.length;u++)C=this.join(C,c[u]);return C}static join(c,C){if(c.length===0)return C;if(C.length===0)return c;const u=[];let s=0,v=0,e=null;for(;s<c.length||v<C.length;){let d=null;if(s<c.length&&v<C.length){const h=c[s],f=C[v];h.startLineNumber<f.startLineNumber?(d=h,s++):(d=f,v++)}else s<c.length?(d=c[s],s++):(d=C[v],v++);e===null?e=d:e.endLineNumberExclusive>=d.startLineNumber?e=new i(e.startLineNumber,Math.max(e.endLineNumberExclusive,d.endLineNumberExclusive)):(u.push(e),e=d)}return e!==null&&u.push(e),u}static ofLength(c,C){return new i(c,c+C)}static deserialize(c){return new i(c[0],c[1])}constructor(c,C){if(c>C)throw new E.BugIndicatingError(`startLineNumber ${c} cannot be after endLineNumberExclusive ${C}`);this.startLineNumber=c,this.endLineNumberExclusive=C}contains(c){return this.startLineNumber<=c&&c<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(c){return new i(this.startLineNumber+c,this.endLineNumberExclusive+c)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(c){return new i(Math.min(this.startLineNumber,c.startLineNumber),Math.max(this.endLineNumberExclusive,c.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(c){const C=Math.max(this.startLineNumber,c.startLineNumber),u=Math.min(this.endLineNumberExclusive,c.endLineNumberExclusive);if(C<=u)return new i(C,u)}intersectsStrict(c){return this.startLineNumber<c.endLineNumberExclusive&&c.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(c){return this.startLineNumber<=c.endLineNumberExclusive&&c.startLineNumber<=this.endLineNumberExclusive}equals(c){return this.startLineNumber===c.startLineNumber&&this.endLineNumberExclusive===c.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new M.Range(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new M.Range(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(c){const C=[];for(let u=this.startLineNumber;u<this.endLineNumberExclusive;u++)C.push(c(u));return C}forEach(c){for(let C=this.startLineNumber;C<this.endLineNumberExclusive;C++)c(C)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(c){return this.startLineNumber<=c&&c<this.endLineNumberExclusive}}n.LineRange=i}),K(ee[36],te([0,1,3,2]),function(B,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Selection=void 0;class i extends M.Range{constructor(c,C,u,s){super(c,C,u,s),this.selectionStartLineNumber=c,this.selectionStartColumn=C,this.positionLineNumber=u,this.positionColumn=s}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(c){return i.selectionsEqual(this,c)}static selectionsEqual(c,C){return c.selectionStartLineNumber===C.selectionStartLineNumber&&c.selectionStartColumn===C.selectionStartColumn&&c.positionLineNumber===C.positionLineNumber&&c.positionColumn===C.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(c,C){return this.getDirection()===0?new i(this.startLineNumber,this.startColumn,c,C):new i(c,C,this.startLineNumber,this.startColumn)}getPosition(){return new E.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new E.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(c,C){return this.getDirection()===0?new i(c,C,this.endLineNumber,this.endColumn):new i(this.endLineNumber,this.endColumn,c,C)}static fromPositions(c,C=c){return new i(c.lineNumber,c.column,C.lineNumber,C.column)}static fromRange(c,C){return C===0?new i(c.startLineNumber,c.startColumn,c.endLineNumber,c.endColumn):new i(c.endLineNumber,c.endColumn,c.startLineNumber,c.startColumn)}static liftSelection(c){return new i(c.selectionStartLineNumber,c.selectionStartColumn,c.positionLineNumber,c.positionColumn)}static selectionsArrEqual(c,C){if(c&&!C||!c&&C)return!1;if(!c&&!C)return!0;if(c.length!==C.length)return!1;for(let u=0,s=c.length;u<s;u++)if(!this.selectionsEqual(c[u],C[u]))return!1;return!0}static isISelection(c){return c&&typeof c.selectionStartLineNumber=="number"&&typeof c.selectionStartColumn=="number"&&typeof c.positionLineNumber=="number"&&typeof c.positionColumn=="number"}static createWithDirection(c,C,u,s,v){return v===0?new i(c,C,u,s):new i(u,s,c,C)}}n.Selection=i}),K(ee[37],te([0,1,24]),function(B,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getMapForWordSeparators=n.WordCharacterClassifier=void 0;class M extends E.CharacterClassifier{constructor(c){super(0);for(let C=0,u=c.length;C<u;C++)this.set(c.charCodeAt(C),2);this.set(32,1),this.set(9,1)}}n.WordCharacterClassifier=M;function i(o){const c={};return C=>(c.hasOwnProperty(C)||(c[C]=o(C)),c[C])}n.getMapForWordSeparators=i(o=>new M(o))}),K(ee[25],te([0,1,18,19]),function(B,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getWordAtText=n.ensureValidWordDefinition=n.DEFAULT_WORD_REGEXP=n.USUAL_WORD_SEPARATORS=void 0,n.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function i(s=""){let v="(-?\\d*\\.\\d\\w*)|([^";for(const e of n.USUAL_WORD_SEPARATORS)s.indexOf(e)>=0||(v+="\\"+e);return v+="\\s]+)",new RegExp(v,"g")}n.DEFAULT_WORD_REGEXP=i();function o(s){let v=n.DEFAULT_WORD_REGEXP;if(s&&s instanceof RegExp)if(s.global)v=s;else{let e="g";s.ignoreCase&&(e+="i"),s.multiline&&(e+="m"),s.unicode&&(e+="u"),v=new RegExp(s.source,e)}return v.lastIndex=0,v}n.ensureValidWordDefinition=o;const c=new M.LinkedList;c.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function C(s,v,e,d,h){if(h||(h=E.Iterable.first(c)),e.length>h.maxLen){let m=s-h.maxLen/2;return m<0?m=0:d+=m,e=e.substring(m,s+h.maxLen/2),C(s,v,e,d,h)}const f=Date.now(),w=s-1-d;let p=-1,y=null;for(let m=1;!(Date.now()-f>=h.timeBudget);m++){const N=w-h.windowSize*m;v.lastIndex=Math.max(0,N);const S=u(v,e,w,p);if(!S&&y||(y=S,N<=0))break;p=N}if(y){const m={word:y[0],startColumn:d+1+y.index,endColumn:d+1+y.index+y[0].length};return v.lastIndex=0,m}return null}n.getWordAtText=C;function u(s,v,e,d){let h;for(;h=s.exec(v);){const f=h.index||0;if(f<=e&&s.lastIndex>=e)return h;if(d>0&&f>d)return null}return null}}),K(ee[8],te([0,1,4,6]),function(B,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DateTimeout=n.InfiniteTimeout=n.SequenceDiff=n.DiffAlgorithmResult=void 0;class i{static trivial(s,v){return new i([new o(new M.OffsetRange(0,s.length),new M.OffsetRange(0,v.length))],!1)}static trivialTimedOut(s,v){return new i([new o(new M.OffsetRange(0,s.length),new M.OffsetRange(0,v.length))],!0)}constructor(s,v){this.diffs=s,this.hitTimeout=v}}n.DiffAlgorithmResult=i;class o{constructor(s,v){this.seq1Range=s,this.seq2Range=v}reverse(){return new o(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(s){return new o(this.seq1Range.join(s.seq1Range),this.seq2Range.join(s.seq2Range))}delta(s){return s===0?this:new o(this.seq1Range.delta(s),this.seq2Range.delta(s))}}n.SequenceDiff=o;class c{isValid(){return!0}}n.InfiniteTimeout=c,c.instance=new c;class C{constructor(s){if(this.timeout=s,this.startTime=Date.now(),this.valid=!0,s<=0)throw new E.BugIndicatingError("timeout must be positive")}isValid(){if(!(Date.now()-this.startTime<this.timeout)&&this.valid){this.valid=!1;debugger}return this.valid}}n.DateTimeout=C}),K(ee[38],te([0,1,6,8]),function(B,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.shiftSequenceDiffs=n.joinSequenceDiffs=n.removeRandomMatches=n.removeRandomLineMatches=n.smoothenSequenceDiffs=n.optimizeSequenceDiffs=void 0;function i(e,d,h){let f=h;return f=u(e,d,f),f=s(e,d,f),f}n.optimizeSequenceDiffs=i;function o(e,d,h){const f=[];for(const w of h){const p=f[f.length-1];if(!p){f.push(w);continue}w.seq1Range.start-p.seq1Range.endExclusive<=2||w.seq2Range.start-p.seq2Range.endExclusive<=2?f[f.length-1]=new M.SequenceDiff(p.seq1Range.join(w.seq1Range),p.seq2Range.join(w.seq2Range)):f.push(w)}return f}n.smoothenSequenceDiffs=o;function c(e,d,h){let f=h;if(f.length===0)return f;let w=0,p;do{p=!1;const y=[f[0]];for(let m=1;m<f.length;m++){let _=function(a,l){const b=new E.OffsetRange(S.seq1Range.endExclusive,N.seq1Range.start);return e.getText(b).replace(/\s/g,"").length<=4&&(a.seq1Range.length+a.seq2Range.length>5||l.seq1Range.length+l.seq2Range.length>5)};const N=f[m],S=y[y.length-1];_(S,N)?(p=!0,y[y.length-1]=y[y.length-1].join(N)):y.push(N)}f=y}while(w++<10&&p);return f}n.removeRandomLineMatches=c;function C(e,d,h){let f=h;if(f.length===0)return f;let w=0,p;do{p=!1;const y=[f[0]];for(let m=1;m<f.length;m++){let _=function(a,l){const b=new E.OffsetRange(S.seq1Range.endExclusive,N.seq1Range.start);if(e.countLinesIn(b)>5||b.length>500)return!1;const L=e.getText(b).trim();if(L.length>20||L.split(/\r\n|\r|\n/).length>1)return!1;const A=e.countLinesIn(a.seq1Range),R=a.seq1Range.length,P=d.countLinesIn(a.seq2Range),O=a.seq2Range.length,V=e.countLinesIn(l.seq1Range),x=l.seq1Range.length,I=d.countLinesIn(l.seq2Range),k=l.seq2Range.length,q=2*40+50;function z(D){return Math.min(D,q)}return Math.pow(Math.pow(z(A*40+R),1.5)+Math.pow(z(P*40+O),1.5),1.5)+Math.pow(Math.pow(z(V*40+x),1.5)+Math.pow(z(I*40+k),1.5),1.5)>Math.pow(Math.pow(q,1.5),1.5)*1.3};const N=f[m],S=y[y.length-1];_(S,N)?(p=!0,y[y.length-1]=y[y.length-1].join(N)):y.push(N)}f=y}while(w++<10&&p);return f}n.removeRandomMatches=C;function u(e,d,h){if(h.length===0)return h;const f=[];f.push(h[0]);for(let p=1;p<h.length;p++){const y=f[f.length-1];let m=h[p];if(m.seq1Range.isEmpty||m.seq2Range.isEmpty){const N=m.seq1Range.start-y.seq1Range.endExclusive;let S;for(S=1;S<=N&&!(e.getElement(m.seq1Range.start-S)!==e.getElement(m.seq1Range.endExclusive-S)||d.getElement(m.seq2Range.start-S)!==d.getElement(m.seq2Range.endExclusive-S));S++);if(S--,S===N){f[f.length-1]=new M.SequenceDiff(new E.OffsetRange(y.seq1Range.start,m.seq1Range.endExclusive-N),new E.OffsetRange(y.seq2Range.start,m.seq2Range.endExclusive-N));continue}m=m.delta(-S)}f.push(m)}const w=[];for(let p=0;p<f.length-1;p++){const y=f[p+1];let m=f[p];if(m.seq1Range.isEmpty||m.seq2Range.isEmpty){const N=y.seq1Range.start-m.seq1Range.endExclusive;let S;for(S=0;S<N&&!(e.getElement(m.seq1Range.start+S)!==e.getElement(m.seq1Range.endExclusive+S)||d.getElement(m.seq2Range.start+S)!==d.getElement(m.seq2Range.endExclusive+S));S++);if(S===N){f[p+1]=new M.SequenceDiff(new E.OffsetRange(m.seq1Range.start+N,y.seq1Range.endExclusive),new E.OffsetRange(m.seq2Range.start+N,y.seq2Range.endExclusive));continue}S>0&&(m=m.delta(S))}w.push(m)}return f.length>0&&w.push(f[f.length-1]),w}n.joinSequenceDiffs=u;function s(e,d,h){if(!e.getBoundaryScore||!d.getBoundaryScore)return h;for(let f=0;f<h.length;f++){const w=f>0?h[f-1]:void 0,p=h[f],y=f+1<h.length?h[f+1]:void 0,m=new E.OffsetRange(w?w.seq1Range.start+1:0,y?y.seq1Range.endExclusive-1:e.length),N=new E.OffsetRange(w?w.seq2Range.start+1:0,y?y.seq2Range.endExclusive-1:d.length);p.seq1Range.isEmpty?h[f]=v(p,e,d,m,N):p.seq2Range.isEmpty&&(h[f]=v(p.reverse(),d,e,N,m).reverse())}return h}n.shiftSequenceDiffs=s;function v(e,d,h,f,w){let y=1;for(;e.seq1Range.start-y>=f.start&&e.seq2Range.start-y>=w.start&&h.isStronglyEqual(e.seq2Range.start-y,e.seq2Range.endExclusive-y)&&y<100;)y++;y--;let m=0;for(;e.seq1Range.start+m<f.endExclusive&&e.seq2Range.endExclusive+m<w.endExclusive&&h.isStronglyEqual(e.seq2Range.start+m,e.seq2Range.endExclusive+m)&&m<100;)m++;if(y===0&&m===0)return e;let N=0,S=-1;for(let _=-y;_<=m;_++){const r=e.seq2Range.start+_,a=e.seq2Range.endExclusive+_,l=e.seq1Range.start+_,b=d.getBoundaryScore(l)+h.getBoundaryScore(r)+h.getBoundaryScore(a);b>S&&(S=b,N=_)}return e.delta(N)}}),K(ee[39],te([0,1,6,8]),function(B,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MyersDiffAlgorithm=void 0;class i{compute(s,v,e=M.InfiniteTimeout.instance){if(s.length===0||v.length===0)return M.DiffAlgorithmResult.trivial(s,v);function d(_,r){for(;_<s.length&&r<v.length&&s.getElement(_)===v.getElement(r);)_++,r++;return _}let h=0;const f=new c;f.set(0,d(0,0));const w=new C;w.set(0,f.get(0)===0?null:new o(null,0,0,f.get(0)));let p=0;e:for(;;){if(h++,!e.isValid())return M.DiffAlgorithmResult.trivialTimedOut(s,v);const _=-Math.min(h,v.length+h%2),r=Math.min(h,s.length+h%2);for(p=_;p<=r;p+=2){const a=p===r?-1:f.get(p+1),l=p===_?-1:f.get(p-1)+1,b=Math.min(Math.max(a,l),s.length),g=b-p;if(b>s.length||g>v.length)continue;const L=d(b,g);f.set(p,L);const A=b===a?w.get(p+1):w.get(p-1);if(w.set(p,L!==b?new o(A,b,g,L-b):A),f.get(p)===s.length&&f.get(p)-p===v.length)break e}}let y=w.get(p);const m=[];let N=s.length,S=v.length;for(;;){const _=y?y.x+y.length:0,r=y?y.y+y.length:0;if((_!==N||r!==S)&&m.push(new M.SequenceDiff(new E.OffsetRange(_,N),new E.OffsetRange(r,S))),!y)break;N=y.x,S=y.y,y=y.prev}return m.reverse(),new M.DiffAlgorithmResult(m,!1)}}n.MyersDiffAlgorithm=i;class o{constructor(s,v,e,d){this.prev=s,this.x=v,this.y=e,this.length=d}}class c{constructor(){this.positiveArr=new Int32Array(10),this.negativeArr=new Int32Array(10)}get(s){return s<0?(s=-s-1,this.negativeArr[s]):this.positiveArr[s]}set(s,v){if(s<0){if(s=-s-1,s>=this.negativeArr.length){const e=this.negativeArr;this.negativeArr=new Int32Array(e.length*2),this.negativeArr.set(e)}this.negativeArr[s]=v}else{if(s>=this.positiveArr.length){const e=this.positiveArr;this.positiveArr=new Int32Array(e.length*2),this.positiveArr.set(e)}this.positiveArr[s]=v}}}class C{constructor(){this.positiveArr=[],this.negativeArr=[]}get(s){return s<0?(s=-s-1,this.negativeArr[s]):this.positiveArr[s]}set(s,v){s<0?(s=-s-1,this.negativeArr[s]=v):this.positiveArr[s]=v}}}),K(ee[40],te([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Array2D=void 0;class E{constructor(i,o){this.width=i,this.height=o,this.array=[],this.array=new Array(i*o)}get(i,o){return this.array[i+o*this.width]}set(i,o,c){this.array[i+o*this.width]=c}}n.Array2D=E}),K(ee[41],te([0,1,6,8,40]),function(B,n,E,M,i){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DynamicProgrammingDiffing=void 0;class o{compute(C,u,s=M.InfiniteTimeout.instance,v){if(C.length===0||u.length===0)return M.DiffAlgorithmResult.trivial(C,u);const e=new i.Array2D(C.length,u.length),d=new i.Array2D(C.length,u.length),h=new i.Array2D(C.length,u.length);for(let S=0;S<C.length;S++)for(let _=0;_<u.length;_++){if(!s.isValid())return M.DiffAlgorithmResult.trivialTimedOut(C,u);const r=S===0?0:e.get(S-1,_),a=_===0?0:e.get(S,_-1);let l;C.getElement(S)===u.getElement(_)?(S===0||_===0?l=0:l=e.get(S-1,_-1),S>0&&_>0&&d.get(S-1,_-1)===3&&(l+=h.get(S-1,_-1)),l+=v?v(S,_):1):l=-1;const b=Math.max(r,a,l);if(b===l){const g=S>0&&_>0?h.get(S-1,_-1):0;h.set(S,_,g+1),d.set(S,_,3)}else b===r?(h.set(S,_,0),d.set(S,_,1)):b===a&&(h.set(S,_,0),d.set(S,_,2));e.set(S,_,b)}const f=[];let w=C.length,p=u.length;function y(S,_){(S+1!==w||_+1!==p)&&f.push(new M.SequenceDiff(new E.OffsetRange(S+1,w),new E.OffsetRange(_+1,p))),w=S,p=_}let m=C.length-1,N=u.length-1;for(;m>=0&&N>=0;)d.get(m,N)===3?(y(m,N),m--,N--):d.get(m,N)===1?m--:N--;return y(-1,-1),f.reverse(),new M.DiffAlgorithmResult(f,!1)}}n.DynamicProgrammingDiffing=o}),K(ee[26],te([0,1,12]),function(B,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MovedText=n.SimpleLineRangeMapping=n.RangeMapping=n.LineRangeMapping=n.LinesDiff=void 0;class M{constructor(s,v,e){this.changes=s,this.moves=v,this.hitTimeout=e}}n.LinesDiff=M;class i{static inverse(s,v,e){const d=[];let h=1,f=1;for(const p of s){const y=new i(new E.LineRange(h,p.originalRange.startLineNumber),new E.LineRange(f,p.modifiedRange.startLineNumber),void 0);y.modifiedRange.isEmpty||d.push(y),h=p.originalRange.endLineNumberExclusive,f=p.modifiedRange.endLineNumberExclusive}const w=new i(new E.LineRange(h,v+1),new E.LineRange(f,e+1),void 0);return w.modifiedRange.isEmpty||d.push(w),d}constructor(s,v,e){this.originalRange=s,this.modifiedRange=v,this.innerChanges=e}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}get changedLineCount(){return Math.max(this.originalRange.length,this.modifiedRange.length)}flip(){var s;return new i(this.modifiedRange,this.originalRange,(s=this.innerChanges)===null||s===void 0?void 0:s.map(v=>v.flip()))}}n.LineRangeMapping=i;class o{constructor(s,v){this.originalRange=s,this.modifiedRange=v}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new o(this.modifiedRange,this.originalRange)}}n.RangeMapping=o;class c{constructor(s,v){this.original=s,this.modified=v}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new c(this.modified,this.original)}}n.SimpleLineRangeMapping=c;class C{constructor(s,v){this.lineRangeMapping=s,this.changes=v}flip(){return new C(this.lineRangeMapping.flip(),this.changes.map(s=>s.flip()))}}n.MovedText=C}),K(ee[42],te([0,1,21,26,5,2,9,12]),function(B,n,E,M,i,o,c,C){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffComputer=n.SmartLinesDiffComputer=void 0;const u=3;class s{computeDiff(_,r,a){var l;const g=new p(_,r,{maxComputationTime:a.maxComputationTimeMs,shouldIgnoreTrimWhitespace:a.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),L=[];let A=null;for(const R of g.changes){let P;R.originalEndLineNumber===0?P=new C.LineRange(R.originalStartLineNumber+1,R.originalStartLineNumber+1):P=new C.LineRange(R.originalStartLineNumber,R.originalEndLineNumber+1);let O;R.modifiedEndLineNumber===0?O=new C.LineRange(R.modifiedStartLineNumber+1,R.modifiedStartLineNumber+1):O=new C.LineRange(R.modifiedStartLineNumber,R.modifiedEndLineNumber+1);let V=new M.LineRangeMapping(P,O,(l=R.charChanges)===null||l===void 0?void 0:l.map(x=>new M.RangeMapping(new o.Range(x.originalStartLineNumber,x.originalStartColumn,x.originalEndLineNumber,x.originalEndColumn),new o.Range(x.modifiedStartLineNumber,x.modifiedStartColumn,x.modifiedEndLineNumber,x.modifiedEndColumn))));A&&(A.modifiedRange.endLineNumberExclusive===V.modifiedRange.startLineNumber||A.originalRange.endLineNumberExclusive===V.originalRange.startLineNumber)&&(V=new M.LineRangeMapping(A.originalRange.join(V.originalRange),A.modifiedRange.join(V.modifiedRange),A.innerChanges&&V.innerChanges?A.innerChanges.concat(V.innerChanges):void 0),L.pop()),L.push(V),A=V}return(0,c.assertFn)(()=>(0,c.checkAdjacentItems)(L,(R,P)=>P.originalRange.startLineNumber-R.originalRange.endLineNumberExclusive===P.modifiedRange.startLineNumber-R.modifiedRange.endLineNumberExclusive&&R.originalRange.endLineNumberExclusive<P.originalRange.startLineNumber&&R.modifiedRange.endLineNumberExclusive<P.modifiedRange.startLineNumber)),new M.LinesDiff(L,[],g.quitEarly)}}n.SmartLinesDiffComputer=s;function v(S,_,r,a){return new E.LcsDiff(S,_,r).ComputeDiff(a)}class e{constructor(_){const r=[],a=[];for(let l=0,b=_.length;l<b;l++)r[l]=y(_[l],1),a[l]=m(_[l],1);this.lines=_,this._startColumns=r,this._endColumns=a}getElements(){const _=[];for(let r=0,a=this.lines.length;r<a;r++)_[r]=this.lines[r].substring(this._startColumns[r]-1,this._endColumns[r]-1);return _}getStrictElement(_){return this.lines[_]}getStartLineNumber(_){return _+1}getEndLineNumber(_){return _+1}createCharSequence(_,r,a){const l=[],b=[],g=[];let L=0;for(let A=r;A<=a;A++){const R=this.lines[A],P=_?this._startColumns[A]:1,O=_?this._endColumns[A]:R.length+1;for(let V=P;V<O;V++)l[L]=R.charCodeAt(V-1),b[L]=A+1,g[L]=V,L++;!_&&A<a&&(l[L]=10,b[L]=A+1,g[L]=R.length+1,L++)}return new d(l,b,g)}}class d{constructor(_,r,a){this._charCodes=_,this._lineNumbers=r,this._columns=a}toString(){return"["+this._charCodes.map((_,r)=>(_===10?"\\n":String.fromCharCode(_))+`-(${this._lineNumbers[r]},${this._columns[r]})`).join(", ")+"]"}_assertIndex(_,r){if(_<0||_>=r.length)throw new Error("Illegal index")}getElements(){return this._charCodes}getStartLineNumber(_){return _>0&&_===this._lineNumbers.length?this.getEndLineNumber(_-1):(this._assertIndex(_,this._lineNumbers),this._lineNumbers[_])}getEndLineNumber(_){return _===-1?this.getStartLineNumber(_+1):(this._assertIndex(_,this._lineNumbers),this._charCodes[_]===10?this._lineNumbers[_]+1:this._lineNumbers[_])}getStartColumn(_){return _>0&&_===this._columns.length?this.getEndColumn(_-1):(this._assertIndex(_,this._columns),this._columns[_])}getEndColumn(_){return _===-1?this.getStartColumn(_+1):(this._assertIndex(_,this._columns),this._charCodes[_]===10?1:this._columns[_]+1)}}class h{constructor(_,r,a,l,b,g,L,A){this.originalStartLineNumber=_,this.originalStartColumn=r,this.originalEndLineNumber=a,this.originalEndColumn=l,this.modifiedStartLineNumber=b,this.modifiedStartColumn=g,this.modifiedEndLineNumber=L,this.modifiedEndColumn=A}static createFromDiffChange(_,r,a){const l=r.getStartLineNumber(_.originalStart),b=r.getStartColumn(_.originalStart),g=r.getEndLineNumber(_.originalStart+_.originalLength-1),L=r.getEndColumn(_.originalStart+_.originalLength-1),A=a.getStartLineNumber(_.modifiedStart),R=a.getStartColumn(_.modifiedStart),P=a.getEndLineNumber(_.modifiedStart+_.modifiedLength-1),O=a.getEndColumn(_.modifiedStart+_.modifiedLength-1);return new h(l,b,g,L,A,R,P,O)}}function f(S){if(S.length<=1)return S;const _=[S[0]];let r=_[0];for(let a=1,l=S.length;a<l;a++){const b=S[a],g=b.originalStart-(r.originalStart+r.originalLength),L=b.modifiedStart-(r.modifiedStart+r.modifiedLength);Math.min(g,L)<u?(r.originalLength=b.originalStart+b.originalLength-r.originalStart,r.modifiedLength=b.modifiedStart+b.modifiedLength-r.modifiedStart):(_.push(b),r=b)}return _}class w{constructor(_,r,a,l,b){this.originalStartLineNumber=_,this.originalEndLineNumber=r,this.modifiedStartLineNumber=a,this.modifiedEndLineNumber=l,this.charChanges=b}static createFromDiffResult(_,r,a,l,b,g,L){let A,R,P,O,V;if(r.originalLength===0?(A=a.getStartLineNumber(r.originalStart)-1,R=0):(A=a.getStartLineNumber(r.originalStart),R=a.getEndLineNumber(r.originalStart+r.originalLength-1)),r.modifiedLength===0?(P=l.getStartLineNumber(r.modifiedStart)-1,O=0):(P=l.getStartLineNumber(r.modifiedStart),O=l.getEndLineNumber(r.modifiedStart+r.modifiedLength-1)),g&&r.originalLength>0&&r.originalLength<20&&r.modifiedLength>0&&r.modifiedLength<20&&b()){const x=a.createCharSequence(_,r.originalStart,r.originalStart+r.originalLength-1),I=l.createCharSequence(_,r.modifiedStart,r.modifiedStart+r.modifiedLength-1);if(x.getElements().length>0&&I.getElements().length>0){let k=v(x,I,b,!0).changes;L&&(k=f(k)),V=[];for(let q=0,z=k.length;q<z;q++)V.push(h.createFromDiffChange(k[q],x,I))}}return new w(A,R,P,O,V)}}class p{constructor(_,r,a){this.shouldComputeCharChanges=a.shouldComputeCharChanges,this.shouldPostProcessCharChanges=a.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=a.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=a.shouldMakePrettyDiff,this.originalLines=_,this.modifiedLines=r,this.original=new e(_),this.modified=new e(r),this.continueLineDiff=N(a.maxComputationTime),this.continueCharDiff=N(a.maxComputationTime===0?0:Math.min(a.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:void 0}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const _=v(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),r=_.changes,a=_.quitEarly;if(this.shouldIgnoreTrimWhitespace){const L=[];for(let A=0,R=r.length;A<R;A++)L.push(w.createFromDiffResult(this.shouldIgnoreTrimWhitespace,r[A],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:a,changes:L}}const l=[];let b=0,g=0;for(let L=-1,A=r.length;L<A;L++){const R=L+1<A?r[L+1]:null,P=R?R.originalStart:this.originalLines.length,O=R?R.modifiedStart:this.modifiedLines.length;for(;b<P&&g<O;){const V=this.originalLines[b],x=this.modifiedLines[g];if(V!==x){{let I=y(V,1),k=y(x,1);for(;I>1&&k>1;){const q=V.charCodeAt(I-2),z=x.charCodeAt(k-2);if(q!==z)break;I--,k--}(I>1||k>1)&&this._pushTrimWhitespaceCharChange(l,b+1,1,I,g+1,1,k)}{let I=m(V,1),k=m(x,1);const q=V.length+1,z=x.length+1;for(;I<q&&k<z;){const D=V.charCodeAt(I-1),T=V.charCodeAt(k-1);if(D!==T)break;I++,k++}(I<q||k<z)&&this._pushTrimWhitespaceCharChange(l,b+1,I,q,g+1,k,z)}}b++,g++}R&&(l.push(w.createFromDiffResult(this.shouldIgnoreTrimWhitespace,R,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),b+=R.originalLength,g+=R.modifiedLength)}return{quitEarly:a,changes:l}}_pushTrimWhitespaceCharChange(_,r,a,l,b,g,L){if(this._mergeTrimWhitespaceCharChange(_,r,a,l,b,g,L))return;let A;this.shouldComputeCharChanges&&(A=[new h(r,a,r,l,b,g,b,L)]),_.push(new w(r,r,b,b,A))}_mergeTrimWhitespaceCharChange(_,r,a,l,b,g,L){const A=_.length;if(A===0)return!1;const R=_[A-1];return R.originalEndLineNumber===0||R.modifiedEndLineNumber===0?!1:R.originalEndLineNumber===r&&R.modifiedEndLineNumber===b?(this.shouldComputeCharChanges&&R.charChanges&&R.charChanges.push(new h(r,a,r,l,b,g,b,L)),!0):R.originalEndLineNumber+1===r&&R.modifiedEndLineNumber+1===b?(R.originalEndLineNumber=r,R.modifiedEndLineNumber=b,this.shouldComputeCharChanges&&R.charChanges&&R.charChanges.push(new h(r,a,r,l,b,g,b,L)),!0):!1}}n.DiffComputer=p;function y(S,_){const r=i.firstNonWhitespaceIndex(S);return r===-1?_:r+1}function m(S,_){const r=i.lastNonWhitespaceIndex(S);return r===-1?_:r+2}function N(S){if(S===0)return()=>!0;const _=Date.now();return()=>Date.now()-_<S}}),K(ee[43],te([0,1,16,9,28,12,6,3,2,8,41,38,39,26]),function(B,n,E,M,i,o,c,C,u,s,v,e,d,h){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinesSliceCharSequence=n.LineSequence=n.getLineRangeMapping=n.lineRangeMappingFromRangeMappings=n.StandardLinesDiffComputer=void 0;class f{constructor(){this.dynamicProgrammingDiffing=new v.DynamicProgrammingDiffing,this.myersDiffingAlgorithm=new d.MyersDiffAlgorithm}computeDiff(k,q,z){if(k.length===1&&k[0].length===0||q.length===1&&q[0].length===0)return{changes:[new h.LineRangeMapping(new o.LineRange(1,k.length+1),new o.LineRange(1,q.length+1),[new h.RangeMapping(new u.Range(1,1,k.length,k[0].length+1),new u.Range(1,1,q.length,q[0].length+1))])],hitTimeout:!1,moves:[]};const D=z.maxComputationTimeMs===0?s.InfiniteTimeout.instance:new s.DateTimeout(z.maxComputationTimeMs),T=!z.ignoreTrimWhitespace,U=new Map;function t(H){let X=U.get(H);return X===void 0&&(X=U.size,U.set(H,X)),X}const j=k.map(H=>t(H.trim())),se=q.map(H=>t(H.trim())),ae=new a(j,k),oe=new a(se,q),ge=(()=>ae.length+oe.length<1700?this.dynamicProgrammingDiffing.compute(ae,oe,D,(H,X)=>k[H]===q[X]?q[X].length===0?.1:1+Math.log(1+q[X].length):.99):this.myersDiffingAlgorithm.compute(ae,oe))();let de=ge.diffs,me=ge.hitTimeout;de=(0,e.optimizeSequenceDiffs)(ae,oe,de),de=(0,e.removeRandomLineMatches)(ae,oe,de);const _e=[],re=H=>{if(T)for(let X=0;X<H;X++){const Z=le+X,ne=Q+X;if(k[Z]!==q[ne]){const ce=this.refineDiff(k,q,new s.SequenceDiff(new c.OffsetRange(Z,Z+1),new c.OffsetRange(ne,ne+1)),D,T);for(const ve of ce.mappings)_e.push(ve);ce.hitTimeout&&(me=!0)}}};let le=0,Q=0;for(const H of de){(0,M.assertFn)(()=>H.seq1Range.start-le===H.seq2Range.start-Q);const X=H.seq1Range.start-le;re(X),le=H.seq1Range.endExclusive,Q=H.seq2Range.endExclusive;const Z=this.refineDiff(k,q,H,D,T);Z.hitTimeout&&(me=!0);for(const ne of Z.mappings)_e.push(ne)}re(k.length-le);const G=S(_e,k,q);let Y=[];return z.computeMoves&&(Y=this.computeMoves(G,k,q,j,se,D,T)),(0,M.assertFn)(()=>{function H(Z,ne){if(Z.lineNumber<1||Z.lineNumber>ne.length)return!1;const ce=ne[Z.lineNumber-1];return!(Z.column<1||Z.column>ce.length+1)}function X(Z,ne){return!(Z.startLineNumber<1||Z.startLineNumber>ne.length+1||Z.endLineNumberExclusive<1||Z.endLineNumberExclusive>ne.length+1)}for(const Z of G){if(!Z.innerChanges)return!1;for(const ne of Z.innerChanges)if(!(H(ne.modifiedRange.getStartPosition(),q)&&H(ne.modifiedRange.getEndPosition(),q)&&H(ne.originalRange.getStartPosition(),k)&&H(ne.originalRange.getEndPosition(),k)))return!1;if(!X(Z.modifiedRange,q)||!X(Z.originalRange,k))return!1}return!0}),new h.LinesDiff(G,Y,me)}computeMoves(k,q,z,D,T,U,t){const j=[],se=k.filter(re=>re.modifiedRange.isEmpty&&re.originalRange.length>=3).map(re=>new x(re.originalRange,q,re)),ae=new Set(k.filter(re=>re.originalRange.isEmpty&&re.modifiedRange.length>=3).map(re=>new x(re.modifiedRange,z,re))),oe=new Set;for(const re of se){let le=-1,Q;for(const G of ae){const Y=re.computeSimilarity(G);Y>le&&(le=Y,Q=G)}if(le>.9&&Q){const G=this.refineDiff(q,z,new s.SequenceDiff(new c.OffsetRange(re.range.startLineNumber-1,re.range.endLineNumberExclusive-1),new c.OffsetRange(Q.range.startLineNumber-1,Q.range.endLineNumberExclusive-1)),U,t),Y=S(G.mappings,q,z,!0);ae.delete(Q),j.push(new h.MovedText(new h.SimpleLineRangeMapping(re.range,Q.range),Y)),oe.add(re.source),oe.add(Q.source)}}const ge=new i.SetMap;for(const re of k)if(!oe.has(re))for(let le=re.originalRange.startLineNumber;le<re.originalRange.endLineNumberExclusive-2;le++){const Q=`${D[le-1]}:${D[le+1-1]}:${D[le+2-1]}`;ge.add(Q,{range:new o.LineRange(le,le+3)})}const de=[];k.sort((0,E.compareBy)(re=>re.modifiedRange.startLineNumber,E.numberComparator));for(const re of k){if(oe.has(re))continue;let le=[];for(let Q=re.modifiedRange.startLineNumber;Q<re.modifiedRange.endLineNumberExclusive-2;Q++){const G=`${T[Q-1]}:${T[Q+1-1]}:${T[Q+2-1]}`,Y=new o.LineRange(Q,Q+3),H=[];ge.forEach(G,({range:X})=>{for(const ne of le)if(ne.originalLineRange.endLineNumberExclusive+1===X.endLineNumberExclusive&&ne.modifiedLineRange.endLineNumberExclusive+1===Y.endLineNumberExclusive){ne.originalLineRange=new o.LineRange(ne.originalLineRange.startLineNumber,X.endLineNumberExclusive),ne.modifiedLineRange=new o.LineRange(ne.modifiedLineRange.startLineNumber,Y.endLineNumberExclusive),H.push(ne);return}const Z={modifiedLineRange:Y,originalLineRange:X};de.push(Z),H.push(Z)}),le=H}}de.sort((0,E.reverseOrder)((0,E.compareBy)(re=>re.modifiedLineRange.length,E.numberComparator)));const me=new p,_e=new p;for(const re of de){const le=re.modifiedLineRange.startLineNumber-re.originalLineRange.startLineNumber,Q=me.subtractFrom(re.modifiedLineRange),G=_e.subtractFrom(re.originalLineRange).map(H=>H.delta(le)),Y=w(Q,G);for(const H of Y){if(H.length<3)continue;const X=H,Z=H.delta(-le),ne=this.refineDiff(q,z,new s.SequenceDiff(new c.OffsetRange(Z.startLineNumber-1,Z.endLineNumberExclusive-1),new c.OffsetRange(X.startLineNumber-1,X.endLineNumberExclusive-1)),U,t),ce=S(ne.mappings,q,z,!0);j.push(new h.MovedText(new h.SimpleLineRangeMapping(Z,X),ce)),me.addRange(X),_e.addRange(Z)}}return j}refineDiff(k,q,z,D,T){const U=new b(k,z.seq1Range,T),t=new b(q,z.seq2Range,T),j=U.length+t.length<500?this.dynamicProgrammingDiffing.compute(U,t,D):this.myersDiffingAlgorithm.compute(U,t,D);let se=j.diffs;return se=(0,e.optimizeSequenceDiffs)(U,t,se),se=m(U,t,se),se=(0,e.smoothenSequenceDiffs)(U,t,se),se=(0,e.removeRandomMatches)(U,t,se),{mappings:se.map(oe=>new h.RangeMapping(U.translateRange(oe.seq1Range),t.translateRange(oe.seq2Range))),hitTimeout:j.hitTimeout}}}n.StandardLinesDiffComputer=f;function w(I,k){const q=[];let z=0,D=0;for(;z<I.length&&D<k.length;){const T=I[z],U=k[D],t=T.intersect(U);t&&!t.isEmpty&&q.push(t),T.endLineNumberExclusive<U.endLineNumberExclusive?z++:D++}return q}class p{constructor(){this._normalizedRanges=[]}addRange(k){const q=y(this._normalizedRanges.findIndex(D=>D.endLineNumberExclusive>=k.startLineNumber),this._normalizedRanges.length),z=(0,E.findLastIndex)(this._normalizedRanges,D=>D.startLineNumber<=k.endLineNumberExclusive)+1;if(q===z)this._normalizedRanges.splice(q,0,k);else if(q===z-1){const D=this._normalizedRanges[q];this._normalizedRanges[q]=D.join(k)}else{const D=this._normalizedRanges[q].join(this._normalizedRanges[z-1]).join(k);this._normalizedRanges.splice(q,z-q,D)}}subtractFrom(k){const q=y(this._normalizedRanges.findIndex(U=>U.endLineNumberExclusive>=k.startLineNumber),this._normalizedRanges.length),z=(0,E.findLastIndex)(this._normalizedRanges,U=>U.startLineNumber<=k.endLineNumberExclusive)+1;if(q===z)return[k];const D=[];let T=k.startLineNumber;for(let U=q;U<z;U++){const t=this._normalizedRanges[U];t.startLineNumber>T&&D.push(new o.LineRange(T,t.startLineNumber)),T=t.endLineNumberExclusive}return T<k.endLineNumberExclusive&&D.push(new o.LineRange(T,k.endLineNumberExclusive)),D}}function y(I,k){return I===-1?k:I}function m(I,k,q){const z=[];let D;function T(){if(!D)return;const t=D.s1Range.length-D.deleted,j=D.s2Range.length-D.added;Math.max(D.deleted,D.added)+(D.count-1)>t&&z.push(new s.SequenceDiff(D.s1Range,D.s2Range)),D=void 0}for(const t of q){let j=function(de,me){var _e,re,le,Q;if(!D||!D.s1Range.containsRange(de)||!D.s2Range.containsRange(me))if(D&&!(D.s1Range.endExclusive<de.start&&D.s2Range.endExclusive<me.start)){const H=c.OffsetRange.tryCreate(D.s1Range.endExclusive,de.start),X=c.OffsetRange.tryCreate(D.s2Range.endExclusive,me.start);D.deleted+=(_e=H?.length)!==null&&_e!==void 0?_e:0,D.added+=(re=X?.length)!==null&&re!==void 0?re:0,D.s1Range=D.s1Range.join(de),D.s2Range=D.s2Range.join(me)}else T(),D={added:0,deleted:0,count:0,s1Range:de,s2Range:me};const G=de.intersect(t.seq1Range),Y=me.intersect(t.seq2Range);D.count++,D.deleted+=(le=G?.length)!==null&&le!==void 0?le:0,D.added+=(Q=Y?.length)!==null&&Q!==void 0?Q:0};const se=I.findWordContaining(t.seq1Range.start-1),ae=k.findWordContaining(t.seq2Range.start-1),oe=I.findWordContaining(t.seq1Range.endExclusive),ge=k.findWordContaining(t.seq2Range.endExclusive);se&&oe&&ae&&ge&&se.equals(oe)&&ae.equals(ge)?j(se,ae):(se&&ae&&j(se,ae),oe&&ge&&j(oe,ge))}return T(),N(q,z)}function N(I,k){const q=[];for(;I.length>0||k.length>0;){const z=I[0],D=k[0];let T;z&&(!D||z.seq1Range.start<D.seq1Range.start)?T=I.shift():T=k.shift(),q.length>0&&q[q.length-1].seq1Range.endExclusive>=T.seq1Range.start?q[q.length-1]=q[q.length-1].join(T):q.push(T)}return q}function S(I,k,q,z=!1){const D=[];for(const T of r(I.map(U=>_(U,k,q)),(U,t)=>U.originalRange.overlapOrTouch(t.originalRange)||U.modifiedRange.overlapOrTouch(t.modifiedRange))){const U=T[0],t=T[T.length-1];D.push(new h.LineRangeMapping(U.originalRange.join(t.originalRange),U.modifiedRange.join(t.modifiedRange),T.map(j=>j.innerChanges[0])))}return(0,M.assertFn)(()=>!z&&D.length>0&&D[0].originalRange.startLineNumber!==D[0].modifiedRange.startLineNumber?!1:(0,M.checkAdjacentItems)(D,(T,U)=>U.originalRange.startLineNumber-T.originalRange.endLineNumberExclusive===U.modifiedRange.startLineNumber-T.modifiedRange.endLineNumberExclusive&&T.originalRange.endLineNumberExclusive<U.originalRange.startLineNumber&&T.modifiedRange.endLineNumberExclusive<U.modifiedRange.startLineNumber)),D}n.lineRangeMappingFromRangeMappings=S;function _(I,k,q){let z=0,D=0;I.modifiedRange.endColumn===1&&I.originalRange.endColumn===1&&I.originalRange.startLineNumber+z<=I.originalRange.endLineNumber&&I.modifiedRange.startLineNumber+z<=I.modifiedRange.endLineNumber&&(D=-1),I.modifiedRange.startColumn-1>=q[I.modifiedRange.startLineNumber-1].length&&I.originalRange.startColumn-1>=k[I.originalRange.startLineNumber-1].length&&I.originalRange.startLineNumber<=I.originalRange.endLineNumber+D&&I.modifiedRange.startLineNumber<=I.modifiedRange.endLineNumber+D&&(z=1);const T=new o.LineRange(I.originalRange.startLineNumber+z,I.originalRange.endLineNumber+1+D),U=new o.LineRange(I.modifiedRange.startLineNumber+z,I.modifiedRange.endLineNumber+1+D);return new h.LineRangeMapping(T,U,[I])}n.getLineRangeMapping=_;function*r(I,k){let q,z;for(const D of I)z!==void 0&&k(z,D)?q.push(D):(q&&(yield q),q=[D]),z=D;q&&(yield q)}class a{constructor(k,q){this.trimmedHash=k,this.lines=q}getElement(k){return this.trimmedHash[k]}get length(){return this.trimmedHash.length}getBoundaryScore(k){const q=k===0?0:l(this.lines[k-1]),z=k===this.lines.length?0:l(this.lines[k]);return 1e3-(q+z)}getText(k){return this.lines.slice(k.start,k.endExclusive).join(`
`)}isStronglyEqual(k,q){return this.lines[k]===this.lines[q]}}n.LineSequence=a;function l(I){let k=0;for(;k<I.length&&(I.charCodeAt(k)===32||I.charCodeAt(k)===9);)k++;return k}class b{constructor(k,q,z){this.lines=k,this.considerWhitespaceChanges=z,this.elements=[],this.firstCharOffsetByLineMinusOne=[],this.offsetByLine=[];let D=!1;q.start>0&&q.endExclusive>=k.length&&(q=new c.OffsetRange(q.start-1,q.endExclusive),D=!0),this.lineRange=q;for(let T=this.lineRange.start;T<this.lineRange.endExclusive;T++){let U=k[T],t=0;if(D)t=U.length,U="",D=!1;else if(!z){const j=U.trimStart();t=U.length-j.length,U=j.trimEnd()}this.offsetByLine.push(t);for(let j=0;j<U.length;j++)this.elements.push(U.charCodeAt(j));T<k.length-1&&(this.elements.push(`
`.charCodeAt(0)),this.firstCharOffsetByLineMinusOne[T-this.lineRange.start]=this.elements.length)}this.offsetByLine.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new c.OffsetRange(0,this.length))}getText(k){return this.elements.slice(k.start,k.endExclusive).map(q=>String.fromCharCode(q)).join("")}getElement(k){return this.elements[k]}get length(){return this.elements.length}getBoundaryScore(k){const q=R(k>0?this.elements[k-1]:-1),z=R(k<this.elements.length?this.elements[k]:-1);if(q===6&&z===7)return 0;let D=0;return q!==z&&(D+=10,z===1&&(D+=1)),D+=A(q),D+=A(z),D}translateOffset(k){if(this.lineRange.isEmpty)return new C.Position(this.lineRange.start+1,1);let q=0,z=this.firstCharOffsetByLineMinusOne.length;for(;q<z;){const T=Math.floor((q+z)/2);this.firstCharOffsetByLineMinusOne[T]>k?z=T:q=T+1}const D=q===0?0:this.firstCharOffsetByLineMinusOne[q-1];return new C.Position(this.lineRange.start+q+1,k-D+1+this.offsetByLine[q])}translateRange(k){return u.Range.fromPositions(this.translateOffset(k.start),this.translateOffset(k.endExclusive))}findWordContaining(k){if(k<0||k>=this.elements.length||!g(this.elements[k]))return;let q=k;for(;q>0&&g(this.elements[q-1]);)q--;let z=k;for(;z<this.elements.length&&g(this.elements[z]);)z++;return new c.OffsetRange(q,z)}countLinesIn(k){return this.translateOffset(k.endExclusive).lineNumber-this.translateOffset(k.start).lineNumber}isStronglyEqual(k,q){return this.elements[k]===this.elements[q]}}n.LinesSliceCharSequence=b;function g(I){return I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57}const L={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function A(I){return L[I]}function R(I){return I===10?7:I===13?6:P(I)?5:I>=97&&I<=122?0:I>=65&&I<=90?1:I>=48&&I<=57?2:I===-1?3:4}function P(I){return I===32||I===9}const O=new Map;function V(I){let k=O.get(I);return k===void 0&&(k=O.size,O.set(I,k)),k}class x{constructor(k,q,z){this.range=k,this.lines=q,this.source=z,this.histogram=[];let D=0;for(let T=k.startLineNumber-1;T<k.endLineNumberExclusive-1;T++){const U=q[T];for(let j=0;j<U.length;j++){D++;const se=U[j],ae=V(se);this.histogram[ae]=(this.histogram[ae]||0)+1}D++;const t=V(`
`);this.histogram[t]=(this.histogram[t]||0)+1}this.totalCount=D}computeSimilarity(k){var q,z;let D=0;const T=Math.max(this.histogram.length,k.histogram.length);for(let U=0;U<T;U++)D+=Math.abs(((q=this.histogram[U])!==null&&q!==void 0?q:0)-((z=k.histogram[U])!==null&&z!==void 0?z:0));return 1-D/(this.totalCount+k.totalCount)}}}),K(ee[44],te([0,1,42,43]),function(B,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.linesDiffComputers=void 0,n.linesDiffComputers={getLegacy:()=>new E.SmartLinesDiffComputer,getAdvanced:()=>new M.StandardLinesDiffComputer}}),K(ee[45],te([0,1,29]),function(B,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeDefaultDocumentColors=void 0;function M(d){const h=[];for(const f of d){const w=Number(f);(w||w===0&&f.replace(/\s/g,"")!=="")&&h.push(w)}return h}function i(d,h,f,w){return{red:d/255,blue:f/255,green:h/255,alpha:w}}function o(d,h){const f=h.index,w=h[0].length;if(!f)return;const p=d.positionAt(f);return{startLineNumber:p.lineNumber,startColumn:p.column,endLineNumber:p.lineNumber,endColumn:p.column+w}}function c(d,h){if(!d)return;const f=E.Color.Format.CSS.parseHex(h);if(f)return{range:d,color:i(f.rgba.r,f.rgba.g,f.rgba.b,f.rgba.a)}}function C(d,h,f){if(!d||h.length!==1)return;const p=h[0].values(),y=M(p);return{range:d,color:i(y[0],y[1],y[2],f?y[3]:1)}}function u(d,h,f){if(!d||h.length!==1)return;const p=h[0].values(),y=M(p),m=new E.Color(new E.HSLA(y[0],y[1]/100,y[2]/100,f?y[3]:1));return{range:d,color:i(m.rgba.r,m.rgba.g,m.rgba.b,m.rgba.a)}}function s(d,h){return typeof d=="string"?[...d.matchAll(h)]:d.findMatches(h)}function v(d){const h=[],w=s(d,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(w.length>0)for(const p of w){const y=p.filter(_=>_!==void 0),m=y[1],N=y[2];if(!N)continue;let S;if(m==="rgb"){const _=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;S=C(o(d,p),s(N,_),!1)}else if(m==="rgba"){const _=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;S=C(o(d,p),s(N,_),!0)}else if(m==="hsl"){const _=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;S=u(o(d,p),s(N,_),!1)}else if(m==="hsla"){const _=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;S=u(o(d,p),s(N,_),!0)}else m==="#"&&(S=c(o(d,p),m+N));S&&h.push(S)}return h}function e(d){return!d||typeof d.getValue!="function"||typeof d.positionAt!="function"?[]:v(d)}n.computeDefaultDocumentColors=e}),K(ee[46],te([0,1,24]),function(B,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeLinks=n.LinkComputer=n.StateMachine=void 0;class M{constructor(d,h,f){const w=new Uint8Array(d*h);for(let p=0,y=d*h;p<y;p++)w[p]=f;this._data=w,this.rows=d,this.cols=h}get(d,h){return this._data[d*this.cols+h]}set(d,h,f){this._data[d*this.cols+h]=f}}class i{constructor(d){let h=0,f=0;for(let p=0,y=d.length;p<y;p++){const[m,N,S]=d[p];N>h&&(h=N),m>f&&(f=m),S>f&&(f=S)}h++,f++;const w=new M(f,h,0);for(let p=0,y=d.length;p<y;p++){const[m,N,S]=d[p];w.set(m,N,S)}this._states=w,this._maxCharCode=h}nextState(d,h){return h<0||h>=this._maxCharCode?0:this._states.get(d,h)}}n.StateMachine=i;let o=null;function c(){return o===null&&(o=new i([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),o}let C=null;function u(){if(C===null){C=new E.CharacterClassifier(0);const e=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let h=0;h<e.length;h++)C.set(e.charCodeAt(h),1);const d=".,;:";for(let h=0;h<d.length;h++)C.set(d.charCodeAt(h),2)}return C}class s{static _createLink(d,h,f,w,p){let y=p-1;do{const m=h.charCodeAt(y);if(d.get(m)!==2)break;y--}while(y>w);if(w>0){const m=h.charCodeAt(w-1),N=h.charCodeAt(y);(m===40&&N===41||m===91&&N===93||m===123&&N===125)&&y--}return{range:{startLineNumber:f,startColumn:w+1,endLineNumber:f,endColumn:y+2},url:h.substring(w,y+1)}}static computeLinks(d,h=c()){const f=u(),w=[];for(let p=1,y=d.getLineCount();p<=y;p++){const m=d.getLineContent(p),N=m.length;let S=0,_=0,r=0,a=1,l=!1,b=!1,g=!1,L=!1;for(;S<N;){let A=!1;const R=m.charCodeAt(S);if(a===13){let P;switch(R){case 40:l=!0,P=0;break;case 41:P=l?0:1;break;case 91:g=!0,b=!0,P=0;break;case 93:g=!1,P=b?0:1;break;case 123:L=!0,P=0;break;case 125:P=L?0:1;break;case 39:case 34:case 96:r===R?P=1:r===39||r===34||r===96?P=0:P=1;break;case 42:P=r===42?1:0;break;case 124:P=r===124?1:0;break;case 32:P=g?0:1;break;default:P=f.get(R)}P===1&&(w.push(s._createLink(f,m,p,_,S)),A=!0)}else if(a===12){let P;R===91?(b=!0,P=0):P=f.get(R),P===1?A=!0:a=13}else a=h.nextState(a,R),a===0&&(A=!0);A&&(a=1,l=!1,b=!1,L=!1,_=S+1,r=R),S++}a===13&&w.push(s._createLink(f,m,p,_,N))}return w}}n.LinkComputer=s;function v(e){return!e||typeof e.getLineCount!="function"||typeof e.getLineContent!="function"?[]:s.computeLinks(e)}n.computeLinks=v}),K(ee[47],te([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BasicInplaceReplace=void 0;class E{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(i,o,c,C,u){if(i&&o){const s=this.doNavigateValueSet(o,u);if(s)return{range:i,value:s}}if(c&&C){const s=this.doNavigateValueSet(C,u);if(s)return{range:c,value:s}}return null}doNavigateValueSet(i,o){const c=this.numberReplace(i,o);return c!==null?c:this.textReplace(i,o)}numberReplace(i,o){const c=Math.pow(10,i.length-(i.lastIndexOf(".")+1));let C=Number(i);const u=parseFloat(i);return!isNaN(C)&&!isNaN(u)&&C===u?C===0&&!o?null:(C=Math.floor(C*c),C+=o?c:-c,String(C/c)):null}textReplace(i,o){return this.valueSetsReplace(this._defaultValueSet,i,o)}valueSetsReplace(i,o,c){let C=null;for(let u=0,s=i.length;C===null&&u<s;u++)C=this.valueSetReplace(i[u],o,c);return C}valueSetReplace(i,o,c){let C=i.indexOf(o);return C>=0?(C+=c?1:-1,C<0?C=i.length-1:C%=i.length,i[C]):null}}n.BasicInplaceReplace=E,E.INSTANCE=new E}),K(ee[48],te([0,1,11]),function(B,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.shouldSynchronizeModel=n.ApplyEditsResult=n.SearchData=n.ValidAnnotatedEditOperation=n.isITextSnapshot=n.FindMatch=n.TextModelResolvedOptions=n.InjectedTextCursorStops=n.MinimapPosition=n.GlyphMarginLane=n.OverviewRulerLane=void 0;var M;(function(f){f[f.Left=1]="Left",f[f.Center=2]="Center",f[f.Right=4]="Right",f[f.Full=7]="Full"})(M||(n.OverviewRulerLane=M={}));var i;(function(f){f[f.Left=1]="Left",f[f.Right=2]="Right"})(i||(n.GlyphMarginLane=i={}));var o;(function(f){f[f.Inline=1]="Inline",f[f.Gutter=2]="Gutter"})(o||(n.MinimapPosition=o={}));var c;(function(f){f[f.Both=0]="Both",f[f.Right=1]="Right",f[f.Left=2]="Left",f[f.None=3]="None"})(c||(n.InjectedTextCursorStops=c={}));class C{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(w){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,w.tabSize|0),w.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,w.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!w.insertSpaces,this.defaultEOL=w.defaultEOL|0,this.trimAutoWhitespace=!!w.trimAutoWhitespace,this.bracketPairColorizationOptions=w.bracketPairColorizationOptions}equals(w){return this.tabSize===w.tabSize&&this._indentSizeIsTabSize===w._indentSizeIsTabSize&&this.indentSize===w.indentSize&&this.insertSpaces===w.insertSpaces&&this.defaultEOL===w.defaultEOL&&this.trimAutoWhitespace===w.trimAutoWhitespace&&(0,E.equals)(this.bracketPairColorizationOptions,w.bracketPairColorizationOptions)}createChangeEvent(w){return{tabSize:this.tabSize!==w.tabSize,indentSize:this.indentSize!==w.indentSize,insertSpaces:this.insertSpaces!==w.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==w.trimAutoWhitespace}}}n.TextModelResolvedOptions=C;class u{constructor(w,p){this._findMatchBrand=void 0,this.range=w,this.matches=p}}n.FindMatch=u;function s(f){return f&&typeof f.read=="function"}n.isITextSnapshot=s;class v{constructor(w,p,y,m,N,S){this.identifier=w,this.range=p,this.text=y,this.forceMoveMarkers=m,this.isAutoWhitespaceEdit=N,this._isTracked=S}}n.ValidAnnotatedEditOperation=v;class e{constructor(w,p,y){this.regex=w,this.wordSeparators=p,this.simpleSearch=y}}n.SearchData=e;class d{constructor(w,p,y){this.reverseEdits=w,this.changes=p,this.trimAutoWhitespaceLineNumbers=y}}n.ApplyEditsResult=d;function h(f){return!f.isTooLargeForSyncing()&&!f.isForSimpleWidget}n.shouldSynchronizeModel=h}),K(ee[49],te([0,1,16,23]),function(B,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.PrefixSumIndexOfResult=n.ConstantTimePrefixSumComputer=n.PrefixSumComputer=void 0;class i{constructor(u){this.values=u,this.prefixSum=new Uint32Array(u.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}insertValues(u,s){u=(0,M.toUint32)(u);const v=this.values,e=this.prefixSum,d=s.length;return d===0?!1:(this.values=new Uint32Array(v.length+d),this.values.set(v.subarray(0,u),0),this.values.set(v.subarray(u),u+d),this.values.set(s,u),u-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=u-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(e.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(u,s){return u=(0,M.toUint32)(u),s=(0,M.toUint32)(s),this.values[u]===s?!1:(this.values[u]=s,u-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=u-1),!0)}removeValues(u,s){u=(0,M.toUint32)(u),s=(0,M.toUint32)(s);const v=this.values,e=this.prefixSum;if(u>=v.length)return!1;const d=v.length-u;return s>=d&&(s=d),s===0?!1:(this.values=new Uint32Array(v.length-s),this.values.set(v.subarray(0,u),0),this.values.set(v.subarray(u+s),u),this.prefixSum=new Uint32Array(this.values.length),u-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=u-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(e.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(u){return u<0?0:(u=(0,M.toUint32)(u),this._getPrefixSum(u))}_getPrefixSum(u){if(u<=this.prefixSumValidIndex[0])return this.prefixSum[u];let s=this.prefixSumValidIndex[0]+1;s===0&&(this.prefixSum[0]=this.values[0],s++),u>=this.values.length&&(u=this.values.length-1);for(let v=s;v<=u;v++)this.prefixSum[v]=this.prefixSum[v-1]+this.values[v];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],u),this.prefixSum[u]}getIndexOf(u){u=Math.floor(u),this.getTotalSum();let s=0,v=this.values.length-1,e=0,d=0,h=0;for(;s<=v;)if(e=s+(v-s)/2|0,d=this.prefixSum[e],h=d-this.values[e],u<h)v=e-1;else if(u>=d)s=e+1;else break;return new c(e,u-h)}}n.PrefixSumComputer=i;class o{constructor(u){this._values=u,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(u){return this._ensureValid(),u===0?0:this._prefixSum[u-1]}getIndexOf(u){this._ensureValid();const s=this._indexBySum[u],v=s>0?this._prefixSum[s-1]:0;return new c(s,u-v)}removeValues(u,s){this._values.splice(u,s),this._invalidate(u)}insertValues(u,s){this._values=(0,E.arrayInsert)(this._values,u,s),this._invalidate(u)}_invalidate(u){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,u-1)}_ensureValid(){if(!this._isValid){for(let u=this._validEndIndex+1,s=this._values.length;u<s;u++){const v=this._values[u],e=u>0?this._prefixSum[u-1]:0;this._prefixSum[u]=e+v;for(let d=0;d<v;d++)this._indexBySum[e+d]=u}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(u,s){this._values[u]!==s&&(this._values[u]=s,this._invalidate(u))}}n.ConstantTimePrefixSumComputer=o;class c{constructor(u,s){this.index=u,this.remainder=s,this._prefixSumIndexOfResultBrand=void 0,this.index=u,this.remainder=s}}n.PrefixSumIndexOfResult=c}),K(ee[50],te([0,1,5,3,49]),function(B,n,E,M,i){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MirrorTextModel=void 0;class o{constructor(C,u,s,v){this._uri=C,this._lines=u,this._eol=s,this._versionId=v,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(C){C.eol&&C.eol!==this._eol&&(this._eol=C.eol,this._lineStarts=null);const u=C.changes;for(const s of u)this._acceptDeleteRange(s.range),this._acceptInsertText(new M.Position(s.range.startLineNumber,s.range.startColumn),s.text);this._versionId=C.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const C=this._eol.length,u=this._lines.length,s=new Uint32Array(u);for(let v=0;v<u;v++)s[v]=this._lines[v].length+C;this._lineStarts=new i.PrefixSumComputer(s)}}_setLineText(C,u){this._lines[C]=u,this._lineStarts&&this._lineStarts.setValue(C,this._lines[C].length+this._eol.length)}_acceptDeleteRange(C){if(C.startLineNumber===C.endLineNumber){if(C.startColumn===C.endColumn)return;this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.startLineNumber-1].substring(C.endColumn-1));return}this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.endLineNumber-1].substring(C.endColumn-1)),this._lines.splice(C.startLineNumber,C.endLineNumber-C.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(C.startLineNumber,C.endLineNumber-C.startLineNumber)}_acceptInsertText(C,u){if(u.length===0)return;const s=(0,E.splitLines)(u);if(s.length===1){this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+s[0]+this._lines[C.lineNumber-1].substring(C.column-1));return}s[s.length-1]+=this._lines[C.lineNumber-1].substring(C.column-1),this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+s[0]);const v=new Uint32Array(s.length-1);for(let e=1;e<s.length;e++)this._lines.splice(C.lineNumber+e-1,0,s[e]),v[e-1]=s[e].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(C.lineNumber,v)}}n.MirrorTextModel=o}),K(ee[51],te([0,1,5,37,3,2,48]),function(B,n,E,M,i,o,c){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Searcher=n.isValidMatch=n.TextModelSearch=n.createFindMatch=n.isMultilineRegexSource=n.SearchParams=void 0;const C=999;class u{constructor(m,N,S,_){this.searchString=m,this.isRegex=N,this.matchCase=S,this.wordSeparators=_}parseSearchRequest(){if(this.searchString==="")return null;let m;this.isRegex?m=s(this.searchString):m=this.searchString.indexOf(`
`)>=0;let N=null;try{N=E.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:m,global:!0,unicode:!0})}catch{return null}if(!N)return null;let S=!this.isRegex&&!m;return S&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(S=this.matchCase),new c.SearchData(N,this.wordSeparators?(0,M.getMapForWordSeparators)(this.wordSeparators):null,S?this.searchString:null)}}n.SearchParams=u;function s(y){if(!y||y.length===0)return!1;for(let m=0,N=y.length;m<N;m++){const S=y.charCodeAt(m);if(S===10)return!0;if(S===92){if(m++,m>=N)break;const _=y.charCodeAt(m);if(_===110||_===114||_===87)return!0}}return!1}n.isMultilineRegexSource=s;function v(y,m,N){if(!N)return new c.FindMatch(y,null);const S=[];for(let _=0,r=m.length;_<r;_++)S[_]=m[_];return new c.FindMatch(y,S)}n.createFindMatch=v;class e{constructor(m){const N=[];let S=0;for(let _=0,r=m.length;_<r;_++)m.charCodeAt(_)===10&&(N[S++]=_);this._lineFeedsOffsets=N}findLineFeedCountBeforeOffset(m){const N=this._lineFeedsOffsets;let S=0,_=N.length-1;if(_===-1||m<=N[0])return 0;for(;S<_;){const r=S+((_-S)/2>>0);N[r]>=m?_=r-1:N[r+1]>=m?(S=r,_=r):S=r+1}return S+1}}class d{static findMatches(m,N,S,_,r){const a=N.parseSearchRequest();return a?a.regex.multiline?this._doFindMatchesMultiline(m,S,new p(a.wordSeparators,a.regex),_,r):this._doFindMatchesLineByLine(m,S,a,_,r):[]}static _getMultilineMatchRange(m,N,S,_,r,a){let l,b=0;_?(b=_.findLineFeedCountBeforeOffset(r),l=N+r+b):l=N+r;let g;if(_){const P=_.findLineFeedCountBeforeOffset(r+a.length)-b;g=l+a.length+P}else g=l+a.length;const L=m.getPositionAt(l),A=m.getPositionAt(g);return new o.Range(L.lineNumber,L.column,A.lineNumber,A.column)}static _doFindMatchesMultiline(m,N,S,_,r){const a=m.getOffsetAt(N.getStartPosition()),l=m.getValueInRange(N,1),b=m.getEOL()===`\r
`?new e(l):null,g=[];let L=0,A;for(S.reset(0);A=S.next(l);)if(g[L++]=v(this._getMultilineMatchRange(m,a,l,b,A.index,A[0]),A,_),L>=r)return g;return g}static _doFindMatchesLineByLine(m,N,S,_,r){const a=[];let l=0;if(N.startLineNumber===N.endLineNumber){const g=m.getLineContent(N.startLineNumber).substring(N.startColumn-1,N.endColumn-1);return l=this._findMatchesInLine(S,g,N.startLineNumber,N.startColumn-1,l,a,_,r),a}const b=m.getLineContent(N.startLineNumber).substring(N.startColumn-1);l=this._findMatchesInLine(S,b,N.startLineNumber,N.startColumn-1,l,a,_,r);for(let g=N.startLineNumber+1;g<N.endLineNumber&&l<r;g++)l=this._findMatchesInLine(S,m.getLineContent(g),g,0,l,a,_,r);if(l<r){const g=m.getLineContent(N.endLineNumber).substring(0,N.endColumn-1);l=this._findMatchesInLine(S,g,N.endLineNumber,0,l,a,_,r)}return a}static _findMatchesInLine(m,N,S,_,r,a,l,b){const g=m.wordSeparators;if(!l&&m.simpleSearch){const R=m.simpleSearch,P=R.length,O=N.length;let V=-P;for(;(V=N.indexOf(R,V+P))!==-1;)if((!g||w(g,N,O,V,P))&&(a[r++]=new c.FindMatch(new o.Range(S,V+1+_,S,V+1+P+_),null),r>=b))return r;return r}const L=new p(m.wordSeparators,m.regex);let A;L.reset(0);do if(A=L.next(N),A&&(a[r++]=v(new o.Range(S,A.index+1+_,S,A.index+1+A[0].length+_),A,l),r>=b))return r;while(A);return r}static findNextMatch(m,N,S,_){const r=N.parseSearchRequest();if(!r)return null;const a=new p(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(m,S,a,_):this._doFindNextMatchLineByLine(m,S,a,_)}static _doFindNextMatchMultiline(m,N,S,_){const r=new i.Position(N.lineNumber,1),a=m.getOffsetAt(r),l=m.getLineCount(),b=m.getValueInRange(new o.Range(r.lineNumber,r.column,l,m.getLineMaxColumn(l)),1),g=m.getEOL()===`\r
`?new e(b):null;S.reset(N.column-1);const L=S.next(b);return L?v(this._getMultilineMatchRange(m,a,b,g,L.index,L[0]),L,_):N.lineNumber!==1||N.column!==1?this._doFindNextMatchMultiline(m,new i.Position(1,1),S,_):null}static _doFindNextMatchLineByLine(m,N,S,_){const r=m.getLineCount(),a=N.lineNumber,l=m.getLineContent(a),b=this._findFirstMatchInLine(S,l,a,N.column,_);if(b)return b;for(let g=1;g<=r;g++){const L=(a+g-1)%r,A=m.getLineContent(L+1),R=this._findFirstMatchInLine(S,A,L+1,1,_);if(R)return R}return null}static _findFirstMatchInLine(m,N,S,_,r){m.reset(_-1);const a=m.next(N);return a?v(new o.Range(S,a.index+1,S,a.index+1+a[0].length),a,r):null}static findPreviousMatch(m,N,S,_){const r=N.parseSearchRequest();if(!r)return null;const a=new p(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(m,S,a,_):this._doFindPreviousMatchLineByLine(m,S,a,_)}static _doFindPreviousMatchMultiline(m,N,S,_){const r=this._doFindMatchesMultiline(m,new o.Range(1,1,N.lineNumber,N.column),S,_,10*C);if(r.length>0)return r[r.length-1];const a=m.getLineCount();return N.lineNumber!==a||N.column!==m.getLineMaxColumn(a)?this._doFindPreviousMatchMultiline(m,new i.Position(a,m.getLineMaxColumn(a)),S,_):null}static _doFindPreviousMatchLineByLine(m,N,S,_){const r=m.getLineCount(),a=N.lineNumber,l=m.getLineContent(a).substring(0,N.column-1),b=this._findLastMatchInLine(S,l,a,_);if(b)return b;for(let g=1;g<=r;g++){const L=(r+a-g-1)%r,A=m.getLineContent(L+1),R=this._findLastMatchInLine(S,A,L+1,_);if(R)return R}return null}static _findLastMatchInLine(m,N,S,_){let r=null,a;for(m.reset(0);a=m.next(N);)r=v(new o.Range(S,a.index+1,S,a.index+1+a[0].length),a,_);return r}}n.TextModelSearch=d;function h(y,m,N,S,_){if(S===0)return!0;const r=m.charCodeAt(S-1);if(y.get(r)!==0||r===13||r===10)return!0;if(_>0){const a=m.charCodeAt(S);if(y.get(a)!==0)return!0}return!1}function f(y,m,N,S,_){if(S+_===N)return!0;const r=m.charCodeAt(S+_);if(y.get(r)!==0||r===13||r===10)return!0;if(_>0){const a=m.charCodeAt(S+_-1);if(y.get(a)!==0)return!0}return!1}function w(y,m,N,S,_){return h(y,m,N,S,_)&&f(y,m,N,S,_)}n.isValidMatch=w;class p{constructor(m,N){this._wordSeparators=m,this._searchRegex=N,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(m){this._searchRegex.lastIndex=m,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(m){const N=m.length;let S;do{if(this._prevMatchStartIndex+this._prevMatchLength===N||(S=this._searchRegex.exec(m),!S))return null;const _=S.index,r=S[0].length;if(_===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){E.getNextCodePoint(m,N,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=_,this._prevMatchLength=r,!this._wordSeparators||w(this._wordSeparators,m,N,_,r))return S}while(S);return null}}n.Searcher=p}),K(ee[52],te([0,1,2,51,5,9,25]),function(B,n,E,M,i,o,c){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.UnicodeTextModelHighlighter=void 0;class C{static computeUnicodeHighlights(d,h,f){const w=f?f.startLineNumber:1,p=f?f.endLineNumber:d.getLineCount(),y=new s(h),m=y.getCandidateCodePoints();let N;m==="allNonBasicAscii"?N=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):N=new RegExp(`${u(Array.from(m))}`,"g");const S=new M.Searcher(null,N),_=[];let r=!1,a,l=0,b=0,g=0;e:for(let L=w,A=p;L<=A;L++){const R=d.getLineContent(L),P=R.length;S.reset(0);do if(a=S.next(R),a){let O=a.index,V=a.index+a[0].length;if(O>0){const q=R.charCodeAt(O-1);i.isHighSurrogate(q)&&O--}if(V+1<P){const q=R.charCodeAt(V-1);i.isHighSurrogate(q)&&V++}const x=R.substring(O,V);let I=(0,c.getWordAtText)(O+1,c.DEFAULT_WORD_REGEXP,R,0);I&&I.endColumn<=O+1&&(I=null);const k=y.shouldHighlightNonBasicASCII(x,I?I.word:null);if(k!==0){k===3?l++:k===2?b++:k===1?g++:(0,o.assertNever)(k);const q=1e3;if(_.length>=q){r=!0;break e}_.push(new E.Range(L,O+1,L,V+1))}}while(a)}return{ranges:_,hasMore:r,ambiguousCharacterCount:l,invisibleCharacterCount:b,nonBasicAsciiCharacterCount:g}}static computeUnicodeHighlightReason(d,h){const f=new s(h);switch(f.shouldHighlightNonBasicASCII(d,null)){case 0:return null;case 2:return{kind:1};case 3:{const p=d.codePointAt(0),y=f.ambiguousCharacters.getPrimaryConfusable(p),m=i.AmbiguousCharacters.getLocales().filter(N=>!i.AmbiguousCharacters.getInstance(new Set([...h.allowedLocales,N])).isAmbiguous(p));return{kind:0,confusableWith:String.fromCodePoint(y),notAmbiguousInLocales:m}}case 1:return{kind:2}}}}n.UnicodeTextModelHighlighter=C;function u(e,d){return`[${i.escapeRegExpCharacters(e.map(f=>String.fromCodePoint(f)).join(""))}]`}class s{constructor(d){this.options=d,this.allowedCodePoints=new Set(d.allowedCodePoints),this.ambiguousCharacters=i.AmbiguousCharacters.getInstance(new Set(d.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const d=new Set;if(this.options.invisibleCharacters)for(const h of i.InvisibleCharacters.codePoints)v(String.fromCodePoint(h))||d.add(h);if(this.options.ambiguousCharacters)for(const h of this.ambiguousCharacters.getConfusableCodePoints())d.add(h);for(const h of this.allowedCodePoints)d.delete(h);return d}shouldHighlightNonBasicASCII(d,h){const f=d.codePointAt(0);if(this.allowedCodePoints.has(f))return 0;if(this.options.nonBasicASCII)return 1;let w=!1,p=!1;if(h)for(const y of h){const m=y.codePointAt(0),N=i.isBasicASCII(y);w=w||N,!N&&!this.ambiguousCharacters.isAmbiguous(m)&&!i.InvisibleCharacters.isInvisibleCharacter(m)&&(p=!0)}return!w&&p?0:this.options.invisibleCharacters&&!v(d)&&i.InvisibleCharacters.isInvisibleCharacter(f)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(f)?3:0}}function v(e){return e===" "||e===`
`||e==="	"}}),K(ee[53],te([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.WrappingIndent=n.TrackedRangeStickiness=n.TextEditorCursorStyle=n.TextEditorCursorBlinkingStyle=n.SymbolTag=n.SymbolKind=n.SignatureHelpTriggerKind=n.SelectionDirection=n.ScrollbarVisibility=n.ScrollType=n.RenderMinimap=n.RenderLineNumbersType=n.PositionAffinity=n.OverviewRulerLane=n.OverlayWidgetPositionPreference=n.MouseTargetType=n.MinimapPosition=n.MarkerTag=n.MarkerSeverity=n.KeyCode=n.InlineCompletionTriggerKind=n.InlayHintKind=n.InjectedTextCursorStops=n.IndentAction=n.GlyphMarginLane=n.EndOfLineSequence=n.EndOfLinePreference=n.EditorOption=n.EditorAutoIndentStrategy=n.DocumentHighlightKind=n.DefaultEndOfLine=n.CursorChangeReason=n.ContentWidgetPositionPreference=n.CompletionTriggerKind=n.CompletionItemTag=n.CompletionItemKind=n.CompletionItemInsertTextRule=n.CodeActionTriggerType=n.AccessibilitySupport=void 0;var E;(function(t){t[t.Unknown=0]="Unknown",t[t.Disabled=1]="Disabled",t[t.Enabled=2]="Enabled"})(E||(n.AccessibilitySupport=E={}));var M;(function(t){t[t.Invoke=1]="Invoke",t[t.Auto=2]="Auto"})(M||(n.CodeActionTriggerType=M={}));var i;(function(t){t[t.None=0]="None",t[t.KeepWhitespace=1]="KeepWhitespace",t[t.InsertAsSnippet=4]="InsertAsSnippet"})(i||(n.CompletionItemInsertTextRule=i={}));var o;(function(t){t[t.Method=0]="Method",t[t.Function=1]="Function",t[t.Constructor=2]="Constructor",t[t.Field=3]="Field",t[t.Variable=4]="Variable",t[t.Class=5]="Class",t[t.Struct=6]="Struct",t[t.Interface=7]="Interface",t[t.Module=8]="Module",t[t.Property=9]="Property",t[t.Event=10]="Event",t[t.Operator=11]="Operator",t[t.Unit=12]="Unit",t[t.Value=13]="Value",t[t.Constant=14]="Constant",t[t.Enum=15]="Enum",t[t.EnumMember=16]="EnumMember",t[t.Keyword=17]="Keyword",t[t.Text=18]="Text",t[t.Color=19]="Color",t[t.File=20]="File",t[t.Reference=21]="Reference",t[t.Customcolor=22]="Customcolor",t[t.Folder=23]="Folder",t[t.TypeParameter=24]="TypeParameter",t[t.User=25]="User",t[t.Issue=26]="Issue",t[t.Snippet=27]="Snippet"})(o||(n.CompletionItemKind=o={}));var c;(function(t){t[t.Deprecated=1]="Deprecated"})(c||(n.CompletionItemTag=c={}));var C;(function(t){t[t.Invoke=0]="Invoke",t[t.TriggerCharacter=1]="TriggerCharacter",t[t.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(C||(n.CompletionTriggerKind=C={}));var u;(function(t){t[t.EXACT=0]="EXACT",t[t.ABOVE=1]="ABOVE",t[t.BELOW=2]="BELOW"})(u||(n.ContentWidgetPositionPreference=u={}));var s;(function(t){t[t.NotSet=0]="NotSet",t[t.ContentFlush=1]="ContentFlush",t[t.RecoverFromMarkers=2]="RecoverFromMarkers",t[t.Explicit=3]="Explicit",t[t.Paste=4]="Paste",t[t.Undo=5]="Undo",t[t.Redo=6]="Redo"})(s||(n.CursorChangeReason=s={}));var v;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(v||(n.DefaultEndOfLine=v={}));var e;(function(t){t[t.Text=0]="Text",t[t.Read=1]="Read",t[t.Write=2]="Write"})(e||(n.DocumentHighlightKind=e={}));var d;(function(t){t[t.None=0]="None",t[t.Keep=1]="Keep",t[t.Brackets=2]="Brackets",t[t.Advanced=3]="Advanced",t[t.Full=4]="Full"})(d||(n.EditorAutoIndentStrategy=d={}));var h;(function(t){t[t.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",t[t.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",t[t.accessibilitySupport=2]="accessibilitySupport",t[t.accessibilityPageSize=3]="accessibilityPageSize",t[t.ariaLabel=4]="ariaLabel",t[t.ariaRequired=5]="ariaRequired",t[t.autoClosingBrackets=6]="autoClosingBrackets",t[t.screenReaderAnnounceInlineSuggestion=7]="screenReaderAnnounceInlineSuggestion",t[t.autoClosingDelete=8]="autoClosingDelete",t[t.autoClosingOvertype=9]="autoClosingOvertype",t[t.autoClosingQuotes=10]="autoClosingQuotes",t[t.autoIndent=11]="autoIndent",t[t.automaticLayout=12]="automaticLayout",t[t.autoSurround=13]="autoSurround",t[t.bracketPairColorization=14]="bracketPairColorization",t[t.guides=15]="guides",t[t.codeLens=16]="codeLens",t[t.codeLensFontFamily=17]="codeLensFontFamily",t[t.codeLensFontSize=18]="codeLensFontSize",t[t.colorDecorators=19]="colorDecorators",t[t.colorDecoratorsLimit=20]="colorDecoratorsLimit",t[t.columnSelection=21]="columnSelection",t[t.comments=22]="comments",t[t.contextmenu=23]="contextmenu",t[t.copyWithSyntaxHighlighting=24]="copyWithSyntaxHighlighting",t[t.cursorBlinking=25]="cursorBlinking",t[t.cursorSmoothCaretAnimation=26]="cursorSmoothCaretAnimation",t[t.cursorStyle=27]="cursorStyle",t[t.cursorSurroundingLines=28]="cursorSurroundingLines",t[t.cursorSurroundingLinesStyle=29]="cursorSurroundingLinesStyle",t[t.cursorWidth=30]="cursorWidth",t[t.disableLayerHinting=31]="disableLayerHinting",t[t.disableMonospaceOptimizations=32]="disableMonospaceOptimizations",t[t.domReadOnly=33]="domReadOnly",t[t.dragAndDrop=34]="dragAndDrop",t[t.dropIntoEditor=35]="dropIntoEditor",t[t.emptySelectionClipboard=36]="emptySelectionClipboard",t[t.experimentalWhitespaceRendering=37]="experimentalWhitespaceRendering",t[t.extraEditorClassName=38]="extraEditorClassName",t[t.fastScrollSensitivity=39]="fastScrollSensitivity",t[t.find=40]="find",t[t.fixedOverflowWidgets=41]="fixedOverflowWidgets",t[t.folding=42]="folding",t[t.foldingStrategy=43]="foldingStrategy",t[t.foldingHighlight=44]="foldingHighlight",t[t.foldingImportsByDefault=45]="foldingImportsByDefault",t[t.foldingMaximumRegions=46]="foldingMaximumRegions",t[t.unfoldOnClickAfterEndOfLine=47]="unfoldOnClickAfterEndOfLine",t[t.fontFamily=48]="fontFamily",t[t.fontInfo=49]="fontInfo",t[t.fontLigatures=50]="fontLigatures",t[t.fontSize=51]="fontSize",t[t.fontWeight=52]="fontWeight",t[t.fontVariations=53]="fontVariations",t[t.formatOnPaste=54]="formatOnPaste",t[t.formatOnType=55]="formatOnType",t[t.glyphMargin=56]="glyphMargin",t[t.gotoLocation=57]="gotoLocation",t[t.hideCursorInOverviewRuler=58]="hideCursorInOverviewRuler",t[t.hover=59]="hover",t[t.inDiffEditor=60]="inDiffEditor",t[t.inlineSuggest=61]="inlineSuggest",t[t.letterSpacing=62]="letterSpacing",t[t.lightbulb=63]="lightbulb",t[t.lineDecorationsWidth=64]="lineDecorationsWidth",t[t.lineHeight=65]="lineHeight",t[t.lineNumbers=66]="lineNumbers",t[t.lineNumbersMinChars=67]="lineNumbersMinChars",t[t.linkedEditing=68]="linkedEditing",t[t.links=69]="links",t[t.matchBrackets=70]="matchBrackets",t[t.minimap=71]="minimap",t[t.mouseStyle=72]="mouseStyle",t[t.mouseWheelScrollSensitivity=73]="mouseWheelScrollSensitivity",t[t.mouseWheelZoom=74]="mouseWheelZoom",t[t.multiCursorMergeOverlapping=75]="multiCursorMergeOverlapping",t[t.multiCursorModifier=76]="multiCursorModifier",t[t.multiCursorPaste=77]="multiCursorPaste",t[t.multiCursorLimit=78]="multiCursorLimit",t[t.occurrencesHighlight=79]="occurrencesHighlight",t[t.overviewRulerBorder=80]="overviewRulerBorder",t[t.overviewRulerLanes=81]="overviewRulerLanes",t[t.padding=82]="padding",t[t.pasteAs=83]="pasteAs",t[t.parameterHints=84]="parameterHints",t[t.peekWidgetDefaultFocus=85]="peekWidgetDefaultFocus",t[t.definitionLinkOpensInPeek=86]="definitionLinkOpensInPeek",t[t.quickSuggestions=87]="quickSuggestions",t[t.quickSuggestionsDelay=88]="quickSuggestionsDelay",t[t.readOnly=89]="readOnly",t[t.readOnlyMessage=90]="readOnlyMessage",t[t.renameOnType=91]="renameOnType",t[t.renderControlCharacters=92]="renderControlCharacters",t[t.renderFinalNewline=93]="renderFinalNewline",t[t.renderLineHighlight=94]="renderLineHighlight",t[t.renderLineHighlightOnlyWhenFocus=95]="renderLineHighlightOnlyWhenFocus",t[t.renderValidationDecorations=96]="renderValidationDecorations",t[t.renderWhitespace=97]="renderWhitespace",t[t.revealHorizontalRightPadding=98]="revealHorizontalRightPadding",t[t.roundedSelection=99]="roundedSelection",t[t.rulers=100]="rulers",t[t.scrollbar=101]="scrollbar",t[t.scrollBeyondLastColumn=102]="scrollBeyondLastColumn",t[t.scrollBeyondLastLine=103]="scrollBeyondLastLine",t[t.scrollPredominantAxis=104]="scrollPredominantAxis",t[t.selectionClipboard=105]="selectionClipboard",t[t.selectionHighlight=106]="selectionHighlight",t[t.selectOnLineNumbers=107]="selectOnLineNumbers",t[t.showFoldingControls=108]="showFoldingControls",t[t.showUnused=109]="showUnused",t[t.snippetSuggestions=110]="snippetSuggestions",t[t.smartSelect=111]="smartSelect",t[t.smoothScrolling=112]="smoothScrolling",t[t.stickyScroll=113]="stickyScroll",t[t.stickyTabStops=114]="stickyTabStops",t[t.stopRenderingLineAfter=115]="stopRenderingLineAfter",t[t.suggest=116]="suggest",t[t.suggestFontSize=117]="suggestFontSize",t[t.suggestLineHeight=118]="suggestLineHeight",t[t.suggestOnTriggerCharacters=119]="suggestOnTriggerCharacters",t[t.suggestSelection=120]="suggestSelection",t[t.tabCompletion=121]="tabCompletion",t[t.tabIndex=122]="tabIndex",t[t.unicodeHighlighting=123]="unicodeHighlighting",t[t.unusualLineTerminators=124]="unusualLineTerminators",t[t.useShadowDOM=125]="useShadowDOM",t[t.useTabStops=126]="useTabStops",t[t.wordBreak=127]="wordBreak",t[t.wordSeparators=128]="wordSeparators",t[t.wordWrap=129]="wordWrap",t[t.wordWrapBreakAfterCharacters=130]="wordWrapBreakAfterCharacters",t[t.wordWrapBreakBeforeCharacters=131]="wordWrapBreakBeforeCharacters",t[t.wordWrapColumn=132]="wordWrapColumn",t[t.wordWrapOverride1=133]="wordWrapOverride1",t[t.wordWrapOverride2=134]="wordWrapOverride2",t[t.wrappingIndent=135]="wrappingIndent",t[t.wrappingStrategy=136]="wrappingStrategy",t[t.showDeprecated=137]="showDeprecated",t[t.inlayHints=138]="inlayHints",t[t.editorClassName=139]="editorClassName",t[t.pixelRatio=140]="pixelRatio",t[t.tabFocusMode=141]="tabFocusMode",t[t.layoutInfo=142]="layoutInfo",t[t.wrappingInfo=143]="wrappingInfo",t[t.defaultColorDecorators=144]="defaultColorDecorators",t[t.colorDecoratorsActivatedOn=145]="colorDecoratorsActivatedOn"})(h||(n.EditorOption=h={}));var f;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(f||(n.EndOfLinePreference=f={}));var w;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(w||(n.EndOfLineSequence=w={}));var p;(function(t){t[t.Left=1]="Left",t[t.Right=2]="Right"})(p||(n.GlyphMarginLane=p={}));var y;(function(t){t[t.None=0]="None",t[t.Indent=1]="Indent",t[t.IndentOutdent=2]="IndentOutdent",t[t.Outdent=3]="Outdent"})(y||(n.IndentAction=y={}));var m;(function(t){t[t.Both=0]="Both",t[t.Right=1]="Right",t[t.Left=2]="Left",t[t.None=3]="None"})(m||(n.InjectedTextCursorStops=m={}));var N;(function(t){t[t.Type=1]="Type",t[t.Parameter=2]="Parameter"})(N||(n.InlayHintKind=N={}));var S;(function(t){t[t.Automatic=0]="Automatic",t[t.Explicit=1]="Explicit"})(S||(n.InlineCompletionTriggerKind=S={}));var _;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.F20=78]="F20",t[t.F21=79]="F21",t[t.F22=80]="F22",t[t.F23=81]="F23",t[t.F24=82]="F24",t[t.NumLock=83]="NumLock",t[t.ScrollLock=84]="ScrollLock",t[t.Semicolon=85]="Semicolon",t[t.Equal=86]="Equal",t[t.Comma=87]="Comma",t[t.Minus=88]="Minus",t[t.Period=89]="Period",t[t.Slash=90]="Slash",t[t.Backquote=91]="Backquote",t[t.BracketLeft=92]="BracketLeft",t[t.Backslash=93]="Backslash",t[t.BracketRight=94]="BracketRight",t[t.Quote=95]="Quote",t[t.OEM_8=96]="OEM_8",t[t.IntlBackslash=97]="IntlBackslash",t[t.Numpad0=98]="Numpad0",t[t.Numpad1=99]="Numpad1",t[t.Numpad2=100]="Numpad2",t[t.Numpad3=101]="Numpad3",t[t.Numpad4=102]="Numpad4",t[t.Numpad5=103]="Numpad5",t[t.Numpad6=104]="Numpad6",t[t.Numpad7=105]="Numpad7",t[t.Numpad8=106]="Numpad8",t[t.Numpad9=107]="Numpad9",t[t.NumpadMultiply=108]="NumpadMultiply",t[t.NumpadAdd=109]="NumpadAdd",t[t.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=111]="NumpadSubtract",t[t.NumpadDecimal=112]="NumpadDecimal",t[t.NumpadDivide=113]="NumpadDivide",t[t.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",t[t.ABNT_C1=115]="ABNT_C1",t[t.ABNT_C2=116]="ABNT_C2",t[t.AudioVolumeMute=117]="AudioVolumeMute",t[t.AudioVolumeUp=118]="AudioVolumeUp",t[t.AudioVolumeDown=119]="AudioVolumeDown",t[t.BrowserSearch=120]="BrowserSearch",t[t.BrowserHome=121]="BrowserHome",t[t.BrowserBack=122]="BrowserBack",t[t.BrowserForward=123]="BrowserForward",t[t.MediaTrackNext=124]="MediaTrackNext",t[t.MediaTrackPrevious=125]="MediaTrackPrevious",t[t.MediaStop=126]="MediaStop",t[t.MediaPlayPause=127]="MediaPlayPause",t[t.LaunchMediaPlayer=128]="LaunchMediaPlayer",t[t.LaunchMail=129]="LaunchMail",t[t.LaunchApp2=130]="LaunchApp2",t[t.Clear=131]="Clear",t[t.MAX_VALUE=132]="MAX_VALUE"})(_||(n.KeyCode=_={}));var r;(function(t){t[t.Hint=1]="Hint",t[t.Info=2]="Info",t[t.Warning=4]="Warning",t[t.Error=8]="Error"})(r||(n.MarkerSeverity=r={}));var a;(function(t){t[t.Unnecessary=1]="Unnecessary",t[t.Deprecated=2]="Deprecated"})(a||(n.MarkerTag=a={}));var l;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(l||(n.MinimapPosition=l={}));var b;(function(t){t[t.UNKNOWN=0]="UNKNOWN",t[t.TEXTAREA=1]="TEXTAREA",t[t.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",t[t.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",t[t.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",t[t.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",t[t.CONTENT_TEXT=6]="CONTENT_TEXT",t[t.CONTENT_EMPTY=7]="CONTENT_EMPTY",t[t.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",t[t.CONTENT_WIDGET=9]="CONTENT_WIDGET",t[t.OVERVIEW_RULER=10]="OVERVIEW_RULER",t[t.SCROLLBAR=11]="SCROLLBAR",t[t.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",t[t.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(b||(n.MouseTargetType=b={}));var g;(function(t){t[t.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",t[t.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",t[t.TOP_CENTER=2]="TOP_CENTER"})(g||(n.OverlayWidgetPositionPreference=g={}));var L;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(L||(n.OverviewRulerLane=L={}));var A;(function(t){t[t.Left=0]="Left",t[t.Right=1]="Right",t[t.None=2]="None",t[t.LeftOfInjectedText=3]="LeftOfInjectedText",t[t.RightOfInjectedText=4]="RightOfInjectedText"})(A||(n.PositionAffinity=A={}));var R;(function(t){t[t.Off=0]="Off",t[t.On=1]="On",t[t.Relative=2]="Relative",t[t.Interval=3]="Interval",t[t.Custom=4]="Custom"})(R||(n.RenderLineNumbersType=R={}));var P;(function(t){t[t.None=0]="None",t[t.Text=1]="Text",t[t.Blocks=2]="Blocks"})(P||(n.RenderMinimap=P={}));var O;(function(t){t[t.Smooth=0]="Smooth",t[t.Immediate=1]="Immediate"})(O||(n.ScrollType=O={}));var V;(function(t){t[t.Auto=1]="Auto",t[t.Hidden=2]="Hidden",t[t.Visible=3]="Visible"})(V||(n.ScrollbarVisibility=V={}));var x;(function(t){t[t.LTR=0]="LTR",t[t.RTL=1]="RTL"})(x||(n.SelectionDirection=x={}));var I;(function(t){t[t.Invoke=1]="Invoke",t[t.TriggerCharacter=2]="TriggerCharacter",t[t.ContentChange=3]="ContentChange"})(I||(n.SignatureHelpTriggerKind=I={}));var k;(function(t){t[t.File=0]="File",t[t.Module=1]="Module",t[t.Namespace=2]="Namespace",t[t.Package=3]="Package",t[t.Class=4]="Class",t[t.Method=5]="Method",t[t.Property=6]="Property",t[t.Field=7]="Field",t[t.Constructor=8]="Constructor",t[t.Enum=9]="Enum",t[t.Interface=10]="Interface",t[t.Function=11]="Function",t[t.Variable=12]="Variable",t[t.Constant=13]="Constant",t[t.String=14]="String",t[t.Number=15]="Number",t[t.Boolean=16]="Boolean",t[t.Array=17]="Array",t[t.Object=18]="Object",t[t.Key=19]="Key",t[t.Null=20]="Null",t[t.EnumMember=21]="EnumMember",t[t.Struct=22]="Struct",t[t.Event=23]="Event",t[t.Operator=24]="Operator",t[t.TypeParameter=25]="TypeParameter"})(k||(n.SymbolKind=k={}));var q;(function(t){t[t.Deprecated=1]="Deprecated"})(q||(n.SymbolTag=q={}));var z;(function(t){t[t.Hidden=0]="Hidden",t[t.Blink=1]="Blink",t[t.Smooth=2]="Smooth",t[t.Phase=3]="Phase",t[t.Expand=4]="Expand",t[t.Solid=5]="Solid"})(z||(n.TextEditorCursorBlinkingStyle=z={}));var D;(function(t){t[t.Line=1]="Line",t[t.Block=2]="Block",t[t.Underline=3]="Underline",t[t.LineThin=4]="LineThin",t[t.BlockOutline=5]="BlockOutline",t[t.UnderlineThin=6]="UnderlineThin"})(D||(n.TextEditorCursorStyle=D={}));var T;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(T||(n.TrackedRangeStickiness=T={}));var U;(function(t){t[t.None=0]="None",t[t.Same=1]="Same",t[t.Indent=2]="Indent",t[t.DeepIndent=3]="DeepIndent"})(U||(n.WrappingIndent=U={}))}),K(ee[54],te([0,1,7,10]),function(B,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=void 0;class i{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new E.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(C){this._onDidChange.fire({changedLanguages:C,changedColorMap:!1})}register(C,u){return this._tokenizationSupports.set(C,u),this.handleChange([C]),(0,M.toDisposable)(()=>{this._tokenizationSupports.get(C)===u&&(this._tokenizationSupports.delete(C),this.handleChange([C]))})}get(C){return this._tokenizationSupports.get(C)||null}registerFactory(C,u){var s;(s=this._factories.get(C))===null||s===void 0||s.dispose();const v=new o(this,C,u);return this._factories.set(C,v),(0,M.toDisposable)(()=>{const e=this._factories.get(C);!e||e!==v||(this._factories.delete(C),e.dispose())})}getOrCreate(C){return pe(this,void 0,void 0,function*(){const u=this.get(C);if(u)return u;const s=this._factories.get(C);return!s||s.isResolved?null:(yield s.resolve(),this.get(C))})}isResolved(C){if(this.get(C))return!0;const s=this._factories.get(C);return!!(!s||s.isResolved)}setColorMap(C){this._colorMap=C,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}n.TokenizationRegistry=i;class o extends M.Disposable{get isResolved(){return this._isResolved}constructor(C,u,s){super(),this._registry=C,this._languageId=u,this._factory=s,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}resolve(){return pe(this,void 0,void 0,function*(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise})}_create(){return pe(this,void 0,void 0,function*(){const C=yield this._factory.tokenizationSupport;this._isResolved=!0,C&&!this._isDisposed&&this._register(this._registry.register(this._languageId,C))})}}}),K(ee[55],te([15,56]),function(B,n){return B.create("vs/base/common/platform",n)}),K(ee[13],te([0,1,55]),function(B,n,E){"use strict";var M;Object.defineProperty(n,"__esModule",{value:!0}),n.isAndroid=n.isEdge=n.isSafari=n.isFirefox=n.isChrome=n.isLittleEndian=n.OS=n.setTimeout0=n.setTimeout0IsFaster=n.language=n.userAgent=n.isMobile=n.isIOS=n.isWebWorker=n.isWeb=n.isNative=n.isLinux=n.isMacintosh=n.isWindows=n.globals=n.LANGUAGE_DEFAULT=void 0,n.LANGUAGE_DEFAULT="en";let i=!1,o=!1,c=!1,C=!1,u=!1,s=!1,v=!1,e=!1,d=!1,h=!1,f,w=n.LANGUAGE_DEFAULT,p=n.LANGUAGE_DEFAULT,y,m;n.globals=typeof self=="object"?self:typeof global=="object"?global:{};let N;typeof n.globals.vscode<"u"&&typeof n.globals.vscode.process<"u"?N=n.globals.vscode.process:typeof process<"u"&&(N=process);const S=typeof((M=N?.versions)===null||M===void 0?void 0:M.electron)=="string",_=S&&N?.type==="renderer";if(typeof navigator=="object"&&!_)m=navigator.userAgent,i=m.indexOf("Windows")>=0,o=m.indexOf("Macintosh")>=0,e=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,c=m.indexOf("Linux")>=0,h=m?.indexOf("Mobi")>=0,s=!0,f=E.getConfiguredDefaultLocale(E.localize(0,null))||n.LANGUAGE_DEFAULT,w=f,p=navigator.language;else if(typeof N=="object"){i=N.platform==="win32",o=N.platform==="darwin",c=N.platform==="linux",C=c&&!!N.env.SNAP&&!!N.env.SNAP_REVISION,v=S,d=!!N.env.CI||!!N.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=n.LANGUAGE_DEFAULT,w=n.LANGUAGE_DEFAULT;const g=N.env.VSCODE_NLS_CONFIG;if(g)try{const L=JSON.parse(g),A=L.availableLanguages["*"];f=L.locale,p=L.osLocale,w=A||n.LANGUAGE_DEFAULT,y=L._translationsConfigFile}catch{}u=!0}else console.error("Unable to resolve platform.");let r=0;o?r=1:i?r=3:c&&(r=2),n.isWindows=i,n.isMacintosh=o,n.isLinux=c,n.isNative=u,n.isWeb=s,n.isWebWorker=s&&typeof n.globals.importScripts=="function",n.isIOS=e,n.isMobile=h,n.userAgent=m,n.language=w,n.setTimeout0IsFaster=typeof n.globals.postMessage=="function"&&!n.globals.importScripts,n.setTimeout0=(()=>{if(n.setTimeout0IsFaster){const g=[];n.globals.addEventListener("message",A=>{if(A.data&&A.data.vscodeScheduleAsyncWork)for(let R=0,P=g.length;R<P;R++){const O=g[R];if(O.id===A.data.vscodeScheduleAsyncWork){g.splice(R,1),O.callback();return}}});let L=0;return A=>{const R=++L;g.push({id:R,callback:A}),n.globals.postMessage({vscodeScheduleAsyncWork:R},"*")}}return g=>setTimeout(g)})(),n.OS=o||e?2:i?1:3;let a=!0,l=!1;function b(){if(!l){l=!0;const g=new Uint8Array(2);g[0]=1,g[1]=2,a=new Uint16Array(g.buffer)[0]===(2<<8)+1}return a}n.isLittleEndian=b,n.isChrome=!!(n.userAgent&&n.userAgent.indexOf("Chrome")>=0),n.isFirefox=!!(n.userAgent&&n.userAgent.indexOf("Firefox")>=0),n.isSafari=!!(!n.isChrome&&n.userAgent&&n.userAgent.indexOf("Safari")>=0),n.isEdge=!!(n.userAgent&&n.userAgent.indexOf("Edg/")>=0),n.isAndroid=!!(n.userAgent&&n.userAgent.indexOf("Android")>=0)}),K(ee[57],te([0,1,13]),function(B,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.platform=n.env=n.cwd=void 0;let M;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.process<"u"){const i=E.globals.vscode.process;M={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?M={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:M={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};n.cwd=M.cwd,n.env=M.env,n.platform=M.platform}),K(ee[58],te([0,1,57]),function(B,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.sep=n.extname=n.basename=n.dirname=n.relative=n.resolve=n.normalize=n.posix=n.win32=void 0;const M=65,i=97,o=90,c=122,C=46,u=47,s=92,v=58,e=63;class d extends Error{constructor(a,l,b){let g;typeof l=="string"&&l.indexOf("not ")===0?(g="must not be",l=l.replace(/^not /,"")):g="must be";const L=a.indexOf(".")!==-1?"property":"argument";let A=`The "${a}" ${L} ${g} of type ${l}`;A+=`. Received type ${typeof b}`,super(A),this.code="ERR_INVALID_ARG_TYPE"}}function h(r,a){if(r===null||typeof r!="object")throw new d(a,"Object",r)}function f(r,a){if(typeof r!="string")throw new d(a,"string",r)}const w=E.platform==="win32";function p(r){return r===u||r===s}function y(r){return r===u}function m(r){return r>=M&&r<=o||r>=i&&r<=c}function N(r,a,l,b){let g="",L=0,A=-1,R=0,P=0;for(let O=0;O<=r.length;++O){if(O<r.length)P=r.charCodeAt(O);else{if(b(P))break;P=u}if(b(P)){if(!(A===O-1||R===1))if(R===2){if(g.length<2||L!==2||g.charCodeAt(g.length-1)!==C||g.charCodeAt(g.length-2)!==C){if(g.length>2){const V=g.lastIndexOf(l);V===-1?(g="",L=0):(g=g.slice(0,V),L=g.length-1-g.lastIndexOf(l)),A=O,R=0;continue}else if(g.length!==0){g="",L=0,A=O,R=0;continue}}a&&(g+=g.length>0?`${l}..`:"..",L=2)}else g.length>0?g+=`${l}${r.slice(A+1,O)}`:g=r.slice(A+1,O),L=O-A-1;A=O,R=0}else P===C&&R!==-1?++R:R=-1}return g}function S(r,a){h(a,"pathObject");const l=a.dir||a.root,b=a.base||`${a.name||""}${a.ext||""}`;return l?l===a.root?`${l}${b}`:`${l}${r}${b}`:b}n.win32={resolve(...r){let a="",l="",b=!1;for(let g=r.length-1;g>=-1;g--){let L;if(g>=0){if(L=r[g],f(L,"path"),L.length===0)continue}else a.length===0?L=E.cwd():(L=E.env[`=${a}`]||E.cwd(),(L===void 0||L.slice(0,2).toLowerCase()!==a.toLowerCase()&&L.charCodeAt(2)===s)&&(L=`${a}\\`));const A=L.length;let R=0,P="",O=!1;const V=L.charCodeAt(0);if(A===1)p(V)&&(R=1,O=!0);else if(p(V))if(O=!0,p(L.charCodeAt(1))){let x=2,I=x;for(;x<A&&!p(L.charCodeAt(x));)x++;if(x<A&&x!==I){const k=L.slice(I,x);for(I=x;x<A&&p(L.charCodeAt(x));)x++;if(x<A&&x!==I){for(I=x;x<A&&!p(L.charCodeAt(x));)x++;(x===A||x!==I)&&(P=`\\\\${k}\\${L.slice(I,x)}`,R=x)}}}else R=1;else m(V)&&L.charCodeAt(1)===v&&(P=L.slice(0,2),R=2,A>2&&p(L.charCodeAt(2))&&(O=!0,R=3));if(P.length>0)if(a.length>0){if(P.toLowerCase()!==a.toLowerCase())continue}else a=P;if(b){if(a.length>0)break}else if(l=`${L.slice(R)}\\${l}`,b=O,O&&a.length>0)break}return l=N(l,!b,"\\",p),b?`${a}\\${l}`:`${a}${l}`||"."},normalize(r){f(r,"path");const a=r.length;if(a===0)return".";let l=0,b,g=!1;const L=r.charCodeAt(0);if(a===1)return y(L)?"\\":r;if(p(L))if(g=!0,p(r.charCodeAt(1))){let R=2,P=R;for(;R<a&&!p(r.charCodeAt(R));)R++;if(R<a&&R!==P){const O=r.slice(P,R);for(P=R;R<a&&p(r.charCodeAt(R));)R++;if(R<a&&R!==P){for(P=R;R<a&&!p(r.charCodeAt(R));)R++;if(R===a)return`\\\\${O}\\${r.slice(P)}\\`;R!==P&&(b=`\\\\${O}\\${r.slice(P,R)}`,l=R)}}}else l=1;else m(L)&&r.charCodeAt(1)===v&&(b=r.slice(0,2),l=2,a>2&&p(r.charCodeAt(2))&&(g=!0,l=3));let A=l<a?N(r.slice(l),!g,"\\",p):"";return A.length===0&&!g&&(A="."),A.length>0&&p(r.charCodeAt(a-1))&&(A+="\\"),b===void 0?g?`\\${A}`:A:g?`${b}\\${A}`:`${b}${A}`},isAbsolute(r){f(r,"path");const a=r.length;if(a===0)return!1;const l=r.charCodeAt(0);return p(l)||a>2&&m(l)&&r.charCodeAt(1)===v&&p(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let a,l;for(let L=0;L<r.length;++L){const A=r[L];f(A,"path"),A.length>0&&(a===void 0?a=l=A:a+=`\\${A}`)}if(a===void 0)return".";let b=!0,g=0;if(typeof l=="string"&&p(l.charCodeAt(0))){++g;const L=l.length;L>1&&p(l.charCodeAt(1))&&(++g,L>2&&(p(l.charCodeAt(2))?++g:b=!1))}if(b){for(;g<a.length&&p(a.charCodeAt(g));)g++;g>=2&&(a=`\\${a.slice(g)}`)}return n.win32.normalize(a)},relative(r,a){if(f(r,"from"),f(a,"to"),r===a)return"";const l=n.win32.resolve(r),b=n.win32.resolve(a);if(l===b||(r=l.toLowerCase(),a=b.toLowerCase(),r===a))return"";let g=0;for(;g<r.length&&r.charCodeAt(g)===s;)g++;let L=r.length;for(;L-1>g&&r.charCodeAt(L-1)===s;)L--;const A=L-g;let R=0;for(;R<a.length&&a.charCodeAt(R)===s;)R++;let P=a.length;for(;P-1>R&&a.charCodeAt(P-1)===s;)P--;const O=P-R,V=A<O?A:O;let x=-1,I=0;for(;I<V;I++){const q=r.charCodeAt(g+I);if(q!==a.charCodeAt(R+I))break;q===s&&(x=I)}if(I!==V){if(x===-1)return b}else{if(O>V){if(a.charCodeAt(R+I)===s)return b.slice(R+I+1);if(I===2)return b.slice(R+I)}A>V&&(r.charCodeAt(g+I)===s?x=I:I===2&&(x=3)),x===-1&&(x=0)}let k="";for(I=g+x+1;I<=L;++I)(I===L||r.charCodeAt(I)===s)&&(k+=k.length===0?"..":"\\..");return R+=x,k.length>0?`${k}${b.slice(R,P)}`:(b.charCodeAt(R)===s&&++R,b.slice(R,P))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const a=n.win32.resolve(r);if(a.length<=2)return r;if(a.charCodeAt(0)===s){if(a.charCodeAt(1)===s){const l=a.charCodeAt(2);if(l!==e&&l!==C)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(m(a.charCodeAt(0))&&a.charCodeAt(1)===v&&a.charCodeAt(2)===s)return`\\\\?\\${a}`;return r},dirname(r){f(r,"path");const a=r.length;if(a===0)return".";let l=-1,b=0;const g=r.charCodeAt(0);if(a===1)return p(g)?r:".";if(p(g)){if(l=b=1,p(r.charCodeAt(1))){let R=2,P=R;for(;R<a&&!p(r.charCodeAt(R));)R++;if(R<a&&R!==P){for(P=R;R<a&&p(r.charCodeAt(R));)R++;if(R<a&&R!==P){for(P=R;R<a&&!p(r.charCodeAt(R));)R++;if(R===a)return r;R!==P&&(l=b=R+1)}}}}else m(g)&&r.charCodeAt(1)===v&&(l=a>2&&p(r.charCodeAt(2))?3:2,b=l);let L=-1,A=!0;for(let R=a-1;R>=b;--R)if(p(r.charCodeAt(R))){if(!A){L=R;break}}else A=!1;if(L===-1){if(l===-1)return".";L=l}return r.slice(0,L)},basename(r,a){a!==void 0&&f(a,"ext"),f(r,"path");let l=0,b=-1,g=!0,L;if(r.length>=2&&m(r.charCodeAt(0))&&r.charCodeAt(1)===v&&(l=2),a!==void 0&&a.length>0&&a.length<=r.length){if(a===r)return"";let A=a.length-1,R=-1;for(L=r.length-1;L>=l;--L){const P=r.charCodeAt(L);if(p(P)){if(!g){l=L+1;break}}else R===-1&&(g=!1,R=L+1),A>=0&&(P===a.charCodeAt(A)?--A===-1&&(b=L):(A=-1,b=R))}return l===b?b=R:b===-1&&(b=r.length),r.slice(l,b)}for(L=r.length-1;L>=l;--L)if(p(r.charCodeAt(L))){if(!g){l=L+1;break}}else b===-1&&(g=!1,b=L+1);return b===-1?"":r.slice(l,b)},extname(r){f(r,"path");let a=0,l=-1,b=0,g=-1,L=!0,A=0;r.length>=2&&r.charCodeAt(1)===v&&m(r.charCodeAt(0))&&(a=b=2);for(let R=r.length-1;R>=a;--R){const P=r.charCodeAt(R);if(p(P)){if(!L){b=R+1;break}continue}g===-1&&(L=!1,g=R+1),P===C?l===-1?l=R:A!==1&&(A=1):l!==-1&&(A=-1)}return l===-1||g===-1||A===0||A===1&&l===g-1&&l===b+1?"":r.slice(l,g)},format:S.bind(null,"\\"),parse(r){f(r,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return a;const l=r.length;let b=0,g=r.charCodeAt(0);if(l===1)return p(g)?(a.root=a.dir=r,a):(a.base=a.name=r,a);if(p(g)){if(b=1,p(r.charCodeAt(1))){let x=2,I=x;for(;x<l&&!p(r.charCodeAt(x));)x++;if(x<l&&x!==I){for(I=x;x<l&&p(r.charCodeAt(x));)x++;if(x<l&&x!==I){for(I=x;x<l&&!p(r.charCodeAt(x));)x++;x===l?b=x:x!==I&&(b=x+1)}}}}else if(m(g)&&r.charCodeAt(1)===v){if(l<=2)return a.root=a.dir=r,a;if(b=2,p(r.charCodeAt(2))){if(l===3)return a.root=a.dir=r,a;b=3}}b>0&&(a.root=r.slice(0,b));let L=-1,A=b,R=-1,P=!0,O=r.length-1,V=0;for(;O>=b;--O){if(g=r.charCodeAt(O),p(g)){if(!P){A=O+1;break}continue}R===-1&&(P=!1,R=O+1),g===C?L===-1?L=O:V!==1&&(V=1):L!==-1&&(V=-1)}return R!==-1&&(L===-1||V===0||V===1&&L===R-1&&L===A+1?a.base=a.name=r.slice(A,R):(a.name=r.slice(A,L),a.base=r.slice(A,R),a.ext=r.slice(L,R))),A>0&&A!==b?a.dir=r.slice(0,A-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const _=(()=>{if(w){const r=/\\/g;return()=>{const a=E.cwd().replace(r,"/");return a.slice(a.indexOf("/"))}}return()=>E.cwd()})();n.posix={resolve(...r){let a="",l=!1;for(let b=r.length-1;b>=-1&&!l;b--){const g=b>=0?r[b]:_();f(g,"path"),g.length!==0&&(a=`${g}/${a}`,l=g.charCodeAt(0)===u)}return a=N(a,!l,"/",y),l?`/${a}`:a.length>0?a:"."},normalize(r){if(f(r,"path"),r.length===0)return".";const a=r.charCodeAt(0)===u,l=r.charCodeAt(r.length-1)===u;return r=N(r,!a,"/",y),r.length===0?a?"/":l?"./":".":(l&&(r+="/"),a?`/${r}`:r)},isAbsolute(r){return f(r,"path"),r.length>0&&r.charCodeAt(0)===u},join(...r){if(r.length===0)return".";let a;for(let l=0;l<r.length;++l){const b=r[l];f(b,"path"),b.length>0&&(a===void 0?a=b:a+=`/${b}`)}return a===void 0?".":n.posix.normalize(a)},relative(r,a){if(f(r,"from"),f(a,"to"),r===a||(r=n.posix.resolve(r),a=n.posix.resolve(a),r===a))return"";const l=1,b=r.length,g=b-l,L=1,A=a.length-L,R=g<A?g:A;let P=-1,O=0;for(;O<R;O++){const x=r.charCodeAt(l+O);if(x!==a.charCodeAt(L+O))break;x===u&&(P=O)}if(O===R)if(A>R){if(a.charCodeAt(L+O)===u)return a.slice(L+O+1);if(O===0)return a.slice(L+O)}else g>R&&(r.charCodeAt(l+O)===u?P=O:O===0&&(P=0));let V="";for(O=l+P+1;O<=b;++O)(O===b||r.charCodeAt(O)===u)&&(V+=V.length===0?"..":"/..");return`${V}${a.slice(L+P)}`},toNamespacedPath(r){return r},dirname(r){if(f(r,"path"),r.length===0)return".";const a=r.charCodeAt(0)===u;let l=-1,b=!0;for(let g=r.length-1;g>=1;--g)if(r.charCodeAt(g)===u){if(!b){l=g;break}}else b=!1;return l===-1?a?"/":".":a&&l===1?"//":r.slice(0,l)},basename(r,a){a!==void 0&&f(a,"ext"),f(r,"path");let l=0,b=-1,g=!0,L;if(a!==void 0&&a.length>0&&a.length<=r.length){if(a===r)return"";let A=a.length-1,R=-1;for(L=r.length-1;L>=0;--L){const P=r.charCodeAt(L);if(P===u){if(!g){l=L+1;break}}else R===-1&&(g=!1,R=L+1),A>=0&&(P===a.charCodeAt(A)?--A===-1&&(b=L):(A=-1,b=R))}return l===b?b=R:b===-1&&(b=r.length),r.slice(l,b)}for(L=r.length-1;L>=0;--L)if(r.charCodeAt(L)===u){if(!g){l=L+1;break}}else b===-1&&(g=!1,b=L+1);return b===-1?"":r.slice(l,b)},extname(r){f(r,"path");let a=-1,l=0,b=-1,g=!0,L=0;for(let A=r.length-1;A>=0;--A){const R=r.charCodeAt(A);if(R===u){if(!g){l=A+1;break}continue}b===-1&&(g=!1,b=A+1),R===C?a===-1?a=A:L!==1&&(L=1):a!==-1&&(L=-1)}return a===-1||b===-1||L===0||L===1&&a===b-1&&a===l+1?"":r.slice(a,b)},format:S.bind(null,"/"),parse(r){f(r,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return a;const l=r.charCodeAt(0)===u;let b;l?(a.root="/",b=1):b=0;let g=-1,L=0,A=-1,R=!0,P=r.length-1,O=0;for(;P>=b;--P){const V=r.charCodeAt(P);if(V===u){if(!R){L=P+1;break}continue}A===-1&&(R=!1,A=P+1),V===C?g===-1?g=P:O!==1&&(O=1):g!==-1&&(O=-1)}if(A!==-1){const V=L===0&&l?1:L;g===-1||O===0||O===1&&g===A-1&&g===L+1?a.base=a.name=r.slice(V,A):(a.name=r.slice(V,g),a.base=r.slice(V,A),a.ext=r.slice(g,A))}return L>0?a.dir=r.slice(0,L-1):l&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},n.posix.win32=n.win32.win32=n.win32,n.posix.posix=n.win32.posix=n.posix,n.normalize=w?n.win32.normalize:n.posix.normalize,n.resolve=w?n.win32.resolve:n.posix.resolve,n.relative=w?n.win32.relative:n.posix.relative,n.dirname=w?n.win32.dirname:n.posix.dirname,n.basename=w?n.win32.basename:n.posix.basename,n.extname=w?n.win32.extname:n.posix.extname,n.sep=w?n.win32.sep:n.posix.sep}),K(ee[14],te([0,1,58,13]),function(B,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.uriToFsPath=n.URI=void 0;const i=/^\w[\w\d+.-]*$/,o=/^\//,c=/^\/\//;function C(l,b){if(!l.scheme&&b)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!i.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!o.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(c.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function u(l,b){return!l&&!b?"file":l}function s(l,b){switch(l){case"https":case"http":case"file":b?b[0]!==e&&(b=e+b):b=e;break}return b}const v="",e="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(b){return b instanceof h?!0:b?typeof b.authority=="string"&&typeof b.fragment=="string"&&typeof b.path=="string"&&typeof b.query=="string"&&typeof b.scheme=="string"&&typeof b.fsPath=="string"&&typeof b.with=="function"&&typeof b.toString=="function":!1}constructor(b,g,L,A,R,P=!1){typeof b=="object"?(this.scheme=b.scheme||v,this.authority=b.authority||v,this.path=b.path||v,this.query=b.query||v,this.fragment=b.fragment||v):(this.scheme=u(b,P),this.authority=g||v,this.path=s(this.scheme,L||v),this.query=A||v,this.fragment=R||v,C(this,P))}get fsPath(){return N(this,!1)}with(b){if(!b)return this;let{scheme:g,authority:L,path:A,query:R,fragment:P}=b;return g===void 0?g=this.scheme:g===null&&(g=v),L===void 0?L=this.authority:L===null&&(L=v),A===void 0?A=this.path:A===null&&(A=v),R===void 0?R=this.query:R===null&&(R=v),P===void 0?P=this.fragment:P===null&&(P=v),g===this.scheme&&L===this.authority&&A===this.path&&R===this.query&&P===this.fragment?this:new w(g,L,A,R,P)}static parse(b,g=!1){const L=d.exec(b);return L?new w(L[2]||v,a(L[4]||v),a(L[5]||v),a(L[7]||v),a(L[9]||v),g):new w(v,v,v,v,v)}static file(b){let g=v;if(M.isWindows&&(b=b.replace(/\\/g,e)),b[0]===e&&b[1]===e){const L=b.indexOf(e,2);L===-1?(g=b.substring(2),b=e):(g=b.substring(2,L),b=b.substring(L)||e)}return new w("file",g,b,v,v)}static from(b,g){return new w(b.scheme,b.authority,b.path,b.query,b.fragment,g)}static joinPath(b,...g){if(!b.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let L;return M.isWindows&&b.scheme==="file"?L=h.file(E.win32.join(N(b,!0),...g)).path:L=E.posix.join(b.path,...g),b.with({path:L})}toString(b=!1){return S(this,b)}toJSON(){return this}static revive(b){var g,L;if(b){if(b instanceof h)return b;{const A=new w(b);return A._formatted=(g=b.external)!==null&&g!==void 0?g:null,A._fsPath=b._sep===f&&(L=b.fsPath)!==null&&L!==void 0?L:null,A}}else return b}}n.URI=h;const f=M.isWindows?1:void 0;class w extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=N(this,!1)),this._fsPath}toString(b=!1){return b?S(this,!0):(this._formatted||(this._formatted=S(this,!1)),this._formatted)}toJSON(){const b={$mid:1};return this._fsPath&&(b.fsPath=this._fsPath,b._sep=f),this._formatted&&(b.external=this._formatted),this.path&&(b.path=this.path),this.scheme&&(b.scheme=this.scheme),this.authority&&(b.authority=this.authority),this.query&&(b.query=this.query),this.fragment&&(b.fragment=this.fragment),b}}const p={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function y(l,b,g){let L,A=-1;for(let R=0;R<l.length;R++){const P=l.charCodeAt(R);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||b&&P===47||g&&P===91||g&&P===93||g&&P===58)A!==-1&&(L+=encodeURIComponent(l.substring(A,R)),A=-1),L!==void 0&&(L+=l.charAt(R));else{L===void 0&&(L=l.substr(0,R));const O=p[P];O!==void 0?(A!==-1&&(L+=encodeURIComponent(l.substring(A,R)),A=-1),L+=O):A===-1&&(A=R)}}return A!==-1&&(L+=encodeURIComponent(l.substring(A))),L!==void 0?L:l}function m(l){let b;for(let g=0;g<l.length;g++){const L=l.charCodeAt(g);L===35||L===63?(b===void 0&&(b=l.substr(0,g)),b+=p[L]):b!==void 0&&(b+=l[g])}return b!==void 0?b:l}function N(l,b){let g;return l.authority&&l.path.length>1&&l.scheme==="file"?g=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===47&&(l.path.charCodeAt(1)>=65&&l.path.charCodeAt(1)<=90||l.path.charCodeAt(1)>=97&&l.path.charCodeAt(1)<=122)&&l.path.charCodeAt(2)===58?b?g=l.path.substr(1):g=l.path[1].toLowerCase()+l.path.substr(2):g=l.path,M.isWindows&&(g=g.replace(/\//g,"\\")),g}n.uriToFsPath=N;function S(l,b){const g=b?m:y;let L="",{scheme:A,authority:R,path:P,query:O,fragment:V}=l;if(A&&(L+=A,L+=":"),(R||A==="file")&&(L+=e,L+=e),R){let x=R.indexOf("@");if(x!==-1){const I=R.substr(0,x);R=R.substr(x+1),x=I.lastIndexOf(":"),x===-1?L+=g(I,!1,!1):(L+=g(I.substr(0,x),!1,!1),L+=":",L+=g(I.substr(x+1),!1,!0)),L+="@"}R=R.toLowerCase(),x=R.lastIndexOf(":"),x===-1?L+=g(R,!1,!0):(L+=g(R.substr(0,x),!1,!0),L+=R.substr(x))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const x=P.charCodeAt(1);x>=65&&x<=90&&(P=`/${String.fromCharCode(x+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const x=P.charCodeAt(0);x>=65&&x<=90&&(P=`${String.fromCharCode(x+32)}:${P.substr(2)}`)}L+=g(P,!0,!1)}return O&&(L+="?",L+=g(O,!1,!1)),V&&(L+="#",L+=b?V:y(V,!1,!1)),L}function _(l){try{return decodeURIComponent(l)}catch{return l.length>3?l.substr(0,3)+_(l.substr(3)):l}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(l){return l.match(r)?l.replace(r,b=>_(b)):l}}),K(ee[62],te([0,1,4,7,10,11,13,5]),function(B,n,E,M,i,o,c,C){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.SimpleWorkerServer=n.SimpleWorkerClient=n.logOnceWebWorkerWarning=void 0;const u="$initialize";let s=!1;function v(a){c.isWeb&&(s||(s=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(a.message))}n.logOnceWebWorkerWarning=v;class e{constructor(l,b,g,L){this.vsWorker=l,this.req=b,this.method=g,this.args=L,this.type=0}}class d{constructor(l,b,g,L){this.vsWorker=l,this.seq=b,this.res=g,this.err=L,this.type=1}}class h{constructor(l,b,g,L){this.vsWorker=l,this.req=b,this.eventName=g,this.arg=L,this.type=2}}class f{constructor(l,b,g){this.vsWorker=l,this.req=b,this.event=g,this.type=3}}class w{constructor(l,b){this.vsWorker=l,this.req=b,this.type=4}}class p{constructor(l){this._workerId=-1,this._handler=l,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(l){this._workerId=l}sendMessage(l,b){const g=String(++this._lastSentReq);return new Promise((L,A)=>{this._pendingReplies[g]={resolve:L,reject:A},this._send(new e(this._workerId,g,l,b))})}listen(l,b){let g=null;const L=new M.Emitter({onWillAddFirstListener:()=>{g=String(++this._lastSentReq),this._pendingEmitters.set(g,L),this._send(new h(this._workerId,g,l,b))},onDidRemoveLastListener:()=>{this._pendingEmitters.delete(g),this._send(new w(this._workerId,g)),g=null}});return L.event}handleMessage(l){!l||!l.vsWorker||this._workerId!==-1&&l.vsWorker!==this._workerId||this._handleMessage(l)}_handleMessage(l){switch(l.type){case 1:return this._handleReplyMessage(l);case 0:return this._handleRequestMessage(l);case 2:return this._handleSubscribeEventMessage(l);case 3:return this._handleEventMessage(l);case 4:return this._handleUnsubscribeEventMessage(l)}}_handleReplyMessage(l){if(!this._pendingReplies[l.seq]){console.warn("Got reply to unknown seq");return}const b=this._pendingReplies[l.seq];if(delete this._pendingReplies[l.seq],l.err){let g=l.err;l.err.$isError&&(g=new Error,g.name=l.err.name,g.message=l.err.message,g.stack=l.err.stack),b.reject(g);return}b.resolve(l.res)}_handleRequestMessage(l){const b=l.req;this._handler.handleMessage(l.method,l.args).then(L=>{this._send(new d(this._workerId,b,L,void 0))},L=>{L.detail instanceof Error&&(L.detail=(0,E.transformErrorForSerialization)(L.detail)),this._send(new d(this._workerId,b,void 0,(0,E.transformErrorForSerialization)(L)))})}_handleSubscribeEventMessage(l){const b=l.req,g=this._handler.handleEvent(l.eventName,l.arg)(L=>{this._send(new f(this._workerId,b,L))});this._pendingEvents.set(b,g)}_handleEventMessage(l){if(!this._pendingEmitters.has(l.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(l.req).fire(l.event)}_handleUnsubscribeEventMessage(l){if(!this._pendingEvents.has(l.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(l.req).dispose(),this._pendingEvents.delete(l.req)}_send(l){const b=[];if(l.type===0)for(let g=0;g<l.args.length;g++)l.args[g]instanceof ArrayBuffer&&b.push(l.args[g]);else l.type===1&&l.res instanceof ArrayBuffer&&b.push(l.res);this._handler.sendMessage(l,b)}}class y extends i.Disposable{constructor(l,b,g){super();let L=null;this._worker=this._register(l.create("vs/base/common/worker/simpleWorker",x=>{this._protocol.handleMessage(x)},x=>{L?.(x)})),this._protocol=new p({sendMessage:(x,I)=>{this._worker.postMessage(x,I)},handleMessage:(x,I)=>{if(typeof g[x]!="function")return Promise.reject(new Error("Missing method "+x+" on main thread host."));try{return Promise.resolve(g[x].apply(g,I))}catch(k){return Promise.reject(k)}},handleEvent:(x,I)=>{if(N(x)){const k=g[x].call(g,I);if(typeof k!="function")throw new Error(`Missing dynamic event ${x} on main thread host.`);return k}if(m(x)){const k=g[x];if(typeof k!="function")throw new Error(`Missing event ${x} on main thread host.`);return k}throw new Error(`Malformed event name ${x}`)}}),this._protocol.setWorkerId(this._worker.getId());let A=null;const R=globalThis.require;typeof R<"u"&&typeof R.getConfig=="function"?A=R.getConfig():typeof globalThis.requirejs<"u"&&(A=globalThis.requirejs.s.contexts._.config);const P=(0,o.getAllMethodNames)(g);this._onModuleLoaded=this._protocol.sendMessage(u,[this._worker.getId(),JSON.parse(JSON.stringify(A)),b,P]);const O=(x,I)=>this._request(x,I),V=(x,I)=>this._protocol.listen(x,I);this._lazyProxy=new Promise((x,I)=>{L=I,this._onModuleLoaded.then(k=>{x(S(k,O,V))},k=>{I(k),this._onError("Worker failed to load "+b,k)})})}getProxyObject(){return this._lazyProxy}_request(l,b){return new Promise((g,L)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(l,b).then(g,L)},L)})}_onError(l,b){console.error(l),console.info(b)}}n.SimpleWorkerClient=y;function m(a){return a[0]==="o"&&a[1]==="n"&&C.isUpperAsciiLetter(a.charCodeAt(2))}function N(a){return/^onDynamic/.test(a)&&C.isUpperAsciiLetter(a.charCodeAt(9))}function S(a,l,b){const g=R=>function(){const P=Array.prototype.slice.call(arguments,0);return l(R,P)},L=R=>function(P){return b(R,P)},A={};for(const R of a){if(N(R)){A[R]=L(R);continue}if(m(R)){A[R]=b(R,void 0);continue}A[R]=g(R)}return A}class _{constructor(l,b){this._requestHandlerFactory=b,this._requestHandler=null,this._protocol=new p({sendMessage:(g,L)=>{l(g,L)},handleMessage:(g,L)=>this._handleMessage(g,L),handleEvent:(g,L)=>this._handleEvent(g,L)})}onmessage(l){this._protocol.handleMessage(l)}_handleMessage(l,b){if(l===u)return this.initialize(b[0],b[1],b[2],b[3]);if(!this._requestHandler||typeof this._requestHandler[l]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+l));try{return Promise.resolve(this._requestHandler[l].apply(this._requestHandler,b))}catch(g){return Promise.reject(g)}}_handleEvent(l,b){if(!this._requestHandler)throw new Error("Missing requestHandler");if(N(l)){const g=this._requestHandler[l].call(this._requestHandler,b);if(typeof g!="function")throw new Error(`Missing dynamic event ${l} on request handler.`);return g}if(m(l)){const g=this._requestHandler[l];if(typeof g!="function")throw new Error(`Missing event ${l} on request handler.`);return g}throw new Error(`Malformed event name ${l}`)}initialize(l,b,g,L){this._protocol.setWorkerId(l);const P=S(L,(O,V)=>this._protocol.sendMessage(O,V),(O,V)=>this._protocol.listen(O,V));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(P),Promise.resolve((0,o.getAllMethodNames)(this._requestHandler))):(b&&(typeof b.baseUrl<"u"&&delete b.baseUrl,typeof b.paths<"u"&&typeof b.paths.vs<"u"&&delete b.paths.vs,typeof b.trustedTypesPolicy!==void 0&&delete b.trustedTypesPolicy,b.catchError=!0,globalThis.require.config(b)),new Promise((O,V)=>{(globalThis.require||B)([g],I=>{if(this._requestHandler=I.create(P),!this._requestHandler){V(new Error("No RequestHandler!"));return}O((0,o.getAllMethodNames)(this._requestHandler))},V)}))}}n.SimpleWorkerServer=_;function r(a){return new _(a,null)}n.create=r}),K(ee[59],te([15,56]),function(B,n){return B.create("vs/editor/common/languages",n)}),K(ee[60],te([0,1,35,14,2,54,59]),function(B,n,E,M,i,o,c){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=n.LazyTokenizationSupport=n.InlayHintKind=n.Command=n.FoldingRangeKind=n.TextEdit=n.SymbolKinds=n.getAriaLabelForSymbol=n.symbolKindNames=n.isLocationLink=n.DocumentHighlightKind=n.SignatureHelpTriggerKind=n.SelectedSuggestionInfo=n.InlineCompletionTriggerKind=n.CompletionItemKinds=n.EncodedTokenizationResult=n.TokenizationResult=n.Token=void 0;class C{constructor(l,b,g){this.offset=l,this.type=b,this.language=g,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}n.Token=C;class u{constructor(l,b){this.tokens=l,this.endState=b,this._tokenizationResultBrand=void 0}}n.TokenizationResult=u;class s{constructor(l,b){this.tokens=l,this.endState=b,this._encodedTokenizationResultBrand=void 0}}n.EncodedTokenizationResult=s;var v;(function(a){const l=new Map;l.set(0,E.Codicon.symbolMethod),l.set(1,E.Codicon.symbolFunction),l.set(2,E.Codicon.symbolConstructor),l.set(3,E.Codicon.symbolField),l.set(4,E.Codicon.symbolVariable),l.set(5,E.Codicon.symbolClass),l.set(6,E.Codicon.symbolStruct),l.set(7,E.Codicon.symbolInterface),l.set(8,E.Codicon.symbolModule),l.set(9,E.Codicon.symbolProperty),l.set(10,E.Codicon.symbolEvent),l.set(11,E.Codicon.symbolOperator),l.set(12,E.Codicon.symbolUnit),l.set(13,E.Codicon.symbolValue),l.set(15,E.Codicon.symbolEnum),l.set(14,E.Codicon.symbolConstant),l.set(15,E.Codicon.symbolEnum),l.set(16,E.Codicon.symbolEnumMember),l.set(17,E.Codicon.symbolKeyword),l.set(27,E.Codicon.symbolSnippet),l.set(18,E.Codicon.symbolText),l.set(19,E.Codicon.symbolColor),l.set(20,E.Codicon.symbolFile),l.set(21,E.Codicon.symbolReference),l.set(22,E.Codicon.symbolCustomColor),l.set(23,E.Codicon.symbolFolder),l.set(24,E.Codicon.symbolTypeParameter),l.set(25,E.Codicon.account),l.set(26,E.Codicon.issues);function b(A){let R=l.get(A);return R||(console.info("No codicon found for CompletionItemKind "+A),R=E.Codicon.symbolProperty),R}a.toIcon=b;const g=new Map;g.set("method",0),g.set("function",1),g.set("constructor",2),g.set("field",3),g.set("variable",4),g.set("class",5),g.set("struct",6),g.set("interface",7),g.set("module",8),g.set("property",9),g.set("event",10),g.set("operator",11),g.set("unit",12),g.set("value",13),g.set("constant",14),g.set("enum",15),g.set("enum-member",16),g.set("enumMember",16),g.set("keyword",17),g.set("snippet",27),g.set("text",18),g.set("color",19),g.set("file",20),g.set("reference",21),g.set("customcolor",22),g.set("folder",23),g.set("type-parameter",24),g.set("typeParameter",24),g.set("account",25),g.set("issue",26);function L(A,R){let P=g.get(A);return typeof P>"u"&&!R&&(P=9),P}a.fromString=L})(v||(n.CompletionItemKinds=v={}));var e;(function(a){a[a.Automatic=0]="Automatic",a[a.Explicit=1]="Explicit"})(e||(n.InlineCompletionTriggerKind=e={}));class d{constructor(l,b,g,L){this.range=l,this.text=b,this.completionKind=g,this.isSnippetText=L}equals(l){return i.Range.lift(this.range).equalsRange(l.range)&&this.text===l.text&&this.completionKind===l.completionKind&&this.isSnippetText===l.isSnippetText}}n.SelectedSuggestionInfo=d;var h;(function(a){a[a.Invoke=1]="Invoke",a[a.TriggerCharacter=2]="TriggerCharacter",a[a.ContentChange=3]="ContentChange"})(h||(n.SignatureHelpTriggerKind=h={}));var f;(function(a){a[a.Text=0]="Text",a[a.Read=1]="Read",a[a.Write=2]="Write"})(f||(n.DocumentHighlightKind=f={}));function w(a){return a&&M.URI.isUri(a.uri)&&i.Range.isIRange(a.range)&&(i.Range.isIRange(a.originSelectionRange)||i.Range.isIRange(a.targetSelectionRange))}n.isLocationLink=w,n.symbolKindNames={[17]:(0,c.localize)(0,null),[16]:(0,c.localize)(1,null),[4]:(0,c.localize)(2,null),[13]:(0,c.localize)(3,null),[8]:(0,c.localize)(4,null),[9]:(0,c.localize)(5,null),[21]:(0,c.localize)(6,null),[23]:(0,c.localize)(7,null),[7]:(0,c.localize)(8,null),[0]:(0,c.localize)(9,null),[11]:(0,c.localize)(10,null),[10]:(0,c.localize)(11,null),[19]:(0,c.localize)(12,null),[5]:(0,c.localize)(13,null),[1]:(0,c.localize)(14,null),[2]:(0,c.localize)(15,null),[20]:(0,c.localize)(16,null),[15]:(0,c.localize)(17,null),[18]:(0,c.localize)(18,null),[24]:(0,c.localize)(19,null),[3]:(0,c.localize)(20,null),[6]:(0,c.localize)(21,null),[14]:(0,c.localize)(22,null),[22]:(0,c.localize)(23,null),[25]:(0,c.localize)(24,null),[12]:(0,c.localize)(25,null)};function p(a,l){return(0,c.localize)(26,null,a,n.symbolKindNames[l])}n.getAriaLabelForSymbol=p;var y;(function(a){const l=new Map;l.set(0,E.Codicon.symbolFile),l.set(1,E.Codicon.symbolModule),l.set(2,E.Codicon.symbolNamespace),l.set(3,E.Codicon.symbolPackage),l.set(4,E.Codicon.symbolClass),l.set(5,E.Codicon.symbolMethod),l.set(6,E.Codicon.symbolProperty),l.set(7,E.Codicon.symbolField),l.set(8,E.Codicon.symbolConstructor),l.set(9,E.Codicon.symbolEnum),l.set(10,E.Codicon.symbolInterface),l.set(11,E.Codicon.symbolFunction),l.set(12,E.Codicon.symbolVariable),l.set(13,E.Codicon.symbolConstant),l.set(14,E.Codicon.symbolString),l.set(15,E.Codicon.symbolNumber),l.set(16,E.Codicon.symbolBoolean),l.set(17,E.Codicon.symbolArray),l.set(18,E.Codicon.symbolObject),l.set(19,E.Codicon.symbolKey),l.set(20,E.Codicon.symbolNull),l.set(21,E.Codicon.symbolEnumMember),l.set(22,E.Codicon.symbolStruct),l.set(23,E.Codicon.symbolEvent),l.set(24,E.Codicon.symbolOperator),l.set(25,E.Codicon.symbolTypeParameter);function b(g){let L=l.get(g);return L||(console.info("No codicon found for SymbolKind "+g),L=E.Codicon.symbolProperty),L}a.toIcon=b})(y||(n.SymbolKinds=y={}));class m{}n.TextEdit=m;class N{static fromValue(l){switch(l){case"comment":return N.Comment;case"imports":return N.Imports;case"region":return N.Region}return new N(l)}constructor(l){this.value=l}}n.FoldingRangeKind=N,N.Comment=new N("comment"),N.Imports=new N("imports"),N.Region=new N("region");var S;(function(a){function l(b){return!b||typeof b!="object"?!1:typeof b.id=="string"&&typeof b.title=="string"}a.is=l})(S||(n.Command=S={}));var _;(function(a){a[a.Type=1]="Type",a[a.Parameter=2]="Parameter"})(_||(n.InlayHintKind=_={}));class r{constructor(l){this.createSupport=l,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(l=>{l&&l.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}n.LazyTokenizationSupport=r,n.TokenizationRegistry=new o.TokenizationRegistry}),K(ee[61],te([0,1,33,7,31,14,3,2,36,60,53]),function(B,n,E,M,i,o,c,C,u,s,v){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createMonacoBaseAPI=n.KeyMod=void 0;class e{static chord(f,w){return(0,i.KeyChord)(f,w)}}n.KeyMod=e,e.CtrlCmd=2048,e.Shift=1024,e.Alt=512,e.WinCtrl=256;function d(){return{editor:void 0,languages:void 0,CancellationTokenSource:E.CancellationTokenSource,Emitter:M.Emitter,KeyCode:v.KeyCode,KeyMod:e,Position:c.Position,Range:C.Range,Selection:u.Selection,SelectionDirection:v.SelectionDirection,MarkerSeverity:v.MarkerSeverity,MarkerTag:v.MarkerTag,Uri:o.URI,Token:s.Token}}n.createMonacoBaseAPI=d}),K(ee[63],te([0,1,21,14,3,2,50,25,46,47,61,20,52,44,11,45]),function(B,n,E,M,i,o,c,C,u,s,v,e,d,h,f,w){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.EditorSimpleWorker=void 0;class p extends c.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}findMatches(S){const _=[];for(let r=0;r<this._lines.length;r++){const a=this._lines[r],l=this.offsetAt(new i.Position(r+1,1)),b=a.matchAll(S);for(const g of b)(g.index||g.index===0)&&(g.index=g.index+l),_.push(g)}return _}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(S){return this._lines[S-1]}getWordAtPosition(S,_){const r=(0,C.getWordAtText)(S.column,(0,C.ensureValidWordDefinition)(_),this._lines[S.lineNumber-1],0);return r?new o.Range(S.lineNumber,r.startColumn,S.lineNumber,r.endColumn):null}words(S){const _=this._lines,r=this._wordenize.bind(this);let a=0,l="",b=0,g=[];return{*[Symbol.iterator](){for(;;)if(b<g.length){const L=l.substring(g[b].start,g[b].end);b+=1,yield L}else if(a<_.length)l=_[a],g=r(l,S),b=0,a+=1;else break}}}getLineWords(S,_){const r=this._lines[S-1],a=this._wordenize(r,_),l=[];for(const b of a)l.push({word:r.substring(b.start,b.end),startColumn:b.start+1,endColumn:b.end+1});return l}_wordenize(S,_){const r=[];let a;for(_.lastIndex=0;(a=_.exec(S))&&a[0].length!==0;)r.push({start:a.index,end:a.index+a[0].length});return r}getValueInRange(S){if(S=this._validateRange(S),S.startLineNumber===S.endLineNumber)return this._lines[S.startLineNumber-1].substring(S.startColumn-1,S.endColumn-1);const _=this._eol,r=S.startLineNumber-1,a=S.endLineNumber-1,l=[];l.push(this._lines[r].substring(S.startColumn-1));for(let b=r+1;b<a;b++)l.push(this._lines[b]);return l.push(this._lines[a].substring(0,S.endColumn-1)),l.join(_)}offsetAt(S){return S=this._validatePosition(S),this._ensureLineStarts(),this._lineStarts.getPrefixSum(S.lineNumber-2)+(S.column-1)}positionAt(S){S=Math.floor(S),S=Math.max(0,S),this._ensureLineStarts();const _=this._lineStarts.getIndexOf(S),r=this._lines[_.index].length;return{lineNumber:1+_.index,column:1+Math.min(_.remainder,r)}}_validateRange(S){const _=this._validatePosition({lineNumber:S.startLineNumber,column:S.startColumn}),r=this._validatePosition({lineNumber:S.endLineNumber,column:S.endColumn});return _.lineNumber!==S.startLineNumber||_.column!==S.startColumn||r.lineNumber!==S.endLineNumber||r.column!==S.endColumn?{startLineNumber:_.lineNumber,startColumn:_.column,endLineNumber:r.lineNumber,endColumn:r.column}:S}_validatePosition(S){if(!i.Position.isIPosition(S))throw new Error("bad position");let{lineNumber:_,column:r}=S,a=!1;if(_<1)_=1,r=1,a=!0;else if(_>this._lines.length)_=this._lines.length,r=this._lines[_-1].length+1,a=!0;else{const l=this._lines[_-1].length+1;r<1?(r=1,a=!0):r>l&&(r=l,a=!0)}return a?{lineNumber:_,column:r}:S}}class y{constructor(S,_){this._host=S,this._models=Object.create(null),this._foreignModuleFactory=_,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(S){return this._models[S]}_getModels(){const S=[];return Object.keys(this._models).forEach(_=>S.push(this._models[_])),S}acceptNewModel(S){this._models[S.url]=new p(M.URI.parse(S.url),S.lines,S.EOL,S.versionId)}acceptModelChanged(S,_){if(!this._models[S])return;this._models[S].onEvents(_)}acceptRemovedModel(S){this._models[S]&&delete this._models[S]}computeUnicodeHighlights(S,_,r){return pe(this,void 0,void 0,function*(){const a=this._getModel(S);return a?d.UnicodeTextModelHighlighter.computeUnicodeHighlights(a,_,r):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}})}computeDiff(S,_,r,a){return pe(this,void 0,void 0,function*(){const l=this._getModel(S),b=this._getModel(_);return!l||!b?null:y.computeDiff(l,b,r,a)})}static computeDiff(S,_,r,a){const l=a==="advanced"?h.linesDiffComputers.getAdvanced():h.linesDiffComputers.getLegacy(),b=S.getLinesContent(),g=_.getLinesContent(),L=l.computeDiff(b,g,r),A=L.changes.length>0?!1:this._modelsAreIdentical(S,_);function R(P){return P.map(O=>{var V;return[O.originalRange.startLineNumber,O.originalRange.endLineNumberExclusive,O.modifiedRange.startLineNumber,O.modifiedRange.endLineNumberExclusive,(V=O.innerChanges)===null||V===void 0?void 0:V.map(x=>[x.originalRange.startLineNumber,x.originalRange.startColumn,x.originalRange.endLineNumber,x.originalRange.endColumn,x.modifiedRange.startLineNumber,x.modifiedRange.startColumn,x.modifiedRange.endLineNumber,x.modifiedRange.endColumn])]})}return{identical:A,quitEarly:L.hitTimeout,changes:R(L.changes),moves:L.moves.map(P=>[P.lineRangeMapping.original.startLineNumber,P.lineRangeMapping.original.endLineNumberExclusive,P.lineRangeMapping.modified.startLineNumber,P.lineRangeMapping.modified.endLineNumberExclusive,R(P.changes)])}}static _modelsAreIdentical(S,_){const r=S.getLineCount(),a=_.getLineCount();if(r!==a)return!1;for(let l=1;l<=r;l++){const b=S.getLineContent(l),g=_.getLineContent(l);if(b!==g)return!1}return!0}computeMoreMinimalEdits(S,_,r){return pe(this,void 0,void 0,function*(){const a=this._getModel(S);if(!a)return _;const l=[];let b;_=_.slice(0).sort((g,L)=>{if(g.range&&L.range)return o.Range.compareRangesUsingStarts(g.range,L.range);const A=g.range?0:1,R=L.range?0:1;return A-R});for(let{range:g,text:L,eol:A}of _){if(typeof A=="number"&&(b=A),o.Range.isEmpty(g)&&!L)continue;const R=a.getValueInRange(g);if(L=L.replace(/\r\n|\n|\r/g,a.eol),R===L)continue;if(Math.max(L.length,R.length)>y._diffLimit){l.push({range:g,text:L});continue}const P=(0,E.stringDiff)(R,L,r),O=a.offsetAt(o.Range.lift(g).getStartPosition());for(const V of P){const x=a.positionAt(O+V.originalStart),I=a.positionAt(O+V.originalStart+V.originalLength),k={text:L.substr(V.modifiedStart,V.modifiedLength),range:{startLineNumber:x.lineNumber,startColumn:x.column,endLineNumber:I.lineNumber,endColumn:I.column}};a.getValueInRange(k.range)!==k.text&&l.push(k)}}return typeof b=="number"&&l.push({eol:b,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),l})}computeLinks(S){return pe(this,void 0,void 0,function*(){const _=this._getModel(S);return _?(0,u.computeLinks)(_):null})}computeDefaultDocumentColors(S){return pe(this,void 0,void 0,function*(){const _=this._getModel(S);return _?(0,w.computeDefaultDocumentColors)(_):null})}textualSuggest(S,_,r,a){return pe(this,void 0,void 0,function*(){const l=new e.StopWatch,b=new RegExp(r,a),g=new Set;e:for(const L of S){const A=this._getModel(L);if(A){for(const R of A.words(b))if(!(R===_||!isNaN(Number(R)))&&(g.add(R),g.size>y._suggestionsLimit))break e}}return{words:Array.from(g),duration:l.elapsed()}})}computeWordRanges(S,_,r,a){return pe(this,void 0,void 0,function*(){const l=this._getModel(S);if(!l)return Object.create(null);const b=new RegExp(r,a),g=Object.create(null);for(let L=_.startLineNumber;L<_.endLineNumber;L++){const A=l.getLineWords(L,b);for(const R of A){if(!isNaN(Number(R.word)))continue;let P=g[R.word];P||(P=[],g[R.word]=P),P.push({startLineNumber:L,startColumn:R.startColumn,endLineNumber:L,endColumn:R.endColumn})}}return g})}navigateValueSet(S,_,r,a,l){return pe(this,void 0,void 0,function*(){const b=this._getModel(S);if(!b)return null;const g=new RegExp(a,l);_.startColumn===_.endColumn&&(_={startLineNumber:_.startLineNumber,startColumn:_.startColumn,endLineNumber:_.endLineNumber,endColumn:_.endColumn+1});const L=b.getValueInRange(_),A=b.getWordAtPosition({lineNumber:_.startLineNumber,column:_.startColumn},g);if(!A)return null;const R=b.getValueInRange(A);return s.BasicInplaceReplace.INSTANCE.navigateValueSet(_,L,A,R,r)})}loadForeignModule(S,_,r){const a=(g,L)=>this._host.fhr(g,L),b={host:(0,f.createProxyObject)(r,a),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(b,_),Promise.resolve((0,f.getAllMethodNames)(this._foreignModule))):new Promise((g,L)=>{B([S],A=>{this._foreignModule=A.create(b,_),g((0,f.getAllMethodNames)(this._foreignModule))},L)})}fmr(S,_){if(!this._foreignModule||typeof this._foreignModule[S]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+S));try{return Promise.resolve(this._foreignModule[S].apply(this._foreignModule,_))}catch(r){return Promise.reject(r)}}}n.EditorSimpleWorker=y,y._diffLimit=1e5,y._suggestionsLimit=1e4;function m(N){return new y(N,null)}n.create=m,typeof importScripts=="function"&&(globalThis.monaco=(0,v.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=../../../../min-maps/vs/base/worker/workerMain.js.map